on *:LOAD:{
  echo Thanks for downloading AnyCard.  I hope you enjoy it and get creative with it.
  echo ...type /startgame to begin...  
}

alias startgame {

  var %ScriptVersion 1

  var %tmp0, %tmp1, %tmp2
  var %Game = AnyCard
  var %MircVs = 6.32
  var %nfiles = gameicons.png tableshadow.png tchars.png discard.wav knock.wav newuser.wav shuffle.wav takecard.wav userdc.wav
  var %nfilescrc = F3EE0A38 30E047AD 0C94D9F0 50AF4AE0 D7AD6452 DADFC80C 3719446E EBAFE8CF 6D59F3E7
  var %DistroSite = blablabla.com
  var %DefaultConfig = defaulttable.png'defaultdeck.cfg'defaultdeck.png'1'dalnet'#aborted'127.0.0.1'8959'null'null'null'8959'null'1  
  if (%GameAlreadyLoaded) {
    echo %Game does not support multiple instances per instance of mIRC.  If you wish to load the script twice or more, load it within additional instances of mIRC.    
    return
  }
  if ($os isnum 95 - 98) || ($os == ME) || ($os == NT) {
    echo It is suggested you run this script on a recent system with a recent OS installed(at least XP).
    return
  }
  if ($version < %MircVs) && ($1 != ignorever) {
    echo It is suggested you run mIRC version %MircVs or greater to ensure compatibility with this script.  If you feel it may work fine anyway, you can start the script
    with the parameter 'ignorever', but the results may be unpredictable.  Keep in mind that some compatibility issues may not be immediatly obvious.
    echo /startgame ignorever
    return
  }  
  %tmp0 = 1
  while (%tmp0 <= $numtok(%nfiles,32)) {
    %tmp1 =  $+(anycard/,$gettok(%nfiles,%tmp0,32))
    if (!$exists($+($mircdir,%tmp1))) {
      echo Could not find $gettok(%nfiles,%tmp0,32) , this is a necessary file for %Game 's operation.  It may be that you haven't extracted %Game to the proper $&
        directory. All files should be extracted to a sub-directory called 'anycard' within mIRC's settings directory.  If you're unsure which directory is your mIRC $&
        settings directory, according to this instance of mIRC, it's located here:
      echo $mircdir
      return
    } 
    elseif ($crc($+($mircdir,%tmp1),2) != $gettok(%nfilescrc,%tmp0,32)) && ($1 != ignorecrc) {
      echo It appears that the version of $gettok(%nfiles,%tmp0,32) on your disk is not the original version of this file.  To ensure that %Game runs properly, $&
        please download the latest version of %Game from %DistroSite and replace all files.  If you feel this message is in error, or you wish to use custom replacements $&
        and are certain that the PNG bitmaps are properly sized, then restart the script, using the parameter 'ignorecrc', like so:
      echo /startgame ignorecrc
      return
    }
    inc %tmp0
  }
  %tmp0 = 1
  %tmp1 = 0
  while (%tmp0 <= $numtok(%DefaultConfig,39)) {
    if ($gettok(%DefaultConfig,%tmp0,39) == null) {
      inc %tmp1 2
    }
    else {
      inc %tmp1 $calc($len($gettok(%DefaultConfig,%tmp0,39)) + 2)
    }
    inc %tmp0
  }
  inc %tmp1 50
  if (!$exists($+($mircdir,anycard/anycard.con))) {
    echo No config file found.
    echo Creating default config.
    if ($disk($mircdir).free < %tmp1) {
      echo There's inadequate space on your disk to create a new config file for %Game .
      return
    }
    .fopen -o configFS "anycard/anycard.con"
    if ($ferr > 0) {
      echo %Game was unable to properly create a default config file.
      return
    }
    %tmp0 = 1
    while (%tmp0 <= $numtok(%DefaultConfig,39)) {
      if ($gettok(%DefaultConfig,%tmp0,39) == null) {
        .fwrite configFS $crlf
        if ($ferr > 0) {
          echo %Game was unable to properly create a default config file.
          .fclose configFS
          return
        }
      }
      else {
        .fwrite -n configFS $gettok(%DefaultConfig,%tmp0,39)
        if ($ferr > 0) {
          echo %Game was unable to properly create a default config file.
          .fclose configFS
          return
        }        
      }
      inc %tmp0
    }
    .fclose configFS
    echo Config file successfully created.  Please do NOT manually edit your main config file, as this may produce undesireable results.
  }
  .fopen menuconfigFS "anycard/anycard.con"
  if ($ferr > 0) {
    echo %Game was unable to properly load your config file.  If you delete this file, the script will automatically create a new default config file, but any settings $&
      you may have saved will be lost.
    return
  }
  %tmp2 = $null
  %tmp0 = 1
  while (%tmp0 <= $numtok(%DefaultConfig,39)) {
    %tmp1 = $fread(menuconfigFS)
    if (%tmp1 = $null) {      
      %tmp2 = $instok(%tmp2,null,%tmp0,39)
    }
    else {
      %tmp2 = $instok(%tmp2,%tmp1,%tmp0,39)
    }
    if ($ferr > 0) {
      echo %Game was unable to properly load your config file.  If you delete this file, the script will automatically create a new default config file, but any settings $&
        you may have saved will be lost.
      .fclose menuconfigFS
      return
    }
    if ($feof) && (%tmp0 < $numtok(DefaultConfig,39)) {
      echo Your config file was too short.  If you delete this file, the script will automatically create a new default config file, but any settings $&
        you may have saved will be lost.
      .fclose menuconfigFS
      return
    }
    inc %tmp0
  }
  .fclose menuconfigFS
  set %GameAlreadyLoaded $true
  set %VersionNumber %ScriptVersion
  set %DistroURL %DistroSite 
  set %ConfigFileOptions $numtok(%DefaultConfig,39)
  window -k0m @AnyCardStatus 0 0 800 200 Fixedsys 9 iconfile anycard/anycard.ico
  echo -t @anyCardStatus 7,1Ifwhat7,1thison7,1sentenceearth7,1makesis7,1sensethis?7,1... then you may need to adjust MiRC's color scheme so that "normal text" $&
    contrasts better with your background color.  If you're not sure what this message is for, then please ignore this.
  echo -t @AnyCardStatus ---
  echo -t @AnyCardStatus Welcome to AnyCard v %VersionNumber by moot of DALnet 2008.
  echo -t @AnyCardStatus ---
  echo -t @AnyCardStatus Please pay attention to this window for important game related messages.  Closing this window is not recommended, as mIRC will likely route these $&
    messages to your server window. Conversely, keeping this window open assures that your other mIRC windows are free from unnecessary clutter via this script.
  set %MenuConfig %tmp2
  %tmp0 = 1
  while (%tmp0 <= 12) {
    %MenuConfig = $instok(%MenuConfig,null,$calc($numtok(%tmp2,39) + %tmp0),39)
    %MenuConfig = $puttok(%MenuConfig,$editcheck(%tmp0),$calc($numtok(%tmp2,39) + %tmp0),39)
    inc %tmp0
  }
  set %gamemode 1
  set %AnimateCursor $false
  set %CursorInfo 0 0 0
  set %Editing $false
  set %EditID
  set %EditBuffer
  set %LoadingTable
  set %tcharx 0 0 0 0 0 0 0
  set %tchary 0 0 0 0 0 0 0
  set %tcharz 0 0 0 0 0 0 0
  set %tcharl -93 -53 -21 27 32 67 97
  set %tchara 0
  set %tcharsx 0 0 0 0 0 0 0
  set %tcharsy 0 0 0 0 0 0 0
  set %tcharzs 1 2 3 4 5 6 7
  set %deg2rad $calc(3.14159265 / 180)
  window -pfhB +d @Tchars 0 0 560 140
  drawpic @Tchars 0 0 "anycard/tchars.png"
  window -pfhB +d @GameIcons 0 0 840 220
  drawpic @GameIcons 0 0 "anycard/gameicons.png"
  window -pfhB +d @MenuBuffer 0 0 700 700
  drawrect -rf @MenuBuffer $rgb(0,0,0) 0 0 0 700 700
  drawtext @MenuBuffer 0 Arial 15 80 180 Table Image
  drawtext @MenuBuffer 0 Arial 15 80 230 Card Deck Config
  drawtext @MenuBuffer 0 Arial 15 80 280 Card Deck Image
  drawtext @MenuBuffer 0 Arial 15 80 363 Advertise Server?
  drawtext @MenuBuffer 0 Arial 15 80 390 Network
  drawtext @MenuBuffer 0 Arial 15 80 440 Channel
  drawtext @MenuBuffer 0 Arial 15 80 490 Server IP
  drawtext @MenuBuffer 0 Arial 15 80 540 Port
  drawtext @MenuBuffer 0 Arial 15 380 183 Join Game?
  drawcopy -t @GameIcons $rgb(164,64,64) 660 160 25 25 @MenuBuffer 595 180
  drawtext @MenuBuffer 0 Arial 15 380 210 Server IP
  drawtext @MenuBuffer 0 Arial 15 380 260 Port
  drawtext @MenuBuffer 0 Arial 15 380 310 Password
  drawtext @MenuBuffer 0 Arial 15 380 393 Start Game?
  drawcopy -t @GameIcons $rgb(164,64,64) 660 160 25 25 @MenuBuffer 595 390
  drawtext @MenuBuffer 0 Arial 15 380 420 Port
  drawtext @MenuBuffer 0 Arial 15 380 470 Password
  drawtext @MenuBuffer 0 Arial 15 380 550 Player
  drawrect -rf @MenuBuffer $rgb(2,255,1) 0 382 572 21 21
  drawrect -rf @MenuBuffer $rgb(248,254,36) 0 442 572 21 21
  drawrect -rf @MenuBuffer $rgb(49,205,253) 0 502 572 21 21
  drawrect -rf @MenuBuffer $rgb(254,22,81) 0 562 572 21 21
  drawtext @MenuBuffer 0 Arial 15 225 650 AnyCard v %VersionNumber by moot of DALnet 2008.
  window -pfhB +d @TcharBuffer 0 0 258 154
  animatetchars
  drawcopy @TcharBuffer 0 0 258 154 @MenuBuffer 223 22
  window -aBCdfk0p +bnt @AnyCard 0 0 700 700 iconfile anycard/anycard.ico
  drawmenu 15
  .timeracanimate -om 0 20 acanimator
}

alias -l acmainclose {
  var %tmp0, %tmp1, %tmp2, %tmp3
  sockclose ac*
  .fclose *FS
  .hfree -sw *HT
  .timeracanimate off
  .timeraccycle off
  .timeracserverad off
  window -c @GrabBuffer
  window -c @ActionsBuffer
  window -c @HandAngle1
  window -c @HandAngle2
  window -c @HandAngle3
  window -c @HandAngle4
  window -c @TableBuffer
  window -c @TableShadow
  window -c @DetectCard
  window -c @MouseBuffer
  window -c @Cards
  window -c @Cards90
  window -c @Cards180
  window -c @Cards270
  window -c @AnyCard
  window -c @TcharBuffer
  window -c @MenuBuffer
  window -c @GameIcons
  window -c @Tchars
  window -c @CardTable
  window -c @DrawBuffer
  window -c @AnyCard
  window -c @AnyCardStatus
  %tmp2 = %ConfigFileOptions
  %tmp3 = %MenuConfig
  unsetall
  %tmp0 = 1
  %tmp1 = 0
  while (%tmp0 <= %tmp2) {
    if ($gettok(%tmp3,%tmp0,39) == null) {
      inc %tmp1 2
    }
    else {
      inc %tmp1 $calc($len($gettok(%tmp3,%tmp0,39)) + 2)
    }
    inc %tmp0
  }
  if ($disk($mircdir).free < %tmp1) {
    echo There's inadequate space on your disk to save your AnyCard config file.
    return
  }
  .fopen -o configFS "anycard/anycard.con"
  if ($ferr > 0) {
    echo AnyCard was unable to properly save your config file.
    return
  }
  %tmp0 = 1
  while (%tmp0 <= %tmp2) {
    if ($gettok(%tmp3,%tmp0,39) == null) {
      .fwrite configFS $crlf
      if ($ferr > 0) {
        echo AnyCard was unable to properly save your config file.
        .fclose configFS
        return
      }
    }
    else {
      .fwrite -n configFS $gettok(%tmp3,%tmp0,39)
      if ($ferr > 0) {
        echo AnyCard was unable to properly save your config file.
        .fclose configFS
        return
      }        
    }
    inc %tmp0
  }
  .fclose configFS
  echo Config file successfully saved.  Please do NOT manually edit your main config file, as this may produce undesireable results.
}

alias -l acanimator {
  animatetchars
  drawcopy @TcharBuffer 0 0 258 154 @AnyCard 223 22
  if (%AnimateCursor) {
    drawline @AnyCard $gettok(%CursorInfo,1,32) 3 $gettok(%CursorInfo,2,32) $gettok(%CursorInfo,3,32) $calc($gettok(%CursorInfo,2,32) + 7) $gettok(%CursorInfo,3,32)
    %CursorInfo = $puttok(%CursorInfo,$xor($gettok(%CursorInfo,1,32),1),1,32)
  }
}

alias -l animatetchars {
  var %tmp2, %tmp3, %tmp4
  drawrect -rf @TcharBuffer $rgb(0,0,0) 0 0 0 258 154
  %tmp3 = 1
  while (%tmp3 <= 7) {
    %tcharz = $puttok(%tcharz,$int($calc($gettok(%tcharl,%tmp3,32) * $sin($calc(%tchara * %deg2rad)))),%tmp3,32)
    %tcharsx = $puttok(%tcharsx,$calc(80 + $int($calc($gettok(%tcharz,%tmp3,32) * 0.24))),%tmp3,32)
    %tcharsy = $puttok(%tcharsy,$calc(140 + $int($calc($gettok(%tcharz,%tmp3,32) * 0.42))),%tmp3,32)
    %tcharx = $puttok(%tcharx,$int($calc((($gettok(%tcharl,%tmp3,32) * $cos($calc(%tchara * %deg2rad))) + 129) - ($gettok(%tcharsx,%tmp3,32) / 2))),%tmp3,32)
    %tchary = $puttok(%tchary,$calc(77 - ($gettok(%tcharsy,%tmp3,32) / 2)),%tmp3,32)
    if ($gettok(%tcharsx,%tmp3,32) < 0) {
      %tcharsx = $puttok(%tcharsx,0,%tmp3,32)
    }
    if ($gettok(%tcharsy,%tmp3,32) < 0) {
      %tcharsy = $puttok(%tcharsy,0,%tmp3,32)
    }
    inc %tmp3
  }
  if ($gettok(%tcharz,1,32) >= 0) {
    %tcharzs = 7 6 5 4 3 2 1
  }
  elseif ($gettok(%tcharz,1,32) < 0) {
    %tcharzs = 1 2 3 4 5 6 7
  }
  %tmp4 = 1
  while (%tmp4 <= 7) {    
    %tmp3 = $gettok(%tcharzs,%tmp4,32)
    drawcopy -mt @Tchars $rgb(164,64,64) $calc((%tmp3 - 1) * 80) 0 80 140 @TcharBuffer $&
      $gettok(%tcharx,%tmp3,32) $gettok(%tchary,%tmp3,32) $gettok(%tcharsx,%tmp3,32) $gettok(%tcharsy,%tmp3,32)
    inc %tmp4
  }
  if (%tchara > 0) {
    dec %tchara
  }
  else {
    %tchara = 360
  }
}

alias -l drawmenu {
  if ($1 == 1) || ($1 == 15) {
    drawrect -rf @MenuBuffer $rgb(255,255,255) 0 82 202 206 21
    if ($gettok(%MenuConfig,1,39) != null) {
      drawtext @MenuBuffer 1 Arial 15 84 204 $gettok(%MenuConfig,1,39)
    }
    if ($gettok(%MenuConfig,15,39)) {
      drawcopy -t @GameIcons $rgb(164,64,64) 810 190 25 25 @MenuBuffer 295 200
    }
    else {
      drawcopy -t @GameIcons $rgb(164,64,64) 620 190 25 25 @MenuBuffer 295 200
    }
    if ($1 == 1) {
      drawcopy @MenuBuffer 82 202 234 21 @AnyCard 82 202
    }
  }
  if ($1 == 2) || ($1 == 15) {
    drawrect -rf @MenuBuffer $rgb(255,255,255) 0 82 252 206 21
    if ($gettok(%MenuConfig,2,39) != null) {
      drawtext @MenuBuffer 1 Arial 15 84 254 $gettok(%MenuConfig,2,39)
    }
    if ($gettok(%MenuConfig,16,39)) {
      drawcopy -t @GameIcons $rgb(164,64,64) 810 190 25 25 @MenuBuffer 295 250
    }
    else {
      drawcopy -t @GameIcons $rgb(164,64,64) 620 190 25 25 @MenuBuffer 295 250
    }
    if ($1 == 2) {
      drawcopy @MenuBuffer 82 252 234 21 @AnyCard 82 252
    }
  }
  if ($1 == 3) || ($1 == 15) {
    drawrect -rf @MenuBuffer $rgb(255,255,255) 0 82 302 206 21
    if ($gettok(%MenuConfig,3,39) != null) {
      drawtext @MenuBuffer 1 Arial 15 84 304 $gettok(%MenuConfig,3,39)
    }
    if ($gettok(%MenuConfig,17,39)) {
      drawcopy -t @GameIcons $rgb(164,64,64) 810 190 25 25 @MenuBuffer 295 300
    }
    else {
      drawcopy -t @GameIcons $rgb(164,64,64) 620 190 25 25 @MenuBuffer 295 300
    }
    if ($1 == 3) {
      drawcopy @MenuBuffer 82 302 234 21 @AnyCard 82 302
    }
  }
  if ($1 == 4) || ($1 == 15) {
    drawrect -rf @MenuBuffer $rgb(255,255,255) 0 82 412 206 21
    if ($gettok(%MenuConfig,5,39) != null) {
      drawtext @MenuBuffer 1 Arial 15 84 414 $gettok(%MenuConfig,5,39)
    }
    if ($gettok(%MenuConfig,18,39)) {
      drawcopy -t @GameIcons $rgb(164,64,64) 810 190 25 25 @MenuBuffer 295 410
    }
    else {
      drawcopy -t @GameIcons $rgb(164,64,64) 620 190 25 25 @MenuBuffer 295 410
    }
    if ($1 == 4) {
      drawcopy @MenuBuffer 82 412 234 21 @AnyCard 82 412
    }
  }
  if ($1 == 5) || ($1 == 15) {
    drawrect -rf @MenuBuffer $rgb(255,255,255) 0 82 462 206 21
    if ($gettok(%MenuConfig,6,39) != null) {
      drawtext @MenuBuffer 1 Arial 15 84 464 $gettok(%MenuConfig,6,39)
    }
    if ($gettok(%MenuConfig,19,39)) {
      drawcopy -t @GameIcons $rgb(164,64,64) 810 190 25 25 @MenuBuffer 295 460
    }
    else {
      drawcopy -t @GameIcons $rgb(164,64,64) 620 190 25 25 @MenuBuffer 295 460
    }
    if ($1 == 5) {
      drawcopy @MenuBuffer 82 462 234 21 @AnyCard 82 462
    }
  }
  if ($1 == 6) || ($1 == 15) {
    drawrect -rf @MenuBuffer $rgb(255,255,255) 0 82 512 206 21
    if ($gettok(%MenuConfig,7,39) != null) {
      drawtext @MenuBuffer 1 Arial 15 84 514 $gettok(%MenuConfig,7,39)
    }
    if ($gettok(%MenuConfig,20,39)) {
      drawcopy -t @GameIcons $rgb(164,64,64) 810 190 25 25 @MenuBuffer 295 510  
    }
    else {
      drawcopy -t @GameIcons $rgb(164,64,64) 620 190 25 25 @MenuBuffer 295 510  
    }
    if ($1 == 6) {
      drawcopy @MenuBuffer 82 512 234 21 @AnyCard 82 512
    }
  }
  if ($1 == 7) || ($1 == 15) {
    drawrect -rf @MenuBuffer $rgb(255,255,255) 0 82 562 101 21
    if ($gettok(%MenuConfig,8,39) != null) {
      drawtext @MenuBuffer 1 Arial 15 84 564 $gettok(%MenuConfig,8,39)
    }
    if ($gettok(%MenuConfig,21,39)) {
      drawcopy -t @GameIcons $rgb(164,64,64) 810 190 25 25 @MenuBuffer 295 560  
    }
    else {
      drawcopy -t @GameIcons $rgb(164,64,64) 620 190 25 25 @MenuBuffer 295 560  
    }
    if ($1 == 7) {
      drawcopy @MenuBuffer 82 562 234 21 @AnyCard 82 562
    }
  }
  if ($1 == 8) || ($1 == 15) {
    drawrect -rf @MenuBuffer $rgb(255,255,255) 0 382 232 206 21
    if ($gettok(%MenuConfig,9,39) != null) {
      drawtext @MenuBuffer 1 Arial 15 384 234 $gettok(%MenuConfig,9,39)
    }
    if ($gettok(%MenuConfig,22,39)) {
      drawcopy -t @GameIcons $rgb(164,64,64) 810 190 25 25 @MenuBuffer 595 230
    }
    else {
      drawcopy -t @GameIcons $rgb(164,64,64) 620 190 25 25 @MenuBuffer 595 230
    }
    if ($1 == 8) {
      drawcopy @MenuBuffer 382 232 234 21 @AnyCard 382 232
    }
  }
  if ($1 == 9) || ($1 == 15) {
    drawrect -rf @MenuBuffer $rgb(255,255,255) 0 382 282 101 21
    if ($gettok(%MenuConfig,10,39) != null) {
      drawtext @MenuBuffer 1 Arial 15 384 284 $gettok(%MenuConfig,10,39)
    }
    if ($gettok(%MenuConfig,23,39)) {
      drawcopy -t @GameIcons $rgb(164,64,64) 810 190 25 25 @MenuBuffer 595 280
    }
    else {
      drawcopy -t @GameIcons $rgb(164,64,64) 620 190 25 25 @MenuBuffer 595 280
    }
    if ($1 == 9) {
      drawcopy @MenuBuffer 382 282 234 21 @AnyCard 382 282
    }
  }
  if ($1 == 10) || ($1 == 15) {
    drawrect -rf @MenuBuffer $rgb(255,255,255) 0 382 332 206 21
    if ($gettok(%MenuConfig,11,39) != null) {
      drawtext @MenuBuffer 1 Arial 15 384 334 $gettok(%MenuConfig,11,39)
    }
    if ($gettok(%MenuConfig,24,39)) {
      drawcopy -t @GameIcons $rgb(164,64,64) 810 190 25 25 @MenuBuffer 595 330
    }
    else {
      drawcopy -t @GameIcons $rgb(164,64,64) 620 190 25 25 @MenuBuffer 595 330
    }
    if ($1 == 10) {
      drawcopy @MenuBuffer 382 332 234 21 @AnyCard 382 332
    }
  }
  if ($1 == 11) || ($1 == 15) {
    drawrect -rf @MenuBuffer $rgb(255,255,255) 0 382 442 101 21
    if ($gettok(%MenuConfig,12,39) != null) {
      drawtext @MenuBuffer 1 Arial 15 384 444 $gettok(%MenuConfig,12,39)
    }
    if ($gettok(%MenuConfig,25,39)) {
      drawcopy -t @GameIcons $rgb(164,64,64) 810 190 25 25 @MenuBuffer 595 440
    }
    else {
      drawcopy -t @GameIcons $rgb(164,64,64) 620 190 25 25 @MenuBuffer 595 440
    }
    if ($1 == 11) {
      drawcopy @MenuBuffer 382 442 234 21 @AnyCard 382 442
    }
  }
  if ($1 == 12) || ($1 == 15) {
    drawrect -rf @MenuBuffer $rgb(255,255,255) 0 382 492 206 21
    if ($gettok(%MenuConfig,13,39) != null) {
      drawtext @MenuBuffer 1 Arial 15 384 494 $gettok(%MenuConfig,13,39)
    }
    if ($gettok(%MenuConfig,26,39)) {
      drawcopy -t @GameIcons $rgb(164,64,64) 810 190 25 25 @MenuBuffer 595 490
    }
    else {
      drawcopy -t @GameIcons $rgb(164,64,64) 620 190 25 25 @MenuBuffer 595 490
    }
    if ($1 == 12) {
      drawcopy @MenuBuffer 382 492 234 21 @AnyCard 382 492
    }
  }
  if ($1 == 13) || ($1 == 15) {
    if ($gettok(%MenuConfig,4,39) == 0) {
      drawcopy -t @GameIcons $rgb(164,64,64) 620 190 25 25 @MenuBuffer 295 360
    }
    else {
      drawcopy -t @GameIcons $rgb(164,64,64) 810 190 25 25 @MenuBuffer 295 360
    }    
    if ($1 == 13) {
      drawcopy @MenuBuffer 295 360 25 25 @AnyCard 295 360
    }
  }
  if ($1 == 14) || ($1 == 15) {
    if ($gettok(%MenuConfig,14,39) == 1) {
      drawcopy -t @GameIcons $rgb(164,64,64) 810 190 25 25 @MenuBuffer 410 570
    }
    else {
      drawcopy -t @GameIcons $rgb(164,64,64) 620 190 25 25 @MenuBuffer 410 570
    }
    if ($gettok(%MenuConfig,14,39) == 2) {
      drawcopy -t @GameIcons $rgb(164,64,64) 810 190 25 25 @MenuBuffer 470 570
    }
    else {
      drawcopy -t @GameIcons $rgb(164,64,64) 620 190 25 25 @MenuBuffer 470 570
    }
    if ($gettok(%MenuConfig,14,39) == 3) {
      drawcopy -t @GameIcons $rgb(164,64,64) 810 190 25 25 @MenuBuffer 530 570
    }
    else {
      drawcopy -t @GameIcons $rgb(164,64,64) 620 190 25 25 @MenuBuffer 530 570
    }
    if ($gettok(%MenuConfig,14,39) == 4) {
      drawcopy -t @GameIcons $rgb(164,64,64) 810 190 25 25 @MenuBuffer 590 570  
    }
    else {
      drawcopy -t @GameIcons $rgb(164,64,64) 620 190 25 25 @MenuBuffer 590 570  
    }
    if ($1 == 14) {
      drawcopy @MenuBuffer 410 570 205 25 @AnyCard 410 570
    }
  }
  if ($1 == 15) {
    drawcopy @MenuBuffer 80 180 540 490 @AnyCard 80 180
  }
}

alias -l editinfo {
  var %tmpdata, %tmp0
  if ($1 == 1) {
    %tmpdata = 1 15 1 82 202 206
  }
  elseif ($1 == 2) {
    %tmpdata = 2 16 2 82 252 206
  }
  elseif ($1 == 3) {
    %tmpdata = 3 17 3 82 302 206
  }
  elseif ($1 == 4) {
    %tmpdata = 5 18 4 82 412 206
  }
  elseif ($1 == 5) {
    %tmpdata = 6 19 5 82 462 206
  }
  elseif ($1 == 6) {
    %tmpdata = 7 20 6 82 512 206
  }
  elseif ($1 == 7) {
    %tmpdata = 8 21 7 82 562 101
  }
  elseif ($1 == 8) {
    %tmpdata = 9 22 8 382 232 206
  }
  elseif ($1 == 9) {
    %tmpdata = 10 23 9 382 282 101
  }
  elseif ($1 == 10) {
    %tmpdata = 11 24 10 382 332 206
  }
  elseif ($1 == 11) {
    %tmpdata = 12 25 11 382 442 101
  }
  elseif ($1 == 12) {
    %tmpdata = 13 26 12 382 492 206
  }
  if ($2 == start) {
    %Editing = $true
    %EditID = $1
    %AnimateCursor = $true
    if ($gettok(%MenuConfig,$gettok(%tmpdata,1,32),39) == null) {
      %tmp0 = 0
      %EditBuffer = $null
    }
    else {
      %tmp0 = $width($gettok(%MenuConfig,$gettok(%tmpdata,1,32),39),Arial,15)
      %EditBuffer = $gettok(%MenuConfig,$gettok(%tmpdata,1,32),39)
    }
    %CursorInfo = $puttok(%CursorInfo,$calc(%tmp0 + $gettok(%tmpdata,4,32) + 2),2,32)
    %CursorInfo = $puttok(%CursorInfo,$calc($gettok(%tmpdata,5,32) + 18),3,32)
    return
  }
  elseif ($2 == finish) {
    %Editing = $false
    %AnimateCursor = $false
    if (%EditBuffer == $null) {
      %MenuConfig = $puttok(%MenuConfig,null,$gettok(%tmpdata,1,32),39)
    }
    else {
      %MenuConfig = $puttok(%MenuConfig,%EditBuffer,$gettok(%tmpdata,1,32),39)
    }
    %tmp0 = $editcheck($gettok(%tmpdata,3,32))
    %MenuConfig = $puttok(%MenuConfig,%tmp0,$gettok(%tmpdata,2,32),39)
    if (!%tmp0) {
      %MenuConfig = $puttok(%MenuConfig,null,$gettok(%tmpdata,1,32),39)      
    }
    drawmenu $gettok(%tmpdata,3,32)
    return
  }
  elseif ($2 == backspace) {
    if (%EditBuffer != $null) {
      %EditBuffer = $left(%EditBuffer,$calc($len(%EditBuffer) - 1))
    }
    else {
      return
    }
  }
  else {
    if ($width(%EditBuffer,Arial,15) >= $calc($gettok(%tmpdata,6,32) - 21)) {
      return
    }
    %EditBuffer = $+(%EditBuffer,$2)
  }
  drawrect -rf @MenuBuffer $rgb(255,255,255) 0 $gettok(%tmpdata,4,32) $gettok(%tmpdata,5,32) $gettok(%tmpdata,6,32) 21
  if (%EditBuffer != $null) {
    drawtext @MenuBuffer 1 Arial 15 $calc($gettok(%tmpdata,4,32) + 2) $calc($gettok(%tmpdata,5,32) + 2) %EditBuffer
  }
  drawcopy @MenuBuffer $gettok(%tmpdata,4,32) $gettok(%tmpdata,5,32) $gettok(%tmpdata,6,32) 21 @AnyCard $gettok(%tmpdata,4,32) $gettok(%tmpdata,5,32)
  %CursorInfo = $puttok(%CursorInfo,$calc($width(%EditBuffer,Arial,15) + $gettok(%tmpdata,4,32) + 2),2,32)
}

alias -l editcheck {
  var %tmp0, %tmp1, %tmp2, %tmp3, %tmp4, %tmp5
  if ($1 == 1) {
    %tmp0 = $gettok(%MenuConfig,1,39)
    if (%tmp0 == null) {
      return $false
    }
    if (%tmp0 == $chr(35)) {
      echo -t @AnyCardStatus (Table Image) Single hash marks can interfere with the operation of mIRC's interpreter without redundant error checking.  I've chosen $&
        to disallow this.
      return $false
    }
    if ($len(%tmp0) < 4) {
      echo -t @AnyCardStatus (Table Image) This file name is too short to be a proper bitmap.
      return $false
    }
    if ($right(%tmp0,4) != .png) && ($right(%tmp0,4) != .bmp) {
      echo -t @AnyCardStatus (Table Image) This file extension is invalid.  Please use BMP or PNG files for mIRC compatibility and maximum image quality.
      return $false
    }
    if (!$exists($+($mircdir,$+(anycard/,%tmp0)))) {
      echo -t @AnyCardStatus (Table Image) AnyCard cannot find this file.  If the file name was entered correctly, it may be that the file wasn't placed in the main $&
        anycard directory.  According to this instance of mIRC, this directory can be found here:
      echo -t @AnyCardStatus $+($mircdir,anycard\)
      return $false
    }
    if ($pic($+(anycard/,%tmp0)).height != 700) || ($pic($+(anycard/,%tmp0)).width != 700) {
      echo -t @AnyCardStatus (Table Image) Bitmaps used for the table image must be exactly 700 x 700.
      return $false
    }
    return $true
  }
  elseif ($1 == 2) {
    %tmp0 = $gettok(%MenuConfig,2,39)
    if (%tmp0 == null) {
      return $false
    }
    if (%tmp0 == $chr(35)) {
      echo -t @AnyCardStatus (Card Deck Config) Single hash marks can interfere with the operation of mIRC's interpreter without redundant error checking.  I've chosen $&
        to disallow this.
      return $false
    }    
    if ($len(%tmp0) < 4) {
      echo -t @AnyCardStatus (Card Deck Config) This file name is too short to be a proper config.
      return $false
    }
    if ($right(%tmp0,4) != .cfg) {
      echo -t @AnyCardStatus (Card Deck Config) This file extension is invalid.  Please use the CFG extension for uniformity with card deck config files.
      return $false
    }
    if (!$exists($+($mircdir,$+(anycard/,%tmp0)))) {
      echo -t @AnyCardStatus (Card Deck Config) AnyCard cannot find this file.  If the file name was entered correctly, it may be that the file wasn't placed in the main $&
        anycard directory.  According to this instance of mIRC, this directory can be found here:
      echo -t @AnyCardStatus $+($mircdir,anycard\)
      return $false
    }
    .fopen testcfgFS $+(anycard/,%tmp0)
    if ($ferr > 0) {
      echo -t @AnyCardStatus (Card Deck Config) Could not properly open config file.
      return $false
    }
    %tmp0 = $fread(testcfgFS)
    if ($ferr) {
      echo -t @AnyCardStatus (Card Deck Config) Could not properly read from the config file. 
      .fclose testcfgFS
      return $false
    }
    elseif ($feof) {
      echo -t @AnyCardStatus (Card Deck Config) Config file ended prematurely.
      .fclose testcfgFS
      return $false
    }
    %tmp0 = $fread(testcfgFS)
    if ($ferr) {
      echo -t @AnyCardStatus (Card Deck Config) Could not properly read from the config file. 
      .fclose testcfgFS
      return $false
    }
    elseif ($feof) {
      echo -t @AnyCardStatus (Card Deck Config) Config file ended prematurely.
      .fclose testcfgFS
      return $false
    }
    if (%tmp0 !isnum 1 - 120) || (. isin %tmp0) {
      echo -t @AnyCardStatus (Card Deck Config) There is an invalid entry for the number of cards in this deck config.  The acceptable range is 1 to 120.
      .fclose testcfgFS
      return $false
    }
    %tmp5 = %tmp0
    %tmp1 = 1
    while (%tmp1 <= %tmp0) {
      %tmp2 = $fread(testcfgFS)
      if ($ferr) {
        echo -t @AnyCardStatus (Card Deck Config) Could not properly read from the config file. 
        .fclose testcfgFS
        return $false
      }
      elseif ($feof) {
        echo -t @AnyCardStatus (Card Deck Config) Config file ended prematurely.
        .fclose testcfgFS
        return $false
      }
      if (%tmp2 != %tmp1) {
        echo -t @AnyCardStatus (Card Deck Config) There is an invalid entry in the card ID number for card %tmp1 .
        .fclose testcfgFS
        return $false
      }
      %tmp2 = $fread(testcfgFS)
      if ($ferr) {
        echo -t @AnyCardStatus (Card Deck Config) Could not properly read from the config file. 
        .fclose testcfgFS
        return $false
      }
      elseif ($feof) {
        echo -t @AnyCardStatus (Card Deck Config) Config file ended prematurely.
        .fclose testcfgFS
        return $false
      }
      %tmp2 = $fread(testcfgFS)
      if ($ferr) {
        echo -t @AnyCardStatus (Card Deck Config) Could not properly read from the config file. 
        .fclose testcfgFS
        return $false
      }
      elseif ($feof) {
        echo -t @AnyCardStatus (Card Deck Config) Config file ended prematurely.
        .fclose testcfgFS
        return $false
      }
      if (%tmp2 !isnum 0 - 119) || (. isin %tmp2) {
        echo -t @AnyCardStatus (Card Deck Config) There is an invalid entry in the card-back image ID number for card %tmp1 .  Acceptable range is 0 to 119.
        .fclose testcfgFS
        return $false
      }
      %tmp2 = $fread(testcfgFS)
      if ($ferr) {
        echo -t @AnyCardStatus (Card Deck Config) Could not properly read from the config file. 
        .fclose testcfgFS
        return $false
      }
      elseif ($feof) {
        echo -t @AnyCardStatus (Card Deck Config) Config file ended prematurely.
        .fclose testcfgFS
        return $false
      }
      if (%tmp2 !isnum 0 - 119) || (. isin %tmp2) {
        echo -t @AnyCardStatus (Card Deck Config) There is an invalid entry in the card-front image ID number for card %tmp1 .  Acceptable range is 0 to 119.
        .fclose testcfgFS
        return $false
      }
      %tmp2 = $fread(testcfgFS)
      if ($ferr) {
        echo -t @AnyCardStatus (Card Deck Config) Could not properly read from the config file. 
        .fclose testcfgFS
        return $false
      }
      elseif ($feof) {
        echo -t @AnyCardStatus (Card Deck Config) Config file ended prematurely.
        .fclose testcfgFS
        return $false
      }
      if (%tmp2 != 1) {
        echo -t @AnyCardStatus (Card Deck Config) There is an invalid entry in the card type ID for card %tmp1 .  This value is reserved for future use, please set to 1.
        .fclose testcfgFS
        return $false
      }
      inc %tmp1
    }
    %tmp0 = $fread(testcfgFS)
    if ($ferr) {
      echo -t @AnyCardStatus (Card Deck Config) Could not properly read from the config file. 
      .fclose testcfgFS
      return $false
    }
    elseif ($feof) {
      echo -t @AnyCardStatus (Card Deck Config) Config file ended prematurely.
      .fclose testcfgFS
      return $false
    }
    if (%tmp0 !isnum 1 - 120) || (. isin %tmp0) {
      echo -t @AnyCardStatus (Card Deck Config) There is an invalid entry for the number of stacks in this deck config.  The acceptable range is 1 to 120.
      .fclose testcfgFS
      return $false
    }
    %tmp4 = 0
    %tmp1 = 1
    while (%tmp1 <= %tmp0) {
      %tmp2 = $fread(testcfgFS)
      if ($ferr) {
        echo -t @AnyCardStatus (Card Deck Config) Could not properly read from the config file. 
        .fclose testcfgFS
        return $false
      }
      elseif ($feof) {
        echo -t @AnyCardStatus (Card Deck Config) Config file ended prematurely.
        .fclose testcfgFS
        return $false
      }
      if (%tmp2 != %tmp1) {
        echo -t @AnyCardStatus (Card Deck Config) There is an invalid entry in the stack ID number for stack %tmp1 .
        .fclose testcfgFS
        return $false
      }
      %tmp2 = $fread(testcfgFS)
      if ($ferr) {
        echo -t @AnyCardStatus (Card Deck Config) Could not properly read from the config file. 
        .fclose testcfgFS
        return $false
      }
      elseif ($feof) {
        echo -t @AnyCardStatus (Card Deck Config) Config file ended prematurely.
        .fclose testcfgFS
        return $false
      }
      if (%tmp2 != $calc(%tmp4 + 1)) {
        echo -t @AnyCardStatus (Card Deck Config) There is an invalid entry in the starting ID number for stack %tmp1 .  It should be $calc(%tmp4 + 1) .
        .fclose testcfgFS
        return $false
      }      
      %tmp3 = $fread(testcfgFS)
      if ($ferr) {
        echo -t @AnyCardStatus (Card Deck Config) Could not properly read from the config file. 
        .fclose testcfgFS
        return $false
      }
      elseif ($feof) {
        echo -t @AnyCardStatus (Card Deck Config) Config file ended prematurely.
        .fclose testcfgFS
        return $false
      }
      if (%tmp3 < %tmp2) || (%tmp3 > %tmp5) || (. isin %tmp3) {
        echo -t @AnyCardStatus (Card Deck Config) There is an invalid entry in the ending ID number for stack %tmp1 .  It should be at least $&
          %tmp2 and less than $calc(%tmp5 + 1) .
        .fclose testcfgFS
        return $false
      }
      %tmp4 = $calc((%tmp3 - %tmp2) + 1 + %tmp4)
      %tmp2 = $fread(testcfgFS)
      if ($ferr) {
        echo -t @AnyCardStatus (Card Deck Config) Could not properly read from the config file. 
        .fclose testcfgFS
        return $false
      }
      elseif ($feof) {
        echo -t @AnyCardStatus (Card Deck Config) Config file ended prematurely.
        .fclose testcfgFS
        return $false
      }
      if (%tmp2 !isnum 65 - 635) || (. isin %tmp2) {
        echo -t @AnyCardStatus (Card Deck Config) There is an invalid entry in the X coordinate for stack %tmp1 .  Acceptable range is 65 - 635.
        .fclose testcfgFS
        return $false
      }
      %tmp2 = $fread(testcfgFS)
      if ($ferr) {
        echo -t @AnyCardStatus (Card Deck Config) Could not properly read from the config file. 
        .fclose testcfgFS
        return $false
      }
      elseif ($feof) {
        echo -t @AnyCardStatus (Card Deck Config) Config file ended prematurely.
        .fclose testcfgFS
        return $false
      }
      if (%tmp2 !isnum 65 - 635) || (. isin %tmp2) {
        echo -t @AnyCardStatus (Card Deck Config) There is an invalid entry in the Y coordinate for stack %tmp1 .  Acceptable range is 65 - 635.
        .fclose testcfgFS
        return $false
      }
      %tmp2 = $fread(testcfgFS)
      if ($ferr) {
        echo -t @AnyCardStatus (Card Deck Config) Could not properly read from the config file. 
        .fclose testcfgFS
        return $false
      }
      elseif ($feof) {
        echo -t @AnyCardStatus (Card Deck Config) Config file ended prematurely.
        .fclose testcfgFS
        return $false
      }
      if (%tmp2 !isnum 0 - 1) || (. isin %tmp2) {
        echo -t @AnyCardStatus (Card Deck Config) There is an invalid entry in the card flip flag for stack %tmp1 .  It should be either 0(face up) or 1(face down).
        .fclose testcfgFS
        return $false
      }
      %tmp2 = $fread(testcfgFS)
      if ($ferr) {
        echo -t @AnyCardStatus (Card Deck Config) Could not properly read from the config file. 
        .fclose testcfgFS
        return $false
      }
      elseif ($feof) && (%tmp4 < %tmp5) {
        echo -t @AnyCardStatus (Card Deck Config) Config file ended prematurely.
        .fclose testcfgFS
        return $false
      }
      if (%tmp2 !isnum 1 - 4) || (. isin %tmp2) {
        echo -t @AnyCardStatus (Card Deck Config) There is an invalid entry in the card angle for stack %tmp1 .  Acceptable range is 1 to 4.
        .fclose testcfgFS
        return $false
      }
      inc %tmp1
    }
    .fclose testcfgFS
    return $true
  }
  if ($1 == 3) {
    %tmp0 = $gettok(%MenuConfig,3,39)
    if (%tmp0 == null) {
      return $false
    }
    if (%tmp0 == $chr(35)) {
      echo -t @AnyCardStatus (Card Deck Image) Single hash marks can interfere with the operation of mIRC's interpreter without redundant error checking.  I've chosen $&
        to disallow this.
      return $false
    }
    if ($len(%tmp0) < 4) {
      echo -t @AnyCardStatus (Card Deck Image) This file name is too short to be a proper bitmap.
      return $false
    }
    if ($right(%tmp0,4) != .png) && ($right(%tmp0,4) != .bmp) {
      echo -t @AnyCardStatus (Card Deck Image) This file extension is invalid.  Please use BMP or PNG files for mIRC compatibility and maximum image quality.
      return $false
    }
    if (!$exists($+($mircdir,$+(anycard/,%tmp0)))) {
      echo -t @AnyCardStatus (Card Deck Image) AnyCard cannot find this file.  If the file name was entered correctly, it may be that the file wasn't placed in the main $&
        anycard directory.  According to this instance of mIRC, this directory can be found here:
      echo -t @AnyCardStatus $+($mircdir,anycard\)
      return $false
    }
    if ($pic($+(anycard/,%tmp0)).height != 800) || ($pic($+(anycard/,%tmp0)).width != 720) {
      echo -t @AnyCardStatus (Card Deck Image) Bitmaps used for the card deck image must be exactly 720 x 800.
      return $false
    }
    return $true
  }
  if ($1 == 4) {
    %tmp0 = $gettok(%MenuConfig,5,39)
    if (%tmp0 == null) {
      return $false
    }
    if (%tmp0 == $chr(35)) {
      echo -t @AnyCardStatus (Advertised Server name) Single hash marks can interfere with the operation of mIRC's interpreter without redundant error checking.  I've $&
        chosen to disallow this.
      return $false
    }
    return $true
  }
  if ($1 == 5) {
    %tmp0 = $gettok(%MenuConfig,6,39)
    if (%tmp0 == null) {
      return $false
    }
    if (%tmp0 == $chr(35)) {
      echo -t @AnyCardStatus (Advertised Server channel) Single hash marks can interfere with the operation of mIRC's interpreter without redundant error checking.  I've $&
        chosen to disallow this.
      return $false
    } 
    return $true
  }
  if ($1 == 6) {
    %tmp0 = $gettok(%MenuConfig,7,39)
    if (%tmp0 == null) {
      return $false
    }
    if ($numtok(%tmp0,46) != 4) {
      echo -t @AnyCardStatus (Advertised Server IP) This IP address contains more or less than the standard 4 segments required.
      return $false
    } 
    if ($gettok(%tmp0,1,46) !isnum 0 - 255) || ($gettok(%tmp0,2,46) !isnum 0 - 255) || ($gettok(%tmp0,3,46) !isnum 0 - 255) || ($gettok(%tmp0,4,46) !isnum 0 - 255) {
      echo -t @AnyCardStatus (Advertised Server IP) This IP address contains segments with invalid values.  Acceptable range is 0 - 255.
      return $false
    } 
    return $true
  }
  if ($1 == 7) {
    %tmp0 = $gettok(%MenuConfig,8,39)
    if (%tmp0 == null) {
      return $false
    }
    if (%tmp0 !isnum 0 - 65535) || (. isin %tmp0) {
      echo -t @AnyCardStatus (Advertised Server Port) This port is invalid.  Acceptable range is 0 - 65535.
      return $false
    }
    if (!$portfree(%tmp0)) {
      echo -t @AnyCardStatus (Advertised Server Port) Port %tmp0 is currently in use.
      return $false
    }
    return $true
  }
  if ($1 == 8) {
    %tmp0 = $gettok(%MenuConfig,9,39)
    if (%tmp0 == null) {
      return $false
    }
    if ($numtok(%tmp0,46) != 4) {
      echo -t @AnyCardStatus (Join Server IP) This IP address contains more or less than the standard 4 segments required.
      return $false
    } 
    if ($gettok(%tmp0,1,46) !isnum 0 - 255) || ($gettok(%tmp0,2,46) !isnum 0 - 255) || ($gettok(%tmp0,3,46) !isnum 0 - 255) || ($gettok(%tmp0,4,46) !isnum 0 - 255) {
      echo -t @AnyCardStatus (Join Server IP) This IP address contains segments with invalid values.  Acceptable range is 0 - 255.
      return $false
    } 
    return $true
  }
  if ($1 == 9) {
    %tmp0 = $gettok(%MenuConfig,10,39)
    if (%tmp0 == null) {
      return $false
    }
    if (%tmp0 !isnum 0 - 65535) || (. isin %tmp0) {
      echo -t @AnyCardStatus (Join Server Port) This port is invalid.  Acceptable range is 0 - 65535.
      return $false
    }
    return $true
  }
  if ($1 == 10) {
    %tmp0 = $gettok(%MenuConfig,11,39)
    if (%tmp0 == null) {
      return $false
    }
    if (%tmp0 == $chr(35)) {
      echo -t @AnyCardStatus (Join Server Password) Single hash marks can interfere with the operation of mIRC's interpreter without redundant error checking.  I've $&
        chosen to disallow this.
      return $false
    }
    return $true
  }
  if ($1 == 11) {
    %tmp0 = $gettok(%MenuConfig,12,39)
    if (%tmp0 == null) {
      return $false
    }
    if (%tmp0 !isnum 0 - 65535) || (. isin %tmp0) {
      echo -t @AnyCardStatus (Start Server Port) This port is invalid.  Acceptable range is 0 - 65535.
      return $false
    }
    if (!$portfree(%tmp0)) {
      echo -t @AnyCardStatus (Start Server Port) Port %tmp0 is currently in use.
      return $false
    }
    return $true
  }
  if ($1 == 12) {
    %tmp0 = $gettok(%MenuConfig,13,39)
    if (%tmp0 == null) {
      return $false
    }
    if (%tmp0 == $chr(35)) {
      echo -t @AnyCardStatus (Start Server Password) Single hash marks can interfere with the operation of mIRC's interpreter without redundant error checking.  I've $&
        chosen to disallow this.
      return $false
    }
    return $true
  }
}

alias -l acstart {
  var %tmp0, %tmp1, %tmp2, %tmp3, %tmp4, %tmp5, %tmp6, %tmp7, %tmp8, %tmp9
  echo -t @AnyCardStatus Preparing table for play.
  %LoadingTable = $true
  set %MouseInWindow $false
  set %CardMode 0
  set %CurrentPlayer $gettok(%MenuConfig,14,39)
  set %DeckName 0
  set %DeckSum 0
  set %Actions
  set %ActionsPlayer
  set %ActionsMarker 35
  set %HandPlayer1
  set %HandPlayer2
  set %HandPlayer3
  set %HandPlayer4
  set %Layers
  set %StackSpacing 0.4
  set %Purgable1 $false
  set %Purgable2 $false
  set %Purgable3 $false
  set %Purgable4 $false
  set %Claimed 
  set %Peaked 0
  set %Stacks
  set %Server $false
  set %CurrentData
  set %CurrentData1
  set %CurrentData2
  set %CurrentData3
  set %PlayerToJoin1 0
  set %PlayerToJoin2 0
  set %PlayerToJoin3 0
  set %ConnectedtoServer 0
  set %ConnectedtoServerIP $gettok(%MenuConfig,9,39)
  set %ActionCueFlag $false
  set %ActionDropCueFlag $false
  set %ServerReady $false
  set %FullyConnected $false
  set %ServerCommanded $false
  set %CuedGrab $false
  set %ServerActionCued $false
  set %AvoidRepeat $false
  set %PlayerConnecting1 $false
  set %PlayerConnecting2 $false
  set %PlayerConnecting3 $false
  set %WaitingOnSecReq $false
  set %ServerAdvertise $false
  hmake PlayerDisconnectHT 8
  hmake ActionCueHT 8
  hmake ActionDropCueHT 8
  hmake ConnectedtoPlayerHT 2
  hmake ConnectedPlayerIPHT 5
  hmake AwaitingPrimaryReqHT 2
  hmake AwaitingSecondaryReqHT 2
  hmake GrabbedFromStackHT 2
  hmake GrabbedFromHandHT 2
  hmake GrabbedFlagHT 2
  hmake GrabbedTypeHT 2
  hmake GrabbedIDHT 2
  hmake GrabbedXHT 2
  hmake GrabbedYHT 2
  hmake PrePlayerFlagHT 2
  hmake PlayerFlagHT 2
  hmake PlayerReadyFlagHT 2
  hmake PlayerAngleHT 2
  hmake PlayerReadyNetHT 2
  hmake PlayerReadyNet2HT 2
  hmake PlayerLagHT 8
  hmake StackTopsHT 8
  hmake StackBottomsHT 8
  hmake StackSizeHT 8
  hmake CardPossessionHT 11
  hmake CardAngleHT 11
  hmake CardTypeHT 11
  hmake CardCoordinateXHT 11
  hmake CardCoordinateYHT 11
  hmake CardLayerHT 11
  hmake CardNameHT 100
  hmake CardFrontHT 11
  hmake CardBackHT 11
  hmake CardStackHT 11
  hmake CardFlipFlagHT 11
  hmake CardPlacementHT 11
  hmake CardFrontXHT 11
  hmake CardFrontYHT 11
  hmake CardFrontX2HT 11
  hmake CardFrontY2HT 11
  hmake CardBackXHT 11
  hmake CardBackYHT 11
  hmake CardBackX2HT 11
  hmake CardBackY2HT 11
  drawpic @GameIcons 0 0 "anycard/gameicons.png"
  window -pfhB +d @ActionsBuffer 0 0 700 40
  %tmp0 = 1
  while (%tmp0 <= 51) {
    %Actions = $addtok(%Actions,%tmp0,46)
    %Actions = $puttok(%Actions,0,%tmp0,46)
    inc %tmp0
  }
  %ActionsPlayer = %Actions
  window -pfhB +d @CardRot 0 0 720 720
  window -pfhB +d @Cards 0 0 720 800
  .fopen carddeckFS $+(anycard/,$gettok(%MenuConfig,2,39))
  %DeckName = $fread(carddeckFS)
  %DeckSum = $fread(carddeckFS)
  drawpic @Cards 0 0 $+(anycard/,$gettok(%MenuConfig,3,39))
  window -pfhB +d @Cards90 0 0 960 600
  %tmp0 = 0
  while ( %tmp0 < 120 ) {
    drawcopy @Cards $calc((%tmp0 % 12)* 60) $calc($int($calc(%tmp0 / 12)) * 80) 60 80 @CardRot 0 0
    drawrot @CardRot 90 0 0 60 80
    drawcopy @CardRot 0 0 80 60 @Cards90 $calc((%tmp0 % 12)* 80) $calc($int($calc(%tmp0 / 12)) * 60)
    inc %tmp0
  }
  window -pfhB +d @Cards180 0 0 720 800
  %tmp0 = 0
  while ( %tmp0 < 120 ) {
    drawcopy @Cards $calc((%tmp0 % 12)* 60) $calc($int($calc(%tmp0 / 12)) * 80) 60 80 @CardRot 0 0
    drawrot @CardRot 180 0 0 100 100
    drawcopy @CardRot 40 19 60 80 @Cards180 $calc((%tmp0 % 12)* 60) $calc($int($calc(%tmp0 / 12)) * 80)
    inc %tmp0
  }
  window -pfhB +d @Cards270 0 0 960 600
  %tmp0 = 0
  while ( %tmp0 < 120 ) {
    drawcopy @Cards $calc((%tmp0 % 12)* 60) $calc($int($calc(%tmp0 / 12)) * 80) 60 80 @CardRot 0 0
    drawrot @CardRot 270 0 0 100 100
    drawcopy @CardRot 1 39 80 60 @Cards270 $calc((%tmp0 % 12)* 80) $calc($int($calc(%tmp0 / 12)) * 60)
    inc %tmp0
  }
  window -pfhB +d @GrabBuffer 0 0 320 160
  drawrect -fr @GrabBuffer $rgb(164,64,64) 0 0 0 320 160
  window -pfhB +d @HandAngle1 0 0 528 80
  drawrect -fr @HandAngle1 $rgb(164,64,64) 0 0 0 528 80
  window -pfhB +d @HandAngle2 0 0 80 528
  drawrect -fr @HandAngle2 $rgb(164,64,64) 0 0 0 80 528
  window -pfhB +d @HandAngle3 0 0 528 80
  drawrect -fr @HandAngle3 $rgb(164,64,64) 0 0 0 528 80
  window -pfhB +d @HandAngle4 0 0 80 528
  drawrect -fr @HandAngle4 $rgb(164,64,64) 0 0 0 80 528
  window -pfhB +d @ActionsBuffer 0 0 700 40
  drawrect -fr @ActionsBuffer $rgb(164,64,64) 0 0 0 700 40
  window -pfhB +d @DrawBuffer 0 0 700 700
  window -pfhB +d @MouseBuffer 0 0 700 700
  window -pfhB +d @DetectCard 0 0 700 700
  window -pfhB +d @TableBuffer 0 0 700 700
  window -pfhB +d @TableShadow 0 0 700 700
  drawpic @TableShadow 0 0 "anycard/tableshadow.png"
  window -pfhB +d @CardTable 0 0 700 700
  drawpic @CardTable 0 0 $+(anycard/,$gettok(%MenuConfig,1,39))
  if ($calc(%CurrentPlayer - 1) == 1) {
    drawrot @CardTable 90 0 0 700 700
  }
  elseif ($calc(%CurrentPlayer - 1) == 2) {
    drawcopy @CardTable 0 0 700 700 @CardRot 0 0
    drawrot @CardRot 180 0 0 720 720
    drawcopy @CardRot 20 19 700 700 @CardTable 0 0
  }
  elseif ($calc(%CurrentPlayer - 1) == 3) {
    drawcopy @CardTable 0 0 700 700 @CardRot 0 0
    drawrot @CardRot 270 0 0 720 720
    drawcopy @CardRot 1 19 700 700 @CardTable 0 0
  }
  %tmp0 = 1
  while (%tmp0 <= 4) {
    hadd PlayerFlagHT %tmp0 0
    %tmp1 = 0
    if (%tmp0 > %currentplayer) {
      inc %tmp1
    }
    if ($calc(((%CurrentPlayer - %tmp0)+(%tmp1 * 4)) * 90) == 90) {
      drawrot @GameIcons 90 760 $calc((%tmp0 - 1) * 40) 40 40
      drawrot @GameIcons 90 800 $calc((%tmp0 - 1) * 40) 40 40
      hadd PlayerAngleHT %tmp0 2
    }
    elseif ($calc(((%CurrentPlayer - %tmp0)+(%tmp1 * 4)) * 90) == 180) {
      drawcopy @GameIcons 760 $calc((%tmp0 - 1) * 40) 40 40 @CardRot 0 0
      drawrot @CardRot 180 0 0 60 60
      drawcopy @CardRot 20 19 40 40 @GameIcons 760 $calc((%tmp0 - 1) * 40)
      drawcopy @GameIcons 800 $calc((%tmp0 - 1) * 40) 40 40 @CardRot 0 0
      drawrot @CardRot 180 0 0 60 60
      drawcopy @CardRot 20 19 40 40 @GameIcons 800 $calc((%tmp0 - 1) * 40)
      hadd PlayerAngleHT %tmp0 3
    }
    elseif ($calc(((%CurrentPlayer - %tmp0)+(%tmp1 * 4)) * 90) == 270) {
      drawcopy @GameIcons 760 $calc((%tmp0 - 1) * 40) 40 40 @CardRot 0 0
      drawrot @CardRot 270 0 0 60 60
      drawcopy @CardRot 1 19 40 40 @GameIcons 760 $calc((%tmp0 - 1) * 40)
      drawcopy @GameIcons 800 $calc((%tmp0 - 1) * 40) 40 40 @CardRot 0 0
      drawrot @CardRot 270 0 0 60 60
      drawcopy @CardRot 1 19 40 40 @GameIcons 800 $calc((%tmp0 - 1) * 40)
      hadd PlayerAngleHT %tmp0 4
    }
    else {
      hadd PlayerFlagHT %tmp0 1
      hadd PlayerAngleHT %tmp0 1
    }
    hadd AwaitingPrimaryReqHT %tmp0 $false
    hadd AwaitingSecondaryReqHT %tmp0 $false
    hadd PlayerReadyFlagHT %tmp0 $false
    hadd PrePlayerFlagHT %tmp0 $false
    hadd PlayerReadyNetHT %tmp0 $false
    hadd PlayerReadyNet2HT %tmp0 $false
    hadd ConnectedtoPlayerHT %tmp0 $false
    hadd GrabbedFromStackHT %tmp0 $false
    hadd GrabbedFromHandHT %tmp0 $false
    hadd GrabbedFlagHT %tmp0 $false
    hadd GrabbedTypeHT %tmp0 0
    hadd GrabbedIDHT %tmp0 0
    hadd GrabbedXHT %tmp0 0
    hadd GrabbedYHT %tmp0 0
    hadd PlayerLagHT %tmp0 0
    hadd PlayerDisconnectHT %tmp0 $false
    inc %tmp0
  }
  window -c @CardRot
  %tmp0 = 1
  while (%tmp0 <= %DeckSum) {
    %tmp1 = $fread(carddeckFS)
    hadd CardNameHT %tmp0 $fread(carddeckFS)
    hadd CardBackHT %tmp0 $fread(carddeckFS)
    hadd CardFrontHT %tmp0 $fread(carddeckFS)
    hadd CardTypeHT %tmp0 $fread(carddeckFS)
    hadd CardPossessionHT %tmp0 0
    hadd CardAngleHT %tmp0 1
    hadd CardCoordinateXHT %tmp0 350
    hadd CardCoordinateYHT %tmp0 350
    hadd CardStackHT %tmp0 0
    hadd CardFlipFlagHT %tmp0 0
    hadd CardPlacementHT %tmp0 0
    %Layers = $addtok(%Layers,%tmp0,46) 
    hadd CardLayerHT %tmp0
    hadd CardFrontXHT %tmp0 $calc(($hget(CardFrontHT,%tmp0) % 12) * 60)
    hadd CardFrontYHT %tmp0 $calc($int($calc($hget(CardFrontHT,%tmp0) / 12)) * 80)
    hadd CardFrontX2HT %tmp0 $calc(($hget(CardFrontHT,%tmp0) % 12) * 80)
    hadd CardFrontY2HT %tmp0 $calc($int($calc($hget(CardFrontHT,%tmp0) / 12)) * 60)
    hadd CardBackXHT %tmp0 $calc(($hget(CardBackHT,%tmp0) % 12) * 60)
    hadd CardBackYHT %tmp0 $calc($int($calc($hget(CardBackHT,%tmp0) / 12)) * 80)
    hadd CardBackX2HT %tmp0 $calc(($hget(CardBackHT,%tmp0) % 12) * 80)
    hadd CardBackY2HT %tmp0 $calc($int($calc($hget(CardBackHT,%tmp0) / 12)) * 60)
    inc %tmp0
  }
  if ($1) {
    %FullyConnected = $true
    %tmp1 = $fread(carddeckFS)
    %tmp0 = 1
    while (%tmp0 <= %tmp1) {
      %tmp8 = $fread(carddeckFS)
      %tmp2 = $fread(carddeckFS)
      %tmp3 = $fread(carddeckFS)
      %tmp4 = $fread(carddeckFS)
      %tmp5 = $fread(carddeckFS)
      %tmp6 = $fread(carddeckFS)
      %tmp7 = $fread(carddeckFS)
      %tmp8 = %tmp2
      while (%tmp8 <= %tmp3) {
        hadd CardCoordinateXHT %tmp8 %tmp4
        hadd CardCoordinateYHT %tmp8 $calc(%tmp5 - $int($calc((%tmp8 - %tmp2) * %StackSpacing)))
        hadd CardFlipFlagHT %tmp8 %tmp6
        hadd CardAngleHT %tmp8 %tmp7
        hadd CardStackHT %tmp8 %tmp0
        inc %tmp8
      }
      if ($calc(%tmp3 - %tmp2) > 0) {
        %Stacks = $addtok(%Stacks,%tmp0,46)
        hadd StackTopsHT %tmp0 %tmp3
        hadd StackBottomsHT %tmp0 %tmp2
        hadd StackSizeHT %tmp0 $calc(%tmp3 - %tmp2)
      }
      inc %tmp0
    }
    %Server = $true
    socklisten acServListen $gettok(%MenuConfig,12,39)
    hadd PlayerFlagHT %CurrentPlayer 1
    hadd ConnectedPlayerIPHT %CurrentPlayer
    %tmp0 = 1
    drawcopy @TcharBuffer 0 0 258 154 @MenuBuffer 223 22
    while (%tmp0 <= 700) {
      drawcopy @MenuBuffer 0 0 700 700 @DrawBuffer 0 0
      drawcopy @CardTable 0 0 700 700 @Drawbuffer $int($calc(350 - (%tmp0 / 2))) $int($calc(350 - (%tmp0 / 2))) %tmp0 %tmp0
      drawcopy @DrawBuffer 0 0 700 700 @AnyCard 0 0
      inc %tmp0 5
    }
    drawcopy -t @TableShadow $rgb(164,64,64) 0 660 700 40 @CardTable 0 660
    drawtable
    drawfinal
    %ServerReady = $true
    .timeracanimate off
    %GameMode = 2
    .timeraccycle -o 0 0 acmaincycle
    echo -t @AnyCardStatus Server started.
    echo -t @AnyCardStatus Please remember that cheating by manipulating this script isn't a stretch.  Choose your opponents carefully.
  }
  else {
    echo -t @AnyCardStatus Attempting connection to server.
    hadd PlayerFlagHT %CurrentPlayer 1
    sockopen acServRequest %ConnectedToServerIP $gettok(%MenuConfig,10,39)
    if ($sockerr > 0) {
      echo -t @AnyCardStatus Unable to connect.  If you're certain that you entered the address information correctly, it may be that you have no direct route.
      sockclose acServRequest
      acclose
      return
    }
  }
  .fclose carddeckFS
  if ($gettok(%MenuConfig,4,39) == 1) && (%Server) {
    if ($gettok(%MenuConfig,18,39)) && ($gettok(%MenuConfig,19,39)) && ($gettok(%MenuConfig,20,39)) && ($gettok(%MenuConfig,21,39)) {
      .timeracserverad -o 0 300 serverad
      echo -t @AnyCardStatus Server advertising enabled.  It should be noted that some servers won't provide information regarding what network they're a part of.  AnyCard $&
        will still advertise over these servers, but cannot distinguish one from another.
    }
  }
}

alias -l acclose {
  var %tmp0
  %LoadingTable = $false
  sockclose ac*
  .fclose *FS
  .timeraccycle off
  .timeracserverad off
  window -c @GrabBuffer
  window -c @ActionsBuffer
  window -c @HandAngle1
  window -c @HandAngle2
  window -c @HandAngle3
  window -c @HandAngle4
  window -c @TableBuffer
  window -c @TableShadow
  window -c @DetectCard
  window -c @MouseBuffer
  window -c @Cards
  window -c @Cards90
  window -c @Cards180
  window -c @Cards270
  .hfree -sw *HT
  unset %MouseInWindow
  unset %CardMode
  unset %CurrentPlayer
  unset %DeckName
  unset %DeckSum
  unset %Actions
  unset %ActionsPlayer
  unset %ActionsMarker
  unset %HandPlayer1
  unset %HandPlayer2
  unset %HandPlayer3
  unset %HandPlayer4
  unset %Layers
  unset %StackSpacing
  unset %Purgable1 
  unset %Purgable2
  unset %Purgable3
  unset %Purgable4
  unset %Claimed 
  unset %Peaked
  unset %Stacks
  unset %Server
  unset %CurrentData
  unset %CurrentData1
  unset %CurrentData2
  unset %CurrentData3
  unset %PlayerToJoin1
  unset %PlayerToJoin2
  unset %PlayerToJoin3
  unset %ConnectedtoServer
  unset %ConnectedtoServerIP
  unset %ActionCueFlag
  unset %ActionDropCueFlag
  unset %ServerReady
  %tmp0 = %FullyConnected
  unset %FullyConnected
  unset %ServerCommanded
  unset %CuedGrab
  unset %ServerActionCued
  unset %AvoidRepeat
  unset %PlayerConnecting1
  unset %PlayerConnecting2
  unset %PlayerConnecting3 
  unset %WaitingOnSecReq 
  unset %ServerAdvertise
  if (!%tmp0) {
    window -c @DrawBuffer
    window -c @CardTable    
    echo -t @AnyCardStatus Table unloaded.
    return
  } 
  drawpic @CardTable 0 0 $+(anycard/,$gettok(%MenuConfig,1,39))
  drawcopy @TcharBuffer 0 0 258 154 @MenuBuffer 223 22
  %tmp0 = 700
  while (%tmp0 >= 1) {
    drawcopy @MenuBuffer 0 0 700 700 @DrawBuffer 0 0
    drawcopy @CardTable 0 0 700 700 @DrawBuffer $int($calc(350 - (%tmp0 / 2))) $int($calc(350 - (%tmp0 / 2))) %tmp0 %tmp0
    drawcopy @DrawBuffer 0 0 700 700 @AnyCard 0 0
    dec %tmp0 5
  }
  drawcopy @MenuBuffer 0 0 700 700 @AnyCard 0 0
  window -c @DrawBuffer
  window -c @CardTable
  echo -t @AnyCardStatus Table unloaded.
  .timeracanimate -om 0 20 acanimator
  %GameMode = 1
}

alias -l acmaincycle {
  if (!%ServerReady) {
    drawcopy -t @GameIcons $rgb(164,64,64) 660 190 25 25 @AnyCard 675 0
  }
  else {
    drawcopy -t @GameIcons $rgb(164,64,64) 620 190 25 25 @AnyCard 675 0    
  }
  if ($hget(GrabbedFlagHT,1)) && (%CurrentPlayer != 1) {
    drawmouse
  }
  elseif ($hget(GrabbedFlagHT,2)) && (%CurrentPlayer != 2) {
    drawmouse
  }
  elseif ($hget(GrabbedFlagHT,3)) && (%CurrentPlayer != 3) {
    drawmouse
  }
  elseif ($hget(GrabbedFlagHT,4)) && (%CurrentPlayer != 4) {
    drawmouse
  }
  if (%Server) {
    if ($sock(acPreConnect1) != $null) && ($sock(acPreConnect1).ls >= 8) {
      if (%PlayerConnecting1) {
        %ServerReady = $true
      }
      hadd PrePlayerFlagHT 1 $false
      %PlayerConnecting1 = $false
      echo -t @AnyCardStatus Pre-Connect 1 terminated.
    }
    if ($sock(acPreConnect2) != $null) && ($sock(acPreConnect2).ls >= 8) {
      if (%PlayerConnecting2) {
        %ServerReady = $true
      }
      hadd PrePlayerFlagHT 2 $false
      %PlayerConnecting2 = $false
      echo -t @AnyCardStatus Pre-Connect 2 terminated.
    }
    if ($sock(acPreConnect3) != $null) && ($sock(acPreConnect3).ls >= 8) {
      if (%PlayerConnecting3) {
        %ServerReady = $true
      }
      hadd PrePlayerFlagHT 3 $false
      %PlayerConnecting3 = $false
      echo -t @AnyCardStatus Pre-Connect 3 terminated.
    }
    if ($hget(PlayerFlagHT,1) == 1) && (%CurrentPlayer != 1) { 
      if ($sock(acPlayer1).ls >= 3) {
        if (%ServerReady) && (!%ActionCueFlag) {
          performaction 1 10
        }
        echo -t @AnyCardStatus Player 1 is slow to respond.
      }
    }
    if ($hget(PlayerFlagHT,2) == 1) && (%CurrentPlayer != 2) {
      if ($sock(acPlayer2).ls >= 3) {
        if (%ServerReady) && (!%ActionCueFlag) {
          performaction 2 10
        }
        echo -t @AnyCardStatus Player 2 is slow to respond.
      }
    }
    if ($hget(PlayerFlagHT,3) == 1) && (%CurrentPlayer != 3) {
      if ($sock(acPlayer3).ls >= 3) {
        if (%ServerReady) && (!%ActionCueFlag) {
          performaction 3 10
        }
        echo -t @AnyCardStatus Player 3 is slow to respond.
      }
    }
    if ($hget(PlayerFlagHT,4) == 1) && (%CurrentPlayer != 4) {
      if ($sock(acPlayer4).ls >= 3) {
        if (%ServerReady) && (!%ActionCueFlag) {
          performaction 4 10
        }
        echo -t @AnyCardStatus Player 4 is slow to respond.
      }
    }
    if ($hget(PlayerDisconnectHT,1)) {
      if (%ServerReady) && (!%ActionCueFlag) {
        if ($hget(GrabbedFlagHT,1)) {
          performaction 1 13
        }
        else {
          performaction 1 11
          hadd PlayerDisconnectHT 1 $false
        }
      }
    }
    if ($hget(PlayerDisconnectHT,2)) {
      if (%ServerReady) && (!%ActionCueFlag) {
        if ($hget(GrabbedFlagHT,2)) {
          performaction 2 13
        }
        else {
          performaction 2 11
          hadd PlayerDisconnectHT 2 $false
        }
      }
    }    
    if ($hget(PlayerDisconnectHT,3)) {
      if (%ServerReady) && (!%ActionCueFlag) {
        if ($hget(GrabbedFlagHT,3)) {
          performaction 3 13
        }
        else {
          performaction 3 11
          hadd PlayerDisconnectHT 3 $false
        }
      }
    }
    if ($hget(PlayerDisconnectHT,4)) {
      if (%ServerReady) && (!%ActionCueFlag) {
        if ($hget(GrabbedFlagHT,4)) {
          performaction 4 13
        }
        else {
          performaction 4 11
          hadd PlayerDisconnectHT 4 $false
        }
      }
    }
  }
}

alias -l serverad {
  var %tmp0, %tmp1, %freeseats = $null
  if (!$hget(PlayerFlagHT,1)) && (!$hget(PlayerDisconnectHT,1)) {
    %freeseats = $addtok(%freeseats,9(1),32)
  }
  if (!$hget(PlayerFlagHT,2)) && (!$hget(PlayerDisconnectHT,2)) {
    %freeseats = $addtok(%freeseats,8(2),32)
  }
  if (!$hget(PlayerFlagHT,3)) && (!$hget(PlayerDisconnectHT,3)) {
    %freeseats = $addtok(%freeseats,12(3),32)
  }
  if (!$hget(PlayerFlagHT,4)) && (!$hget(PlayerDisconnectHT,4)) {
    %freeseats = $addtok(%freeseats,4(4),32)
  }
  if (%freeseats = $null) {
    %freeseats = none
  }
  if ($Server != $null) {
    if ($gettok(%MenuConfig,5,39) == $network) || ($network == $null) {
      if ($me ison $gettok(%MenuConfig,6,39)) {
        msg $gettok(%MenuConfig,6,39) 7,1AnyCard server running at5 $gettok(%MenuConfig,7,39) 7:5 $gettok(%MenuConfig,8,39) 7.  Available Seating: %freeseats
        msg $gettok(%MenuConfig,6,39) 7,1Download AnyCard at %DistroURL .
      }
    }
  }
}

alias -l actionnotify {
  %Actions = $deltok(%Actions,1,46)
  %Actions = $instok(%Actions,$2,51,46)
  %ActionsPlayer = $deltok(%ActionsPlayer,1,46)
  %ActionsPlayer = $instok(%ActionsPlayer,$1,51,46)
  drawactions
}

alias -l drawactions {
  var %tmp0 = %ActionsMarker, %tmp1 = %ActionsMarker + 16
  drawrect -fr @ActionsBuffer $rgb(164,64,64) 0 0 0 700 40
  while (%tmp0 <= %tmp1) {
    if ($gettok(%Actions,%tmp0,46) != 0) {
      drawcopy -t @GameIcons $rgb(164,64,64) $calc(($gettok(%Actions,%tmp0,46) - 1) * 40) $calc(($gettok(%ActionsPlayer,%tmp0,46) - 1) * 40) 40 40 $&
        @ActionsBuffer $calc(((%tmp0 - %ActionsMarker) * 40) + 10) 0
    }
    inc %tmp0
  }
}

alias -l drawhand {
  var %tmp0, %tmp1, %tmp2
  if ($1 == 1) {
    if ($hget(PlayerAngleHT,$1) == 1) {
      drawrect -fr @HandAngle1 $rgb(164,64,64) 0 0 0 528 80
      %tmp1 = $numtok(%HandPlayer1,46)
      %tmp0 = 1
      while (%tmp0 <= %tmp1) {
        %tmp2 = $gettok(%HandPlayer1,%tmp0,46)
        if ($hget(CardPlacementHT,%tmp2) == 2) {
          drawcopy @Cards $hget(CardFrontXHT,%tmp2) $hget(CardFrontYHT,%tmp2) 60 80 @HandAngle1 $calc((%tmp0 - 1) * 12) 0
        }
        inc %tmp0
      }
    }
    elseif ($hget(PlayerAngleHT,$1) == 2) {
      drawrect -fr @HandAngle2 $rgb(164,64,64) 0 0 0 80 528
      %tmp1 = $numtok(%HandPlayer1,46)
      %tmp0 = %tmp1
      while (%tmp0 >= 1) {
        %tmp2 = $gettok(%HandPlayer1,%tmp0,46)
        if ($hget(CardPlacementHT,%tmp2) == 2) {
          drawcopy @Cards90 $hget(CardBackX2HT,%tmp2) $hget(CardBackY2HT,%tmp2) 80 60 @HandAngle2 0 $calc((%tmp0 - 1) * 12)
        }
        dec %tmp0
      }
    }
    elseif ($hget(PlayerAngleHT,$1) == 3) {
      drawrect -fr @HandAngle3 $rgb(164,64,64) 0 0 0 528 80
      %tmp1 = $numtok(%HandPlayer1,46)
      %tmp0 = %tmp1
      while (%tmp0 >= 1) {
        %tmp2 = $gettok(%HandPlayer1,%tmp0,46)
        if ($hget(CardPlacementHT,%tmp2) == 2) {
          drawcopy @Cards180 $hget(CardBackXHT,%tmp2) $hget(CardBackYHT,%tmp2) 60 80 @HandAngle3 $calc(468 -((%tmp0 - 1) * 12)) 0
        }
        dec %tmp0
      }
    }
    else {
      drawrect -fr @HandAngle4 $rgb(164,64,64) 0 0 0 80 528
      %tmp1 = $numtok(%HandPlayer1,46)
      %tmp0 = %tmp1
      while (%tmp0 >= 1) {
        %tmp2 = $gettok(%HandPlayer1,%tmp0,46)
        if ($hget(CardPlacementHT,%tmp2) == 2) {
          drawcopy @Cards270 $hget(CardBackX2HT,%tmp2) $hget(CardBackY2HT,%tmp2) 80 60 @HandAngle4 0 $calc(468 -((%tmp0 - 1) * 12))
        }
        dec %tmp0
      }
    }
  }
  elseif ($1 == 2) {
    if ($hget(PlayerAngleHT,$1) == 1) {
      drawrect -fr @HandAngle1 $rgb(164,64,64) 0 0 0 528 80
      %tmp1 = $numtok(%HandPlayer2,46)
      %tmp0 = 1
      while (%tmp0 <= %tmp1) {
        %tmp2 = $gettok(%HandPlayer2,%tmp0,46)
        if ($hget(CardPlacementHT,%tmp2) == 2) {
          drawcopy @Cards $hget(CardFrontXHT,%tmp2) $hget(CardFrontYHT,%tmp2) 60 80 @HandAngle1 $calc((%tmp0 - 1) * 12) 0
        }
        inc %tmp0
      }
    }
    elseif ($hget(PlayerAngleHT,$1) == 2) {
      drawrect -fr @HandAngle2 $rgb(164,64,64) 0 0 0 80 528
      %tmp1 = $numtok(%HandPlayer2,46)
      %tmp0 = %tmp1
      while (%tmp0 >= 1) {
        %tmp2 = $gettok(%HandPlayer2,%tmp0,46)
        if ($hget(CardPlacementHT,%tmp2) == 2) {
          drawcopy @Cards90 $hget(CardBackX2HT,%tmp2) $hget(CardBackY2HT,%tmp2) 80 60 @HandAngle2 0 $calc((%tmp0 - 1) * 12)
        }
        dec %tmp0
      }
    }
    elseif ($hget(PlayerAngleHT,$1) == 3) {
      drawrect -fr @HandAngle3 $rgb(164,64,64) 0 0 0 528 80
      %tmp1 = $numtok(%HandPlayer2,46)
      %tmp0 = %tmp1
      while (%tmp0 >= 1) {
        %tmp2 = $gettok(%HandPlayer2,%tmp0,46)
        if ($hget(CardPlacementHT,%tmp2) == 2) {
          drawcopy @Cards180 $hget(CardBackXHT,%tmp2) $hget(CardBackYHT,%tmp2) 60 80 @HandAngle3 $calc(468 -((%tmp0 - 1) * 12)) 0
        }
        dec %tmp0
      }
    }
    else {
      drawrect -fr @HandAngle4 $rgb(164,64,64) 0 0 0 80 528
      %tmp1 = $numtok(%HandPlayer2,46)
      %tmp0 = %tmp1
      while (%tmp0 >= 1) {
        %tmp2 = $gettok(%HandPlayer2,%tmp0,46)
        if ($hget(CardPlacementHT,%tmp2) == 2) {
          drawcopy @Cards270 $hget(CardBackX2HT,%tmp2) $hget(CardBackY2HT,%tmp2) 80 60 @HandAngle4 0 $calc(468 -((%tmp0 - 1) * 12))
        }
        dec %tmp0
      }
    }
  }
  elseif ($1 == 3) {
    if ($hget(PlayerAngleHT,$1) == 1) {
      drawrect -fr @HandAngle1 $rgb(164,64,64) 0 0 0 528 80
      %tmp1 = $numtok(%HandPlayer3,46)
      %tmp0 = 1
      while (%tmp0 <= %tmp1) {
        %tmp2 = $gettok(%HandPlayer3,%tmp0,46)
        if ($hget(CardPlacementHT,%tmp2) == 2) {
          drawcopy @Cards $hget(CardFrontXHT,%tmp2) $hget(CardFrontYHT,%tmp2) 60 80 @HandAngle1 $calc((%tmp0 - 1) * 12) 0
        }
        inc %tmp0
      }
    }
    elseif ($hget(PlayerAngleHT,$1) == 2) {
      drawrect -fr @HandAngle2 $rgb(164,64,64) 0 0 0 80 528
      %tmp1 = $numtok(%HandPlayer3,46)
      %tmp0 = %tmp1
      while (%tmp0 >= 1) {
        %tmp2 = $gettok(%HandPlayer3,%tmp0,46)
        if ($hget(CardPlacementHT,%tmp2) == 2) {
          drawcopy @Cards90 $hget(CardBackX2HT,%tmp2) $hget(CardBackY2HT,%tmp2) 80 60 @HandAngle2 0 $calc((%tmp0 - 1) * 12)
        }
        dec %tmp0
      }
    }
    elseif ($hget(PlayerAngleHT,$1) == 3) {
      drawrect -fr @HandAngle3 $rgb(164,64,64) 0 0 0 528 80
      %tmp1 = $numtok(%HandPlayer3,46)
      %tmp0 = %tmp1
      while (%tmp0 >= 1) {
        %tmp2 = $gettok(%HandPlayer3,%tmp0,46)
        if ($hget(CardPlacementHT,%tmp2) == 2) {
          drawcopy @Cards180 $hget(CardBackXHT,%tmp2) $hget(CardBackYHT,%tmp2) 60 80 @HandAngle3 $calc(468 -((%tmp0 - 1) * 12)) 0
        }
        dec %tmp0
      }
    }
    else {
      drawrect -fr @HandAngle4 $rgb(164,64,64) 0 0 0 80 528
      %tmp1 = $numtok(%HandPlayer3,46)
      %tmp0 = %tmp1
      while (%tmp0 >= 1) {
        %tmp2 = $gettok(%HandPlayer3,%tmp0,46)
        if ($hget(CardPlacementHT,%tmp2) == 2) {
          drawcopy @Cards270 $hget(CardBackX2HT,%tmp2) $hget(CardBackY2HT,%tmp2) 80 60 @HandAngle4 0 $calc(468 -((%tmp0 - 1) * 12))
        }
        dec %tmp0
      }
    }
  }
  elseif ($1 == 4) {
    if ($hget(PlayerAngleHT,$1) == 1) {
      drawrect -fr @HandAngle1 $rgb(164,64,64) 0 0 0 528 80
      %tmp1 = $numtok(%HandPlayer4,46)
      %tmp0 = 1
      while (%tmp0 <= %tmp1) {
        %tmp2 = $gettok(%HandPlayer4,%tmp0,46)
        if ($hget(CardPlacementHT,%tmp2) == 2) {
          drawcopy @Cards $hget(CardFrontXHT,%tmp2) $hget(CardFrontYHT,%tmp2) 60 80 @HandAngle1 $calc((%tmp0 - 1) * 12) 0
        }
        inc %tmp0
      }
    }
    elseif ($hget(PlayerAngleHT,$1) == 2) {
      drawrect -fr @HandAngle2 $rgb(164,64,64) 0 0 0 80 528
      %tmp1 = $numtok(%HandPlayer4,46)
      %tmp0 = %tmp1
      while (%tmp0 >= 1) {
        %tmp2 = $gettok(%HandPlayer4,%tmp0,46)
        if ($hget(CardPlacementHT,%tmp2) == 2) {
          drawcopy @Cards90 $hget(CardBackX2HT,%tmp2) $hget(CardBackY2HT,%tmp2) 80 60 @HandAngle2 0 $calc((%tmp0 - 1) * 12)
        }
        dec %tmp0
      }
    }
    elseif ($hget(PlayerAngleHT,$1) == 3) {
      drawrect -fr @HandAngle3 $rgb(164,64,64) 0 0 0 528 80
      %tmp1 = $numtok(%HandPlayer4,46)
      %tmp0 = %tmp1
      while (%tmp0 >= 1) {
        %tmp2 = $gettok(%HandPlayer4,%tmp0,46)
        if ($hget(CardPlacementHT,%tmp2) == 2) {
          drawcopy @Cards180 $hget(CardBackXHT,%tmp2) $hget(CardBackYHT,%tmp2) 60 80 @HandAngle3 $calc(468 -((%tmp0 - 1) * 12)) 0
        }
        dec %tmp0
      }
    }
    else {
      drawrect -fr @HandAngle4 $rgb(164,64,64) 0 0 0 80 528
      %tmp1 = $numtok(%HandPlayer4,46)
      %tmp0 = %tmp1
      while (%tmp0 >= 1) {
        %tmp2 = $gettok(%HandPlayer4,%tmp0,46)
        if ($hget(CardPlacementHT,%tmp2) == 2) {
          drawcopy @Cards270 $hget(CardBackX2HT,%tmp2) $hget(CardBackY2HT,%tmp2) 80 60 @HandAngle4 0 $calc(468 -((%tmp0 - 1) * 12))
        }
        dec %tmp0
      }
    }
  }
}

alias -l drawtable {
  var %tmp0 = 1, %tmp1, %tmp2, %tmp3, %tmp4, %tmp5
  drawcopy @Cardtable 0 0 700 700 @Tablebuffer 0 0
  drawrect -fr @DetectCard 0 0 0 0 700 700
  while (%tmp0 <= %DeckSum) {
    %tmp1 = $gettok(%Layers,%tmp0,46)
    if ($hget(CardPlacementHT,%tmp1) == 0) {
      %tmp2 = $hget(CardCoordinateXHT,%tmp1) - 30
      %tmp3 = $hget(CardCoordinateYHT,%tmp1) - 40
      %tmp4 = $hget(CardCoordinateXHT,%tmp1) - 40
      %tmp5 = $hget(CardCoordinateYHT,%tmp1) - 30
      if ($hget(CardAngleHT,%tmp1) == 1) {
        if ($hget(CardFlipFlagHT,%tmp1) == 0) {
          drawcopy @Cards $hget(CardFrontXHT,%tmp1) $hget(CardFrontYHT,%tmp1) 60 80 @TableBuffer %tmp2 %tmp3
        }
        else {
          drawcopy @Cards $hget(CardBackXHT,%tmp1) $hget(CardBackYHT,%tmp1) 60 80 @TableBuffer %tmp2 %tmp3
        }
        drawrect -fr @DetectCard %tmp1 0 %tmp2 %tmp3 60 80
      }
      elseif ($hget(CardAngleHT,%tmp1) == 2) {
        if ($hget(CardFlipFlagHT,%tmp1) == 0) {
          drawcopy @Cards90 $hget(CardFrontX2HT,%tmp1) $hget(CardFrontY2HT,%tmp1) 80 60 @TableBuffer %tmp4 %tmp5
        }
        else {
          drawcopy @Cards90 $hget(CardBackX2HT,%tmp1) $hget(CardBackY2HT,%tmp1) 80 60 @TableBuffer %tmp4 %tmp5
        }
        drawrect -fr @DetectCard %tmp1 0 %tmp4 %tmp5 80 60
      }
      elseif ($hget(CardAngleHT,%tmp1) == 3) {
        if ($hget(CardFlipFlagHT,%tmp1) == 0) {
          drawcopy @Cards180 $hget(CardFrontXHT,%tmp1) $hget(CardFrontYHT,%tmp1) 60 80 @TableBuffer %tmp2 %tmp3
        }
        else {
          drawcopy @Cards180 $hget(CardBackXHT,%tmp1) $hget(CardBackYHT,%tmp1) 60 80 @TableBuffer %tmp2 %tmp3
        }
        drawrect -fr @DetectCard %tmp1 0 %tmp2 %tmp3 60 80
      }
      else {
        if ($hget(CardFlipFlagHT,%tmp1) == 0) {
          drawcopy @Cards270 $hget(CardFrontX2HT,%tmp1) $hget(CardFrontY2HT,%tmp1) 80 60 @Tablebuffer %tmp4 %tmp5
        }
        else {
          drawcopy @Cards270 $hget(CardBackX2HT,%tmp1) $hget(CardBackY2HT,%tmp1) 80 60 @Tablebuffer %tmp4 %tmp5
        }
        drawrect -fr @DetectCard %tmp1 0 %tmp4 %tmp5 80 60
      }
    }
    inc %tmp0
  }
  %tmp0 = 1
  %tmp1 = $numtok(%Stacks,46)
  while (%tmp0 <= %tmp1) {
    %tmp2 = $gettok(%Stacks,%tmp0,46)
    if ($hget(CardPlacementHT,$hget(StackBottomsHT,%tmp2)) == 0) {
      drawcopy -t @GameIcons $rgb(164,64,64) 740 160 60 60 @Tablebuffer $calc($hget(CardCoordinateXHT,$hget(StackBottomsHT,%tmp2)) - 30) $&
        $calc($hget(CardCoordinateYHT,$hget(StackBottomsHT,%tmp2)) - 30)
    }
    inc %tmp0
  }
  %tmp0 = 1
  %tmp1 = $numtok(%Claimed,46)
  while (%tmp0 <= %tmp1) {
    drawcopy -t @GameIcons $rgb(164,64,64) $calc((($hget(CardPossessionHT,$gettok(%Claimed,%tmp0,46)) - 1) * 40) + 460) 190 25 25 @Tablebuffer $&
      $calc($hget(CardCoordinateXHT,$gettok(%Claimed,%tmp0,46)) - 12) $calc($hget(CardCoordinateYHT,$gettok(%Claimed,%tmp0,46)) - 12)
    inc %tmp0
  }
  drawcopy -t @GameIcons $rgb(164,64,64) 620 160 25 25 @TableBuffer 20 635
  drawcopy -t @GameIcons $rgb(164,64,64) 660 160 25 25 @TableBuffer 655 635
  drawcopy -t @TableShadow $rgb(164,64,64) 65 595 528 65 @TableBuffer 65 595
  drawcopy -t @TableShadow $rgb(164,64,64) 25 660 650 15 @TableBuffer 25 660
}

alias -l drawcard {
  var %tmpx = $3, %tmpy = $4
  if ($hget(CardAngleHT,$1) == 1) {
    if ($5) {
      %tmpx = $calc($3 - 30)
      %tmpy = $calc($4 - 40)
    }
    if ($6) {
      drawcopy @Cards $hget(CardFrontXHT,$1) $hget(CardFrontYHT,$1) 60 80 $2 %tmpx %tmpy
    }
    else {
      drawcopy @Cards $hget(CardBackXHT,$1) $hget(CardBackYHT,$1) 60 80 $2 %tmpx %tmpy
    }
  }
  elseif ($hget(CardAngleHT,$1) == 2) {
    if ($5) {
      %tmpx = $calc($3 - 40)
      %tmpy = $calc($4 - 30)
    }
    if ($6) {
      drawcopy @Cards90 $hget(CardFrontX2HT,$1) $hget(CardFrontY2HT,$1) 80 60 $2 %tmpx %tmpy
    }
    else {
      drawcopy @Cards90 $hget(CardBackX2HT,$1) $hget(CardBackY2HT,$1) 80 60 $2 %tmpx %tmpy
    }
  }
  elseif ($hget(CardAngleHT,$1) == 3) {
    if ($5) {
      %tmpx = $calc($3 - 30)
      %tmpy = $calc($4 - 40)
    }
    if ($6) {
      drawcopy @Cards180 $hget(CardFrontXHT,$1) $hget(CardFrontYHT,$1) 60 80 $2 %tmpx %tmpy
    }
    else {
      drawcopy @Cards180 $hget(CardBackXHT,$1) $hget(CardBackYHT,$1) 60 80 $2 %tmpx %tmpy
    }
  }
  else {
    if ($5) {
      %tmpx = $calc($3 - 40)
      %tmpy = $calc($4 - 30)
    }
    if ($6) {
      drawcopy @Cards270 $hget(CardFrontX2HT,$1) $hget(CardFrontY2HT,$1) 80 60 $2 %tmpx %tmpy
    }
    else {
      drawcopy @Cards270 $hget(CardBackX2HT,$1) $hget(CardBackY2HT,$1) 80 60 $2 %tmpx %tmpy
    }
  }
}

alias -l drawfinal {
  var %tmp0 = 1
  drawcopy @TableBuffer 0 0 700 700 @DrawBuffer 0 0
  if (%Server) {
    if (%Purgable1) || (%Purgable2) || (%Purgable3) || (%Purgable4) {
      drawcopy -t @GameIcons $rgb(164,64,64) 700 160 25 25 @DrawBuffer 20 600
    }
  }
  while (%tmp0 <= 4) {
    if ($hget(PlayerAngleHT,%tmp0) == 2) {
      if (%tmp0 == 1) && ($numtok(%HandPlayer1,46) > 0) {
        drawcopy -t @HandAngle2 $rgb(164,64,64) 0 0 80 528 @DrawBuffer 25 65
      }
      elseif (%tmp0 == 2) && ($numtok(%HandPlayer2,46) > 0) {
        drawcopy -t @HandAngle2 $rgb(164,64,64) 0 0 80 528 @DrawBuffer 25 65
      }
      elseif (%tmp0 == 3) && ($numtok(%HandPlayer3,46) > 0) {
        drawcopy -t @HandAngle2 $rgb(164,64,64) 0 0 80 528 @DrawBuffer 25 65
      }
      elseif (%tmp0 == 4) && ($numtok(%HandPlayer4,46) > 0) {
        drawcopy -t @HandAngle2 $rgb(164,64,64) 0 0 80 528 @DrawBuffer 25 65
      }              
      if ($hget(PlayerFlagHT,%tmp0) == 1) {    
        if ($hget(PlayerReadyFlagHT,%tmp0)) {
          drawcopy -t @GameIcons $rgb(164,64,64) 800 $calc((%tmp0 - 1) * 40) 40 40 @DrawBuffer 45 45
        }
        else {
          drawcopy -t @GameIcons $rgb(164,64,64) 760 $calc((%tmp0 - 1) * 40) 40 40 @DrawBuffer 45 45
        }
        if (%Server) && (%CurrentPlayer != %tmp0) {
          drawcopy -t @GameIcons $rgb(164,64,64) 700 190 25 25 @DrawBuffer 52 52
        }
        elseif (!%Server) && (%ConnectedToServer == %tmp0) { 
          drawcopy -t @GameIcons $rgb(164,64,64) 810 160 25 25 @DrawBuffer 52 52
        }        
      }
    }
    elseif ($hget(PlayerAngleHT,%tmp0) == 3) {        
      if (%tmp0 == 1) && ($numtok(%HandPlayer1,46) > 0) {
        drawcopy -t @HandAngle3 $rgb(164,64,64) 0 0 528 80 @DrawBuffer 107 25
      }
      elseif (%tmp0 == 2) && ($numtok(%HandPlayer2,46) > 0) {
        drawcopy -t @HandAngle3 $rgb(164,64,64) 0 0 528 80 @DrawBuffer 107 25
      }
      elseif (%tmp0 == 3) && ($numtok(%HandPlayer3,46) > 0) {
        drawcopy -t @HandAngle3 $rgb(164,64,64) 0 0 528 80 @DrawBuffer 107 25
      }
      elseif (%tmp0 == 4) && ($numtok(%HandPlayer4,46) > 0) {
        drawcopy -t @HandAngle3 $rgb(164,64,64) 0 0 528 80 @DrawBuffer 107 25
      }   
      if ($hget(PlayerFlagHT,%tmp0) == 1) {
        if ($hget(PlayerReadyFlagHT,%tmp0)) {
          drawcopy -t @GameIcons $rgb(164,64,64) 800 $calc((%tmp0 - 1) * 40) 40 40 @DrawBuffer 615 45
        }
        else {
          drawcopy -t @GameIcons $rgb(164,64,64) 760 $calc((%tmp0 - 1) * 40) 40 40 @DrawBuffer 615 45
        }
        if (%Server) && (%CurrentPlayer != %tmp0) {
          drawcopy -t @GameIcons $rgb(164,64,64) 700 190 25 25 @DrawBuffer 622 52
        }
        elseif (!%Server) && (%ConnectedToServer == %tmp0) { 
          drawcopy -t @GameIcons $rgb(164,64,64) 810 160 25 25 @DrawBuffer 622 52
        }
      }
    }
    elseif ($hget(PlayerAngleHT,%tmp0) == 4) {        
      if (%tmp0 == 1) && ($numtok(%HandPlayer1,46) > 0) {
        drawcopy -t @HandAngle4 $rgb(164,64,64) 0 0 80 528 @DrawBuffer 595 107
      }
      elseif (%tmp0 == 2) && ($numtok(%HandPlayer2,46) > 0) {
        drawcopy -t @HandAngle4 $rgb(164,64,64) 0 0 80 528 @DrawBuffer 595 107
      }
      elseif (%tmp0 == 3) && ($numtok(%HandPlayer3,46) > 0) {
        drawcopy -t @HandAngle4 $rgb(164,64,64) 0 0 80 528 @DrawBuffer 595 107
      }
      elseif (%tmp0 == 4) && ($numtok(%HandPlayer4,46) > 0) {
        drawcopy -t @HandAngle4 $rgb(164,64,64) 0 0 80 528 @DrawBuffer 595 107
      }   
      if ($hget(PlayerFlagHT,%tmp0) == 1) {
        if ($hget(PlayerReadyFlagHT,%tmp0)) {
          drawcopy -t @GameIcons $rgb(164,64,64) 800 $calc((%tmp0 - 1) * 40) 40 40 @DrawBuffer 615 615
        }
        else {
          drawcopy -t @GameIcons $rgb(164,64,64) 760 $calc((%tmp0 - 1) * 40) 40 40 @DrawBuffer 615 615
        }
        if (%Server) && (%CurrentPlayer != %tmp0) {
          drawcopy -t @GameIcons $rgb(164,64,64) 700 190 25 25 @DrawBuffer 622 622
        }
        elseif (!%Server) && (%ConnectedToServer == %tmp0) { 
          drawcopy -t @GameIcons $rgb(164,64,64) 810 160 25 25 @DrawBuffer 622 622
        }
      }
    }
    else {        
      if (%tmp0 == 1) && ($numtok(%HandPlayer1,46) > 0) {
        drawcopy -t @HandAngle1 $rgb(164,64,64) 0 0 528 80 @DrawBuffer 65 595
      }
      elseif (%tmp0 == 2) && ($numtok(%HandPlayer2,46) > 0) {
        drawcopy -t @HandAngle1 $rgb(164,64,64) 0 0 528 80 @DrawBuffer 65 595
      }
      elseif (%tmp0 == 3) && ($numtok(%HandPlayer3,46) > 0) {
        drawcopy -t @HandAngle1 $rgb(164,64,64) 0 0 528 80 @DrawBuffer 65 595
      }
      elseif (%tmp0 == 4) && ($numtok(%HandPlayer4,46) > 0) {
        drawcopy -t @HandAngle1 $rgb(164,64,64) 0 0 528 80 @DrawBuffer 65 595
      } 
      if ($hget(PlayerFlagHT,%tmp0) == 1) {
        if ($hget(PlayerReadyFlagHT,%tmp0)) {
          drawcopy -t @GameIcons $rgb(164,64,64) 800 $calc((%tmp0 - 1) * 40) 40 40 @DrawBuffer 45 615
        }
        else {
          drawcopy -t @GameIcons $rgb(164,64,64) 760 $calc((%tmp0 - 1) * 40) 40 40 @DrawBuffer 45 615
        }
      }
    }
    inc %tmp0
  }
  drawcopy -t @ActionsBuffer $rgb(164,64,64) 0 0 700 40 @DrawBuffer 0 660
  drawmouse
}

alias -l drawmouse {
  var %tmp0 = 1, %tmpx, %tmpy
  drawcopy -h @DrawBuffer 0 0 700 700 @MouseBuffer 0 0
  %tmpx = $mouse.x
  %tmpy = $mouse.y
  while (%tmp0 <= 4) {
    if ($hget(GrabbedFlagHT,%tmp0)) {
      if (%tmp0 = %CurrentPlayer) {
        hadd GrabbedXHT %tmp0 %tmpx
        hadd GrabbedYHT %tmp0 %tmpy
      }
      if ($hget(GrabbedTypeHT,%tmp0) == 1) {
        if ($hget(CardAngleHT,$hget(GrabbedIDHT,%tmp0)) == 1) || ($hget(CardAngleHT,$hget(GrabbedIDHT,%tmp0)) == 3) {
          drawcopy -mt @TableShadow $rgb(164,64,64) $calc($hget(GrabbedXHT,%tmp0) - 27) $calc($hget(GrabbedYHT,%tmp0) - 39) $&
            68 90 @MouseBuffer $calc($hget(GrabbedXHT,%tmp0) - 27) $calc($hget(GrabbedYHT,%tmp0) - 39) 68 90        
        }
        elseif ($hget(CardAngleHT,$hget(GrabbedIDHT,%tmp0)) == 2) || ($hget(CardAngleHT,$hget(GrabbedIDHT,%tmp0)) == 4) {
          drawcopy -mt @TableShadow $rgb(164,64,64) $calc($hget(GrabbedXHT,%tmp0) - 37) $calc($hget(GrabbedYHT,%tmp0) - 29) $&
            90 68 @MouseBuffer $calc($hget(GrabbedXHT,%tmp0) - 37) $calc($hget(GrabbedYHT,%tmp0) - 29) 90 68    
        }
        drawcopy -mt @GrabBuffer $rgb(164,64,64) $calc((%tmp0 - 1) * 80) 0 80 160 @MouseBuffer $calc($hget(GrabbedXHT,%tmp0) - 45) $calc($hget(GrabbedYHT,%tmp0) - 139) 92 184 
      }
      else {
        if ($hget(CardAngleHT,$hget(StackTopsHT,$hget(GrabbedIDHT,%tmp0))) == 1) || ($hget(CardAngleHT,$hget(StackTopsHT,$hget(GrabbedIDHT,%tmp0))) == 3) {
          drawcopy -mt @TableShadow $rgb(164,64,64) $calc($hget(GrabbedXHT,%tmp0) - 27) $calc($hget(GrabbedYHT,%tmp0) - 39) $&
            68 90 @MouseBuffer $calc($hget(GrabbedXHT,%tmp0) - 27) $calc($hget(GrabbedYHT,%tmp0) - 39) 68 90        
        }
        elseif ($hget(CardAngleHT,$hget(StackTopsHT,$hget(GrabbedIDHT,%tmp0))) == 2) || ($hget(CardAngleHT,$hget(StackTopsHT,$hget(GrabbedIDHT,%tmp0))) == 4) {
          drawcopy -mt @TableShadow $rgb(164,64,64) $calc($hget(GrabbedXHT,%tmp0) - 37) $calc($hget(GrabbedYHT,%tmp0) - 29) $&
            90 68 @MouseBuffer $calc($hget(GrabbedXHT,%tmp0) - 37) $calc($hget(GrabbedYHT,%tmp0) - 29) 90 68    
        }
        drawcopy -mt @GrabBuffer $rgb(164,64,64) $calc((%tmp0 - 1) * 80) 0 80 160 @MouseBuffer $calc($hget(GrabbedXHT,%tmp0) - 45) $calc($hget(GrabbedYHT,%tmp0) - 139) 92 184
        drawcopy -t @GameIcons $rgb(164,64,64) 740 160 60 60 @MouseBuffer $calc($hget(GrabbedXHT,%tmp0) - 30) $calc($hget(GrabbedYHT,%tmp0) - 30)
      }
      if (%tmp0 != %CurrentPlayer) {
        drawcopy -t @GameIcons $rgb(164,64,64) $calc(((%tmp0 - 1) * 40) + 460) 160 25 25 @MouseBuffer $hget(GrabbedXHT,%tmp0) $hget(GrabbedYHT,%tmp0)
      }
    }
    inc %tmp0
  }
  if (%Peaked != 0) {
    if ($hget(CardFlipFlagHT,%Peaked)) {
      drawcard %Peaked @MouseBuffer $hget(CardCoordinateXHT,%Peaked) $hget(CardCoordinateYHT,%Peaked) $true $true
    }
    else {
      drawcard %Peaked @MouseBuffer $hget(CardCoordinateXHT,%Peaked) $hget(CardCoordinateYHT,%Peaked) $true $false
    }
  }
  if ($inrect(%tmpx,%tmpy,65,595,528,80)) && (%CardMode <= 1) && (%MouseInWindow) {
    drawcopy -t @GameIcons $rgb(164,64,64) $calc(%cardmode * 60) 160 60 60 @MouseBuffer %tmpx %tmpy
  }
  elseif ($inrect(%tmpx,%tmpy,65,65,570,570)) && (!$inrect(%tmpx,%tmpy,65,595,528,80)) && (%MouseInWindow) {
    drawcopy -t @GameIcons $rgb(164,64,64) $calc(%cardmode * 60) 160 60 60 @MouseBuffer %tmpx %tmpy
  }
  drawcopy -t @GameIcons $rgb(164,64,64) 360 160 100 50 @MouseBuffer 0 0 
  if (!%ServerReady) {
    drawcopy -t @GameIcons $rgb(164,64,64) 660 190 27 27 @MouseBuffer 675 0
  }
  else {
    drawcopy -t @GameIcons $rgb(164,64,64) 620 190 27 27 @MouseBuffer 675 0   
  }
  drawcopy -h @MouseBuffer 0 0 700 700 @AnyCard 0 0
}

alias -l drawgrab {
  var %tmp0, %tmp1, %tmp2, %tmp3, %tmp4, %tmp5, %tmp6
  drawrect -fr @GrabBuffer $rgb(164,64,64) 0 $calc(($1 - 1) * 80) 0 $calc($1 * 80) 160
  if ($2 == 1) {
    if ($hget(GrabbedFromHandHT,$1)) {
      if (%CurrentPlayer == $1) {
        %tmp6 = $hget(CardFlipFlagHT,$3)
      }
      else {
        %tmp6 = 1
      }
    }
    else {
      %tmp6 = $hget(CardFlipFlagHT,$3)
    }
    %tmp0 = $calc((($1 - 1) * 80) + 40)
    if ($hget(CardAngleHT,$3) == 1) {
      if (%tmp6 == 0) {
        drawcopy @Cards $hget(CardFrontXHT,$3) $hget(CardFrontYHT,$3) 60 80 @GrabBuffer $calc(%tmp0 - 30) 80
      }
      else {
        drawcopy @Cards $hget(CardBackXHT,$3) $hget(CardBackYHT,$3) 60 80 @GrabBuffer $calc(%tmp0 - 30) 80
      }
    }
    elseif ($hget(CardAngleHT,$3) == 2) {
      if (%tmp6 == 0) {
        drawcopy @Cards90 $hget(CardFrontX2HT,$3) $hget(CardFrontY2HT,$3) 80 60 @GrabBuffer $calc(%tmp0 - 40) 90
      }
      else {
        drawcopy @Cards90 $hget(CardBackX2HT,$3) $hget(CardBackY2HT,$3) 80 60 @GrabBuffer $calc(%tmp0 - 40) 90
      }
    }
    elseif ($hget(CardAngleHT,$3) == 3) {
      if (%tmp6 == 0) {
        drawcopy @Cards180 $hget(CardFrontXHT,$3) $hget(CardFrontYHT,$3) 60 80 @GrabBuffer $calc(%tmp0 - 30) 80
      }
      else {
        drawcopy @Cards180 $hget(CardBackXHT,$3) $hget(CardBackYHT,$3) 60 80 @GrabBuffer $calc(%tmp0 - 30) 80
      }
    }
    else {
      if (%tmp6 == 0) {
        drawcopy @Cards270 $hget(CardFrontX2HT,$3) $hget(CardFrontY2HT,$3) 80 60 @GrabBuffer $calc(%tmp0 - 40) 90
      }
      else {
        drawcopy @Cards270 $hget(CardBackX2HT,$3) $hget(CardBackY2HT,$3) 80 60 @GrabBuffer $calc(%tmp0 - 40) 90
      }
    }
  }
  elseif ($2 == 2) {
    %tmp0 = $findtok(%Layers,$hget(StackBottomsHT,$3),1,46)
    %tmp1 = $findtok(%Layers,$hget(StackTopsHT,$3),1,46)
    %tmp3 = $calc((($1 - 1) * 80) + 40)
    %tmp4 = $hget(CardCoordinateYHT, $gettok(%Layers,%tmp0,46))
    while (%tmp0 <= %tmp1) {
      %tmp2 = $gettok(%Layers,%tmp0,46)
      %tmp5 = $hget(CardCoordinateYHT, $gettok(%Layers,%tmp0,46))
      if ($hget(CardAngleHT,%tmp2) == 1) {
        if ($hget(CardFlipFlagHT,%tmp2) == 0) {
          drawcopy @Cards $hget(CardFrontXHT,%tmp2) $hget(CardFrontYHT,%tmp2) 60 80 @GrabBuffer $calc(%tmp3 - 30) $calc(80 - (%tmp4 - %tmp5))
        }
        else {
          drawcopy @Cards $hget(CardBackXHT,%tmp2) $hget(CardBackYHT,%tmp2) 60 80 @GrabBuffer $calc(%tmp3 - 30) $calc(80 - (%tmp4 - %tmp5))
        }
      }
      elseif ($hget(CardAngleHT,%tmp2) == 2) {
        if ($hget(CardFlipFlagHT,%tmp2) == 0) {
          drawcopy @Cards90 $hget(CardFrontX2HT,%tmp2) $hget(CardFrontY2HT,%tmp2) 80 60 @GrabBuffer $calc(%tmp3 - 40) $calc(90 - (%tmp4 - %tmp5))
        }
        else {
          drawcopy @Cards90 $hget(CardBackX2HT,%tmp2) $hget(CardBackY2HT,%tmp2) 80 60 @GrabBuffer $calc(%tmp3 - 40) $calc(90 - (%tmp4 - %tmp5))
        }
      }
      elseif ($hget(CardAngleHT,%tmp2) == 3) {
        if ($hget(CardFlipFlagHT,%tmp2) == 0) {
          drawcopy @Cards180 $hget(CardFrontXHT,%tmp2) $hget(CardFrontYHT,%tmp2) 60 80 @GrabBuffer $calc(%tmp3 - 30) $calc(80 - (%tmp4 - %tmp5))
        }
        else {
          drawcopy @Cards180 $hget(CardBackXHT,%tmp2) $hget(CardBackYHT,%tmp2) 60 80 @GrabBuffer $calc(%tmp3 - 30) $calc(80 - (%tmp4 - %tmp5))
        }
      }
      else {
        if ($hget(CardFlipFlagHT,%tmp2) == 0) {
          drawcopy @Cards270 $hget(CardFrontX2HT,%tmp2) $hget(CardFrontY2HT,%tmp2) 80 60 @GrabBuffer $calc(%tmp3 - 40) $calc(90 - (%tmp4 - %tmp5))
        }
        else {
          drawcopy @Cards270 $hget(CardBackX2HT,%tmp2) $hget(CardBackY2HT,%tmp2) 80 60 @GrabBuffer $calc(%tmp3 - 40) $calc(90 - (%tmp4 - %tmp5))
        }
      }
      inc %tmp0
    }
  }
}

alias -l performaction {
  var %tmp0, %tmp1, %tmp2, %tmp3, %tmp4, %tmp5, %tmpstack, %tmpstack2, %tmpstack3, %noplayers, %tmpx, %tmpy, %tmpangle
  if (!%ServerCommanded) {
    if (%ServerReady) && (%Server) {
      if ($1 == %CurrentPlayer) && ($2 == 1) && (%ActionDropCueFlag) {
        return
      }
      elseif ($1 == %CurrentPlayer) && ($2 == 2) && (%ActionDropCueFlag) {
        return
      }
      %ServerReady = $false 
      %noplayers = $true
      %tmp0 = 1
      while (%tmp0 <= 4) {
        if ($hget(PlayerFlagHT,%tmp0) == 1) && (%CurrentPlayer != %tmp0) {
          %noplayers = $false
        }
        inc %tmp0
      }
      if (!%noplayers) {
        %ActionCueFlag = $true
        hadd ActionCueHT 1 $1
        hadd ActionCueHT 2 $2  
        hadd ActionCueHT 3 $3  
        hadd ActionCueHT 4 $4  
        hadd ActionCueHT 5 $5
        hadd ActionCueHT 6 $6  
        hadd ActionCueHT 7 $7
      }
      else {
        %ServerReady = $true
      }
    }
    elseif (%ServerReady) && (!%Server) {
      if (!%ActionCueFlag) {
        if ($2 == 1) && (!%ActionDropCueFlag) { 
          %ActionCueFlag = $true
          hadd ActionCueHT 1 $1
          hadd ActionCueHT 2 $2  
          hadd ActionCueHT 3 $3  
          hadd ActionCueHT 4 $4  
          hadd ActionCueHT 5 $5
          hadd ActionCueHT 6 $6           
          hadd ActionCueHT 7 $7
          %CuedGrab = $true
          %AvoidRepeat = $false
        }
        elseif ($2 != 1) {
          %ActionCueFlag = $true
          hadd ActionCueHT 1 $1
          hadd ActionCueHT 2 $2  
          hadd ActionCueHT 3 $3  
          hadd ActionCueHT 4 $4  
          hadd ActionCueHT 5 $5
          hadd ActionCueHT 6 $6           
          hadd ActionCueHT 7 $7
          if ($2 == 2) || ($2 = 13) {
            %CuedGrab = $false
          }
        }
      }
      elseif (!%ActionDropCueFlag) { 
        if ($2 == 2) || ($2 = 13) {
          %ActionDropCueFlag = $true
          hadd ActionDropCueHT 1 $1
          hadd ActionDropCueHT 2 $2  
          hadd ActionDropCueHT 3 $3  
          hadd ActionDropCueHT 4 $4  
          hadd ActionDropCueHT 5 $5
          hadd ActionDropCueHT 6 $6  
          hadd ActionDropCueHT 7 $7
          %CuedGrab = $false
        }
      }
      return
    }
    elseif (!%ServerReady) && (%Server) {
      if (!%ActionDropCueFlag) {
        if ($2 == 2) || ($2 == 13) {
          %ActionDropCueFlag = $true
          hadd ActionDropCueHT 1 $1
          hadd ActionDropCueHT 2 $2  
          hadd ActionDropCueHT 3 $3  
          hadd ActionDropCueHT 4 $4  
          hadd ActionDropCueHT 5 $5
          hadd ActionDropCueHT 6 $6  
          hadd ActionDropCueHT 7 $7
          %ServerActionCued = $true
        }
      }
      return
    }
    elseif (!%ServerReady) && (!%Server) {
      if (!%ActionCueFlag) {
        if ($2 == 1) && (!%ActionDropCueFlag) { 
          %ActionCueFlag = $true
          hadd ActionCueHT 1 $1
          hadd ActionCueHT 2 $2  
          hadd ActionCueHT 3 $3  
          hadd ActionCueHT 4 $4  
          hadd ActionCueHT 5 $5
          hadd ActionCueHT 6 $6           
          hadd ActionCueHT 7 $7
          %CuedGrab = $true
          %AvoidRepeat = $false
        }
        elseif ($2 != 1)  {
          %ActionCueFlag = $true
          hadd ActionCueHT 1 $1
          hadd ActionCueHT 2 $2  
          hadd ActionCueHT 3 $3  
          hadd ActionCueHT 4 $4  
          hadd ActionCueHT 5 $5
          hadd ActionCueHT 6 $6           
          hadd ActionCueHT 7 $7
          if ($2 == 2) || ($2 = 13) {
            %CuedGrab = $false
          }
        }
      }
      elseif (!%ActionDropCueFlag) { 
        if ($2 == 2) || ($2 = 13) {
          %ActionDropCueFlag = $true
          hadd ActionDropCueHT 1 $1
          hadd ActionDropCueHT 2 $2  
          hadd ActionDropCueHT 3 $3  
          hadd ActionDropCueHT 4 $4  
          hadd ActionDropCueHT 5 $5
          hadd ActionDropCueHT 6 $6  
          hadd ActionDropCueHT 7 $7
          %CuedGrab = $false
        }
      }
      return
    }
  }
  if ($2 == 1) {
    if ($1 == %CurrentPlayer) {
      %CuedGrab = $false
    }
    if ($3 == 1) {
      hadd GrabbedXHT $1 $hget(CardCoordinateXHT,$4)
      hadd GrabbedYHT $1 $hget(CardCoordinateYHT,$4)
      drawgrab $1 1 $4
      hadd GrabbedFlagHT $1 $true
      hadd GrabbedTypeHT $1 1
      hadd GrabbedIDHT $1 $4
      hadd CardPlacementHT $4 1
      splay -w $+($mircdir,anycard\takecard.wav)
      drawtable
      drawfinal
    }
    elseif ($3 == 2) {
      hadd GrabbedXHT $1 $hget(CardCoordinateXHT,$hget(StackBottomsHT,$4))
      hadd GrabbedYHT $1 $hget(CardCoordinateYHT,$hget(StackBottomsHT,$4))
      drawgrab $1 2 $4
      hadd GrabbedFlagHT $1 $true
      hadd GrabbedTypeHT $1 2
      hadd GrabbedIDHT $1 $4      
      %tmp0 = $findtok(%Layers,$hget(StackBottomsHT,$4),1,46)
      %tmp1 = $findtok(%Layers,$hget(StackTopsHT,$4),1,46)
      while (%tmp0 <= %tmp1) {
        hadd CardPlacementHT $gettok(%Layers,%tmp0,46) 1
        inc %tmp0
      }
      splay -w $+($mircdir,anycard\takecard.wav)
      drawtable
      drawfinal
    }
    elseif ($3 == 3) {      
      hadd GrabbedFromHandHT $1 $true
      if ($1 == 1) {
        if ($hget(PlayerAngleHT,1) == 1) {
          hadd GrabbedXHT $1 $calc(95 + (($4 - 1) * 12))
          hadd GrabbedYHT $1 635
        }
        elseif ($hget(PlayerAngleHT,1) == 2) {
          hadd GrabbedXHT $1 65
          hadd GrabbedYHT $1 $calc(95 + (($4 - 1) * 12))
        }
        elseif ($hget(PlayerAngleHT,1) == 3) {
          hadd GrabbedXHT $1 $calc(563 - (($4 - 1) * 12))
          hadd GrabbedYHT $1 65
        }
        else {
          hadd GrabbedXHT $1 635
          hadd GrabbedYHT $1 $calc(593 - (($4 - 1) * 12))
        }
        hadd GrabbedFlagHT 1 $true
        hadd GrabbedTypeHT 1 1
        hadd GrabbedIDHT 1 $gettok(%HandPlayer1,$4,46)
        hadd CardPlacementHT $gettok(%HandPlayer1,$4,46) 1
        hadd CardAngleHT $gettok(%HandPlayer1,$4,46) $hget(PlayerAngleHT,1)
        drawgrab 1 1 $gettok(%HandPlayer1,$4,46)
        %HandPlayer1 = $deltok(%HandPlayer1,$4,46)
        splay -w $+($mircdir,anycard\takecard.wav)
        drawtable
        drawhand 1
        drawfinal
      }
      elseif ($1 == 2) {
        if ($hget(PlayerAngleHT,2) == 1) {
          hadd GrabbedXHT $1 $calc(95 + (($4 - 1) * 12))
          hadd GrabbedYHT $1 635
        }
        elseif ($hget(PlayerAngleHT,2) == 2) {
          hadd GrabbedXHT $1 65
          hadd GrabbedYHT $1 $calc(95 + (($4 - 1) * 12))
        }
        elseif ($hget(PlayerAngleHT,2) == 3) {
          hadd GrabbedXHT $1 $calc(563 - (($4 - 1) * 12))
          hadd GrabbedYHT $1 65
        }
        else {
          hadd GrabbedXHT $1 635
          hadd GrabbedYHT $1 $calc(593 - (($4 - 1) * 12))
        }
        hadd GrabbedFlagHT 2 $true
        hadd GrabbedTypeHT 2 1
        hadd GrabbedIDHT 2 $gettok(%HandPlayer2,$4,46)
        hadd CardPlacementHT $gettok(%HandPlayer2,$4,46) 1
        hadd CardAngleHT $gettok(%HandPlayer2,$4,46) $hget(PlayerAngleHT,2)
        drawgrab 2 1 $gettok(%HandPlayer2,$4,46)
        %HandPlayer2 = $deltok(%HandPlayer2,$4,46)
        splay -w $+($mircdir,anycard\takecard.wav)
        drawtable
        drawhand 2
        drawfinal
      }
      elseif ($1 == 3) {
        if ($hget(PlayerAngleHT,3) == 1) {
          hadd GrabbedXHT $1 $calc(95 + (($4 - 1) * 12))
          hadd GrabbedYHT $1 635
        }
        elseif ($hget(PlayerAngleHT,3) == 2) {
          hadd GrabbedXHT $1 65
          hadd GrabbedYHT $1 $calc(95 + (($4 - 1) * 12))
        }
        elseif ($hget(PlayerAngleHT,3) == 3) {
          hadd GrabbedXHT $1 $calc(563 - (($4 - 1) * 12))
          hadd GrabbedYHT $1 65
        }
        else {
          hadd GrabbedXHT $1 635
          hadd GrabbedYHT $1 $calc(593 - (($4 - 1) * 12))
        }
        hadd GrabbedFlagHT 3 $true
        hadd GrabbedTypeHT 3 1
        hadd GrabbedIDHT 3 $gettok(%HandPlayer3,$4,46)
        hadd CardPlacementHT $gettok(%HandPlayer3,$4,46) 1
        hadd CardAngleHT $gettok(%HandPlayer3,$4,46) $hget(PlayerAngleHT,3)
        drawgrab 3 1 $gettok(%HandPlayer3,$4,46)
        %HandPlayer3 = $deltok(%HandPlayer3,$4,46)
        splay -w $+($mircdir,anycard\takecard.wav)
        drawtable
        drawhand 3
        drawfinal
      }
      else {
        if ($hget(PlayerAngleHT,4) == 1) {
          hadd GrabbedXHT $1 $calc(95 + (($4 - 1) * 12))
          hadd GrabbedYHT $1 635
        }
        elseif ($hget(PlayerAngleHT,4) == 2) {
          hadd GrabbedXHT $1 65
          hadd GrabbedYHT $1 $calc(95 + (($4 - 1) * 12))
        }
        elseif ($hget(PlayerAngleHT,4) == 3) {
          hadd GrabbedXHT $1 $calc(563 - (($4 - 1) * 12))
          hadd GrabbedYHT $1 65
        }
        else {
          hadd GrabbedXHT $1 635
          hadd GrabbedYHT $1 $calc(593 - (($4 - 1) * 12))
        }
        hadd GrabbedFlagHT 4 $true
        hadd GrabbedTypeHT 4 1
        hadd GrabbedIDHT 4 $gettok(%HandPlayer4,$4,46)
        hadd CardPlacementHT $gettok(%HandPlayer4,$4,46) 1
        hadd CardAngleHT $gettok(%HandPlayer4,$4,46) $hget(PlayerAngleHT,4)
        drawgrab 4 1 $gettok(%HandPlayer4,$4,46)
        %HandPlayer4 = $deltok(%HandPlayer4,$4,46)
        splay -w $+($mircdir,anycard\takecard.wav)
        drawtable
        drawhand 4
        drawfinal
      }
    }
    elseif ($3 == 4) {
      %tmp0 = $hget(StackTopsHT,$4)
      hadd GrabbedXHT $1 $hget(CardCoordinateXHT,%tmp0)
      hadd GrabbedYHT $1 $hget(CardCoordinateYHT,%tmp0)
      drawgrab $1 1 %tmp0
      hadd GrabbedFromStackHT $1 $true
      hadd GrabbedFlagHT $1 $true
      hadd GrabbedTypeHT $1 1
      hadd GrabbedIDHT $1 %tmp0
      hadd CardPlacementHT %tmp0 1
      hadd CardStackHT %tmp0 0
      if ($hget(StackSizeHT,$4) == 1) {
        hadd CardStackHT $hget(StackBottomsHT,$4) 0       
        %Stacks = $remtok(%Stacks,$4,1,46)
      }
      else {
        hadd StackTopsHT $4 $gettok(%Layers,$calc($findtok(%Layers,$hget(StackTopsHT,$4),1,46) - 1),46)
        hadd StackSizeHT $4 $calc($hget(StackSizeHT,$4) - 1)
      }
      splay -w $+($mircdir,anycard\takecard.wav)
      drawtable
      drawfinal
    }
  }
  elseif ($2 == 2) {
    hadd GrabbedXHT $1 0
    if ($3 == 1) {
      if ($hget(GrabbedTypeHT,$1) == 1) {
        hadd GrabbedFlagHT $1 $false
        %tmp0 = $hget(GrabbedIDHT,$1)
        hadd CardCoordinateXHT %tmp0 $4
        hadd CardCoordinateYHT %tmp0 $5
        hadd CardPlacementHT %tmp0 0
        %Layers = $remtok(%Layers,%tmp0,1,46)
        %Layers = $addtok(%Layers,%tmp0,46)
        splay -w $+($mircdir,anycard\discard.wav)
        if ($hget(GrabbedFromStackHT,$1)) {
          actionnotify $1 6
          hadd GrabbedFromStackHT $1 $false
        }
        elseif ($hget(GrabbedFromHandHT,$1)) {
          actionnotify $1 3
          hadd GrabbedFromHandHT $1 $false
        }
        else {
          actionnotify $1 5
        }
        drawtable
        drawfinal
      }
      elseif ($hget(GrabbedTypeHT,$1) == 2) {
        hadd GrabbedFlagHT $1 $false
        %tmp3 = $findtok(%Layers,$hget(StackBottomsHT,$hget(GrabbedIDHT,$1)),1,46)
        %tmp0 = %tmp3
        %tmp1 = $findtok(%Layers,$hget(StackTopsHT,$hget(GrabbedIDHT,$1)),1,46)
        %tmp2 = $hget(CardCoordinateYHT,$gettok(%Layers,%tmp0,46))
        while (%tmp0 <= %tmp1) {
          hadd CardCoordinateXHT $gettok(%Layers,%tmp0,46) $4
          hadd CardCoordinateYHT $gettok(%Layers,%tmp0,46) $calc($5 - (%tmp2 - $hget(CardCoordinateYHT,$gettok(%Layers,%tmp0,46))))
          hadd CardPlacementHT $gettok(%Layers,%tmp0,46) 0
          inc %tmp0
        }
        %tmpstack = $gettok(%Layers,%tmp3 - %tmp1,46)
        %Layers = $deltok(%Layers,%tmp3 - %tmp1,46)
        %Layers = $addtok(%Layers,%tmpstack,46)
        splay -w $+($mircdir,anycard\discard.wav)
        actionnotify $1 7
        drawtable
        drawfinal
      }
    }
    elseif ($3 == 2) {
      if ($hget(GrabbedTypeHT,$1) == 1) {
        hadd GrabbedFlagHT $1 $false
        %tmp0 = $hget(GrabbedIDHT,$1)
        hadd CardCoordinateXHT %tmp0 $hget(CardCoordinateXHT,$4)
        hadd CardCoordinateYHT %tmp0 $calc($hget(CardCoordinateYHT,$4) - $int($calc(1 * %StackSpacing)))
        hadd CardAngleHT %tmp0 $hget(CardAngleHT,$4)
        hadd CardPlacementHT %tmp0 0
        %Layers = $remtok(%Layers,$4,1,46)
        %Layers = $addtok(%Layers,$4,46)
        %Layers = $remtok(%Layers,%tmp0,1,46)
        %Layers = $addtok(%Layers,%tmp0,46)
        %tmp1 = 1
        while ($istok(%Stacks,%tmp1,46)) {
          inc %tmp1
        }
        %Stacks = $addtok(%Stacks,%tmp1,46)
        hadd StackBottomsHT %tmp1 $4
        hadd StackTopsHT %tmp1 %tmp0
        hadd StackSizeHT %tmp1 1
        hadd CardStackHT %tmp0 %tmp1
        hadd CardStackHT $4 %tmp1
        hadd GrabbedFromHandHT $1 $false
        hadd GrabbedFromStackHT $1 $false
        splay -w $+($mircdir,anycard\discard.wav)
        actionnotify $1 6
        drawtable
        drawfinal
      }
      elseif ($hget(GrabbedTypeHT,$1) == 2) {
        hadd GrabbedFlagHT $1 $false
        %tmp3 = $findtok(%Layers,$hget(StackBottomsHT,$hget(GrabbedIDHT,$1)),1,46)
        %tmp0 = %tmp3
        %tmp1 = $findtok(%Layers,$hget(StackTopsHT,$hget(GrabbedIDHT,$1)),1,46)
        %tmp2 = $hget(CardCoordinateYHT,$gettok(%Layers,%tmp0,46))
        %tmp4 = $hget(CardCoordinateXHT,$4)
        %tmp5 = $hget(CardCoordinateYHT,$4)
        while (%tmp0 <= %tmp1) {
          hadd CardCoordinateXHT $gettok(%Layers,%tmp0,46) %tmp4
          hadd CardCoordinateYHT $gettok(%Layers,%tmp0,46) $calc(%tmp5 - $int($calc(((%tmp0 - %tmp3) + 1) * %StackSpacing)))
          hadd CardPlacementHT $gettok(%Layers,%tmp0,46) 0
          inc %tmp0
        }
        hadd StackSizeHT $hget(GrabbedIDHT,$1) $calc($hget(StackSizeHT,$hget(GrabbedIDHT,$1)) + 1)
        hadd CardStackHT $4 $hget(GrabbedIDHT,$1)
        hadd CardAngleHT $4 $hget(CardAngleHT,$gettok(%Layers,%tmp3,46))
        %Layers = $remtok(%Layers,$4,1,46)
        %Layers = $addtok(%Layers,$4,46)
        %tmp3 = $findtok(%Layers,$hget(StackBottomsHT,$hget(GrabbedIDHT,$1)),1,46)
        %tmp1 = $findtok(%Layers,$hget(StackTopsHT,$hget(GrabbedIDHT,$1)),1,46)
        hadd StackBottomsHT $hget(GrabbedIDHT,$1) $4
        %tmpstack = $gettok(%Layers,%tmp3 - %tmp1,46)
        %Layers = $deltok(%Layers,%tmp3 - %tmp1,46)
        %Layers = $addtok(%Layers,%tmpstack,46)
        splay -w $+($mircdir,anycard\discard.wav)
        actionnotify $1 6
        drawtable
        drawfinal
      }
    }
    elseif ($3 == 3) {
      if ($hget(GrabbedTypeHT,$1) == 1) {
        hadd GrabbedFlagHT $1 $false
        %tmp0 = $findtok(%Layers,$hget(StackBottomsHT,$4),1,46)
        %tmp1 = $findtok(%Layers,$hget(StackTopsHT,$4),1,46)
        %tmpstack = $gettok(%Layers,%tmp0 - %tmp1,46)
        %Layers = $deltok(%Layers,%tmp0 - %tmp1,46)
        %Layers = $addtok(%Layers,%tmpstack,46)
        hadd CardStackHT $hget(GrabbedIDHT,$1) $4
        hadd CardPlacementHT $hget(GrabbedIDHT,$1) 0
        hadd CardAngleHT $hget(GrabbedIDHT,$1) $hget(CardAngleHT,$hget(StackBottomsHT,$4))
        %Layers = $remtok(%Layers,$hget(GrabbedIDHT,$1),1,46)
        %Layers = $addtok(%Layers,$hget(GrabbedIDHT,$1),46)
        hadd CardCoordinateXHT $hget(GrabbedIDHT,$1) $hget(CardCoordinateXHT,$hget(StackTopsHT,$4))
        hadd CardCoordinateYHT $hget(GrabbedIDHT,$1) $calc($hget(CardCoordinateYHT,$hget(StackBottomsHT,$4)) - $int($calc(($hget(StackSizeHT,$4) + 1) * %StackSpacing)))
        hadd StackSizeHT $4 $calc($hget(StackSizeHT,$4) + 1)
        hadd StackTopsHT $4 $hget(GrabbedIDHT,$1)
        hadd GrabbedFromHandHT $1 $false
        hadd GrabbedFromStackHT $1 $false
        splay -w $+($mircdir,anycard\discard.wav)
        actionnotify $1 6
        drawtable
        drawfinal
      }
      if ($hget(GrabbedTypeHT,$1) == 2) {
        hadd GrabbedFlagHT $1 $false
        %tmp0 = $findtok(%Layers,$hget(StackBottomsHT,$4),1,46)
        %tmp1 = $findtok(%Layers,$hget(StackTopsHT,$4),1,46)
        %tmpstack = $gettok(%Layers,%tmp0 - %tmp1,46)
        %Layers = $deltok(%Layers,%tmp0 - %tmp1,46)
        %Layers = $addtok(%Layers,%tmpstack,46)
        %tmp3 = $hget(GrabbedIDHT,$1)
        %tmp0 = $findtok(%Layers,$hget(StackBottomsHT,%tmp3),1,46)
        %tmp2 = %tmp0
        %tmp1 = $findtok(%Layers,$hget(StackTopsHT,%tmp3),1,46)
        %tmp4 = $hget(StackSizeHT,$4)
        %tmp5 = $hget(StackSizeHT,%tmp3)
        hadd StackSizeHT $4 $calc(%tmp4 + %tmp5 + 1)
        hadd StackTopsHT $4 $hget(StackTopsHT,%tmp3)
        while (%tmp0 <= %tmp1) {
          hadd CardStackHT $gettok(%Layers,%tmp0,46) $4
          hadd CardPlacementHT $gettok(%Layers,%tmp0,46) 0
          hadd CardAngleHT $gettok(%Layers,%tmp0,46) $hget(CardAngleHT,$hget(StackBottomsHT,$4))
          hadd CardCoordinateXHT $gettok(%Layers,%tmp0,46) $hget(CardCoordinateXHT,$hget(StackBottomsHT,$4))
          hadd CardCoordinateYHT $gettok(%Layers,%tmp0,46) $&
            $calc($hget(CardCoordinateYHT,$hget(StackBottomsHT,$4)) - $int($calc(((%tmp4 + (%tmp0 - %tmp2)) + 1) * %StackSpacing)))
          inc %tmp0
        }
        %tmpstack = $gettok(%Layers,%tmp2 - %tmp1,46)
        %Layers = $deltok(%Layers,%tmp2 - %tmp1,46)
        %Layers = $addtok(%Layers,%tmpstack,46)
        %Stacks = $deltok(%Stacks,$findtok(%Stacks,%tmp3,1,46),46)
        splay -w $+($mircdir,anycard\discard.wav)
        actionnotify $1 8
        drawtable
        drawfinal
      }
    }
    elseif ($3 == 4) {
      if ($hget(GrabbedTypeHT,$1) == 1) {
        hadd GrabbedFlagHT $1 $false
        hadd CardPlacementHT $hget(GrabbedIDHT,$1) 2
        hadd CardFlipFlagHT $hget(GrabbedIDHT,$1) 0
        if ($1 == 1) {
          if ($numtok(%HandPlayer1,46) >= $4) {
            %HandPlayer1 = $instok(%HandPlayer1,$hget(GrabbedIDHT,1),$4,46)
          }
          else {
            %HandPlayer1 = $addtok(%HandPlayer1,$hget(GrabbedIDHT,1),46)
          }
        }
        elseif ($1 == 2) {
          if ($numtok(%HandPlayer2,46) >= $4) {
            %HandPlayer2 = $instok(%HandPlayer2,$hget(GrabbedIDHT,2),$4,46)
          }
          else {
            %HandPlayer2 = $addtok(%HandPlayer2,$hget(GrabbedIDHT,2),46)
          }
        }
        elseif ($1 == 3) {
          if ($numtok(%HandPlayer3,46) >= $4) {
            %HandPlayer3 = $instok(%HandPlayer3,$hget(GrabbedIDHT,3),$4,46)
          }
          else {
            %HandPlayer3 = $addtok(%HandPlayer3,$hget(GrabbedIDHT,3),46)
          }
        }
        else {
          if ($numtok(%HandPlayer4,46) >= $4) {
            %HandPlayer4 = $instok(%HandPlayer4,$hget(GrabbedIDHT,4),$4,46)
          }
          else {
            %HandPlayer4 = $addtok(%HandPlayer4,$hget(GrabbedIDHT,4),46)
          }
        }
        hadd GrabbedFromHandHT $1 $false
        hadd GrabbedFromStackHT $1 $false
        actionnotify $1 3
        drawhand $1
        drawtable
        drawfinal       
      }
      elseif ($hget(GrabbedTypeHT,$1) == 2) {
        hadd GrabbedFlagHT $1 $false
        %tmp2 = $hget(GrabbedIDHT,$1)
        %tmp0 = $findtok(%Layers,$hget(StackBottomsHT,%tmp2),1,46)
        %tmp1 = $findtok(%Layers,$hget(StackTopsHT,%tmp2),1,46)
        %tmphand = $gettok(%Layers,%tmp0 - %tmp1,46)
        while (%tmp0 <= %tmp1) {
          hadd CardPlacementHT $gettok(%Layers,%tmp0,46) 2
          hadd CardFlipFlagHT $gettok(%Layers,%tmp0,46) 0
          hadd CardStackHT $gettok(%Layers,%tmp0,46) 0
          inc %tmp0
        }
        %Stacks = $deltok(%Stacks,$findtok(%Stacks,%tmp2,1,46),46)
        if ($1 == 1) {
          if ($numtok(%HandPlayer1,46) >= $4) {
            %HandPlayer1 = $instok(%HandPlayer1,%tmphand,$4,46)
          }
          else {
            %HandPlayer1 = $addtok(%HandPlayer1,%tmphand,46)
          }
        }
        elseif ($1 == 2) {
          if ($numtok(%HandPlayer2,46) >= $4) {
            %HandPlayer2 = $instok(%HandPlayer2,%tmphand,$4,46)
          }
          else {
            %HandPlayer2 = $addtok(%HandPlayer2,%tmphand,46)
          }
        }
        elseif ($1 == 3) {
          if ($numtok(%HandPlayer3,46) >= $4) {
            %HandPlayer3 = $instok(%HandPlayer3,%tmphand,$4,46)
          }
          else {
            %HandPlayer3 = $addtok(%HandPlayer3,%tmphand,46)
          }
        }
        else {
          if ($numtok(%HandPlayer4,46) >= $4) {
            %HandPlayer4 = $instok(%HandPlayer4,%tmphand,$4,46)
          }
          else {
            %HandPlayer4 = $addtok(%HandPlayer4,%tmphand,46)
          }
        }
        actionnotify $1 4
        drawhand $1
        drawtable
        drawfinal       
      }
    }
  }
  elseif ($2 == 3) {
    if ($3 == 1) {
      %tmp0 = $hget(CardAngleHT,$4)
      if (%tmp0 < 4) {
        inc %tmp0
      }
      else {
        %tmp0 = 1
      }
      hadd CardAngleHT $4 %tmp0
      actionnotify $1 11
      drawtable
      drawfinal      
    }
    elseif ($3 == 2) {
      %tmp1 = $findtok(%Layers,$hget(StackBottomsHT,$4),1,46)
      %tmp2 = $findtok(%Layers,$hget(StackTopsHT,$4),1,46)
      %tmp0 = $hget(CardAngleHT,$hget(StackBottomsHT,$4))
      if (%tmp0 < 4) {
        inc %tmp0
      }
      else {
        %tmp0 = 1
      }
      while (%tmp1 <= %tmp2) {
        hadd CardAngleHT $gettok(%Layers,%tmp1,46) %tmp0
        inc %tmp1
      }
      actionnotify $1 12
      drawtable
      drawfinal
    }
  }
  elseif ($2 == 4) {
    if ($3 == 1) {
      %tmp0 = $hget(CardFlipFlagHT,$4)
      if (%tmp0 == 1) {
        %tmp0 = 0
      }
      else {
        %tmp0 = 1
      }
      hadd CardFlipFlagHT $4 %tmp0
      splay -w $+($mircdir,anycard\takecard.wav)
      actionnotify $1 9
      if ($hget(GrabbedFlagHT,$1)) {
        drawgrab $1 1 $4
      }
      drawtable
      drawfinal      
    }
    elseif ($3 == 2) {
      %tmp1 = $findtok(%Layers,$hget(StackBottomsHT,$4),1,46)
      %tmp4 = %tmp1
      %tmp2 = $findtok(%Layers,$hget(StackTopsHT,$4),1,46)
      while (%tmp1 <= %tmp2) {
        %tmp0 = $hget(CardFlipFlagHT,$gettok(%Layers,%tmp1,46))
        if (%tmp0 == 1) {
          %tmp0 = 0
        }
        else {
          %tmp0 = 1
        }
        hadd CardFlipFlagHT $gettok(%Layers,%tmp1,46) %tmp0
        inc %tmp1
      }
      %tmp1 = %tmp4
      while ($calc(%tmp1 - %tmp4) <= $int($calc($hget(StackSizeHT,$4) / 2))) {
        %tmp3 = $hget(CardCoordinateYHT,$gettok(%Layers,%tmp1,46))
        hadd CardCoordinateYHT $gettok(%Layers,%tmp1,46) $hget(CardCoordinateYHT,$gettok(%Layers,$calc(%tmp2 - (%tmp1 - %tmp4)),46))
        hadd CardCoordinateYHT $gettok(%Layers,$calc(%tmp2 - (%tmp1 - %tmp4)),46) %tmp3
        %tmp3 = $gettok(%Layers,%tmp1,46)
        %Layers = $puttok(%Layers,$gettok(%Layers,$calc(%tmp2 - (%tmp1 - %tmp4)),46),%tmp1,46)
        %Layers = $puttok(%Layers,%tmp3,$calc(%tmp2 - (%tmp1 - %tmp4)),46)
        inc %tmp1
      }
      %tmp0 = $hget(StackBottomsHT,$4)
      hadd StackBottomsHT $4 $hget(StackTopsHT,$4)
      hadd StackTopsHT $4 %tmp0
      splay -w $+($mircdir,anycard\takecard.wav)
      actionnotify $1 10
      drawtable
      drawfinal
    }   
  }
  elseif ($2 == 5) {
    if (%CurrentPlayer != $1) {
      splay -w $+($mircdir,anycard\takecard.wav)
    }
    actionnotify $1 13
    drawfinal
  }
  elseif ($2 == 6) {
    if ($3 == 1) {
      %tmp0 = $hget(CardPossessionHT,$4)
      if (%tmp0 == $1) {
        %tmp0 = 0
        %Claimed = $remtok(%Claimed,$4,1,46)
      }
      else {
        %tmp0 = $1
        %Claimed = $addtok(%Claimed,$4,46)
      }
      hadd CardPossessionHT $4 %tmp0
      actionnotify $1 1
      drawtable
      drawfinal      
    }
    elseif ($3 == 2) {
      %tmp1 = $findtok(%Layers,$hget(StackBottomsHT,$4),1,46)
      %tmp2 = $findtok(%Layers,$hget(StackTopsHT,$4),1,46)
      %tmp0 = $hget(CardPossessionHT,$hget(StackBottomsHT,$4))
      if (%tmp0 == $1) {
        %tmp0 = 0
        %Claimed = $remtok(%Claimed,$hget(StackBottomsHT,$4),1,46)
      }
      else {
        %tmp0 = $1
        %Claimed = $addtok(%Claimed,$hget(StackBottomsHT,$4),46)
      }
      while (%tmp1 <= %tmp2) {
        hadd CardPossessionHT $gettok(%Layers,%tmp1,46) %tmp0
        inc %tmp1
      }
      actionnotify $1 2
      drawtable
      drawfinal
    }
  }
  elseif ($2 == 7) {
    %tmp0 = $hget(GrabbedIDHT,$1)
    %tmp1 = $findtok(%Layers,$hget(StackBottomsHT,%tmp0),1,46)
    %tmp2 = $findtok(%Layers,$hget(StackTopsHT,%tmp0),1,46)
    %tmpstack = $gettok(%Layers,%tmp1 - %tmp2,46)
    %tmp3 = $3
    if (%tmp3 > $calc($hget(StackSizeHT,%tmp0) + 1)) {
      %tmp3 = $calc($hget(StackSizeHT,%tmp0) + 1)
    }
    while (%tmp3 > 0) {
      %tmp4 = 1
      while ($calc(%tmp4 * %tmp3) <= $calc($hget(StackSizeHT,%tmp0) + 1)) {
        %tmpstack2 = $addtok(%tmpstack2,$gettok(%tmpstack,$calc(%tmp4 * %tmp3),46),46)
        inc %tmp4
      }
      dec %tmp3
    }
    %tmpstack = %tmpstack2
    %tmpstack2 = $deltok(%tmpstack2,1 - $numtok(%tmpstack2,46),46)
    %tmp3 = $4
    if (%tmp3 > $calc($hget(StackSizeHT,%tmp0) + 1)) {
      %tmp3 = $calc($hget(StackSizeHT,%tmp0) + 1)
    }
    while (%tmp3 > 0) {
      %tmp4 = 1
      while ($calc(%tmp4 * %tmp3) <= $calc($hget(StackSizeHT,%tmp0) + 1)) {
        %tmpstack2 = $addtok(%tmpstack2,$gettok(%tmpstack,$calc(%tmp4 * %tmp3),46),46)
        inc %tmp4
      }
      dec %tmp3
    }
    if ($gettok(%tmpstack2,$numtok(%tmpstack2,46),46) == $gettok(%Layers,%tmp2,46)) && ($numtok(%tmpstack2,46) >= 7) {
      %tmp3 = $gettok(%tmpstack2,$numtok(%tmpstack2,46),46)
      %tmpstack2 = $deltok(%tmpstack2,$numtok(%tmpstack2,46),46)
      %tmpstack2 = $instok(%tmpstack2,%tmp3,$4,46)
    }
    %tmpstack = $deltok(%tmpstack,1 - $numtok(%tmpstack,46),46)
    %tmp3 = 1
    while (%tmp3 <= $numtok(%tmpstack2,46)) {
      %tmpstack = $addtok(%tmpstack,0,46)
      %tmpstack = $puttok(%tmpstack,$hget(CardCoordinateYHT,$gettok(%Layers,$calc(%tmp1 + %tmp3 - 1),46)),%tmp3,46) 
      inc %tmp3
    }
    %tmp3 = 1
    while (%tmp3 <= $numtok(%tmpstack2,46)) {
      hadd CardCoordinateYHT $gettok(%tmpstack2,%tmp3,46) $gettok(%tmpstack,%tmp3,46)
      inc %tmp3
    }
    %Layers = $deltok(%Layers,%tmp1 - %tmp2,46)
    %Layers = $instok(%Layers,%tmpstack2,%tmp1,46)
    hadd StackBottomsHT %tmp0 $gettok(%tmpstack2,1,46)
    hadd StackTopsHT %tmp0 $gettok(%tmpstack2,$numtok(%tmpstack2,46),46)
    splay -w $+($mircdir,anycard\shuffle.wav)
    drawgrab $1 2 $hget(GrabbedIDHT,$1)
    actionnotify $1 14
    drawfinal
  }
  elseif ($2 == 8) {
    splay -w $+($mircdir,anycard\knock.wav)
    actionnotify $1 15
    drawfinal
  }
  elseif ($2 == 9) {
    if (%Server) {
      if ($1 == 1) {
        %Purgable1 = $false
      }
      elseif ($1 == 2) {
        %Purgable2 = $false
      }
      elseif ($1 == 3) {
        %Purgable3 = $false
      }
      else {
        %Purgable4 = $false
      }
    }
    if (%CurrentPlayer != $1) {
      hadd ConnectedPlayerIPHT $1 $3
      hadd PlayerFlagHT $1 1
      splay -w $+($mircdir,anycard\newuser.wav)
      actionnotify $1 17
      drawfinal
    }
  }
  elseif ($2 == 10) {
    actionnotify $1 18
    drawfinal
  }
  elseif ($2 == 11) {
    hadd PlayerFlagHT $1 0
    splay -w $+($mircdir,anycard\userdc.wav)
    actionnotify $1 19
    if (%Server) {
      if ($1 == 1) {
        if ($numtok(%HandPlayer1,46) > 0) {
          %Purgable1 = $true
        }
        %tmp0 = 1
        %tmp1 = $false
        if ($numtok(%Claimed,46) > 0) {
          while (%tmp0 <= $numtok(%Claimed,46)) && (!%tmp1) {
            if ($hget(CardPossessionHT,$gettok(%Claimed,%tmp0,46)) == 1) {
              %tmp1 = $true
            }
            inc %tmp0
          }
        }
        if (%tmp1) {
          %purgable1 = $true
        }
      }
      elseif ($1 == 2) {
        if ($numtok(%HandPlayer2,46) > 0) {
          %Purgable2 = $true
        }
        %tmp0 = 1
        %tmp1 = $false
        if ($numtok(%Claimed,46) > 0) {
          while (%tmp0 <= $numtok(%Claimed,46)) && (!%tmp1) {
            if ($hget(CardPossessionHT,$gettok(%Claimed,%tmp0,46)) == 2) {
              %tmp1 = $true
            }
            inc %tmp0
          }
        }
        if (%tmp1) {
          %purgable2 = $true
        }
      }
      elseif ($1 == 3) {
        if ($numtok(%HandPlayer3,46) > 0) {
          %Purgable3 = $true
        }
        %tmp0 = 1
        %tmp1 = $false
        if ($numtok(%Claimed,46) > 0) {
          while (%tmp0 <= $numtok(%Claimed,46)) && (!%tmp1) {
            if ($hget(CardPossessionHT,$gettok(%Claimed,%tmp0,46)) == 3) {
              %tmp1 = $true
            }
            inc %tmp0
          }
        }
        if (%tmp1) {
          %purgable3 = $true
        }
      }
      elseif ($1 == 4) {
        if ($numtok(%HandPlayer4,46) > 0) {
          %Purgable4 = $true
        }
        %tmp0 = 1
        %tmp1 = $false
        if ($numtok(%Claimed,46) > 0) {
          while (%tmp0 <= $numtok(%Claimed,46)) && (!%tmp1) {
            if ($hget(CardPossessionHT,$gettok(%Claimed,%tmp0,46)) == 4) {
              %tmp1 = $true
            }
            inc %tmp0
          }
        }
        if (%tmp1) {
          %purgable4 = $true
        }
      }
    }
    drawfinal
  }
  elseif ($2 == 12) {
    hadd PlayerReadyFlagHT $1 $not($hget(PlayerReadyFlagHT,$1))
    drawfinal
  }
  elseif ($2 == 13) {
    hadd GrabbedXHT $1 0
    if ($hget(GrabbedTypeHT,$1) == 1) {
      hadd GrabbedFlagHT $1 $false
      %tmp0 = $hget(GrabbedIDHT,$1)
      if ($hget(GrabbedFromHandHT,$1)) {
        hadd CardPlacementHT %tmp0 2
        if ($1 == 1) {
          %HandPlayer1 = $addtok(%HandPlayer1,%tmp0,46)
        }
        elseif ($1 == 2) {
          %HandPlayer2 = $addtok(%HandPlayer2,%tmp0,46)
        }
        elseif ($1 == 3) {
          %HandPlayer3 = $addtok(%HandPlayer3,%tmp0,46)
        }
        else {
          %HandPlayer4 = $addtok(%HandPlayer4,%tmp0,46)
        }
        hadd CardFlipFlagHT $hget(GrabbedIDHT,$1) 0
        hadd GrabbedFromHandHT $1 $false
        drawhand $1
      }
      else {
        hadd CardPlacementHT %tmp0 0
        drawtable
      }
      hadd GrabbedFromStackHT $1 $false
      actionnotify $1 16
      drawfinal
    }
    elseif ($hget(GrabbedTypeHT,$1) == 2) {
      hadd GrabbedFlagHT $1 $false
      %tmp0 = $hget(GrabbedIDHT,$1)
      %tmp1 = $findtok(%Layers,$hget(StackBottomsHT,%tmp0),1,46)
      %tmp2 = $findtok(%Layers,$hget(StackTopsHT,%tmp0),1,46)
      while (%tmp1 <= %tmp2) {
        hadd CardPlacementHT $gettok(%Layers,%tmp1,46) 0
        inc %tmp1
      }
      drawtable
      actionnotify $1 16
      drawfinal
    }
  }
  elseif ($2 == 14) {
    if ($3) {
      if ($numtok(%Claimed,46) > 0) {
        %tmp0 = 1
        %tmp5 = $null
        while (%tmp0 <= $numtok(%Claimed,46)) {
          %tmp4 = $gettok(%Claimed,%tmp0,46)
          if ($hget(CardPossessionHT,%tmp4) == 1) {
            if ($hget(CardStackHT,%tmp4) == 0) {
              %tmp5 = $addtok(%tmp5,%tmp4,46)
              hadd CardPossessionHT %tmp4 0             
            }
            else {
              %tmp5 = $addtok(%tmp5,%tmp4,46)
              %tmp3 = $hget(CardStackHT,%tmp4)
              %tmp1 = $findtok(%Layers,$hget(StackBottomsHT,%tmp3),1,46)
              %tmp2 = $findtok(%Layers,$hget(StackTopsHT,%tmp3),1,46)
              while (%tmp1 <= %tmp2) {
                hadd CardPossessionHT $gettok(%Layers,%tmp1,46) 0
                inc %tmp1
              }              
            } 
          }
          inc %tmp0
        }  
        %tmp0 = 1
        while (%tmp0 <= $numtok(%tmp5,46)) {
          %Claimed = $remtok(%Claimed,$gettok(%tmp5,%tmp0,46),1,46)
          inc %tmp0
        }
      }
      if ($numtok(%HandPlayer1,46) > 0) {
        if ($hget(PlayerAngleHT,1) = 2) {
          %tmpx = 105
          %tmpy = 350
          %tmpangle = 3
        }
        elseif ($hget(PlayerAngleHT,1) = 3) {
          %tmpx = 350
          %tmpy = 105
          %tmpangle = 2
        }
        else {
          %tmpx = 595
          %tmpy = 350
          %tmpangle = 1
        }
        %tmp0 = 1
        %tmp1 = $numtok(%HandPlayer1,46)
        if (%tmp1 > 1) {
          %tmp2 = $true
          %tmp3 = 1
          while ($istok(%Stacks,%tmp3,46)) {
            inc %tmp3
          }
          %Stacks = $addtok(%Stacks,%tmp3,46)
          hadd StackTopsHT %tmp3 $gettok(%HandPlayer1,%tmp1,46)
          hadd StackBottomsHT %tmp3 $gettok(%HandPlayer1,1,46)
          hadd StackSizeHT %tmp3 %tmp1
        }
        else {
          %tmp2 = $false
        }
        while (%tmp0 <= %tmp1) {
          %tmp4 = $gettok(%HandPlayer1,%tmp0,46)
          hadd CardPlacementHT %tmp4 0
          hadd CardAngleHT %tmp4 %tmpangle
          hadd CardFlipFlagHT %tmp4 1
          hadd CardCoordinateXHT %tmp4 %tmpx
          if (%tmp2) {
            hadd CardCoordinateXHT %tmp4 %tmpx
            hadd CardCoordinateYHT %tmp4 $calc(%tmpy - $int($calc((%tmp0 - 1) * %StackSpacing)))
            hadd CardStackHT %tmp4 %tmp3
          }
          else {
            hadd CardCoordinateYHT %tmp4 %tmpy
          }
          %Layers = $remtok(%Layers,%tmp4,1,46)
          %Layers = $addtok(%Layers,%tmp4,46)         
          inc %tmp0 
        }
        %HandPlayer1 = $null
        drawhand 1       
      }
      if (%Server) {
        %Purgable1 = $false
      } 
    }
    if ($4) {
      if ($numtok(%Claimed,46) > 0) {
        %tmp0 = 1
        %tmp5 = $null
        while (%tmp0 <= $numtok(%Claimed,46)) {
          %tmp4 = $gettok(%Claimed,%tmp0,46)
          if ($hget(CardPossessionHT,%tmp4) == 2) {
            if ($hget(CardStackHT,%tmp4) == 0) {
              %tmp5 = $addtok(%tmp5,%tmp4,46)
              hadd CardPossessionHT %tmp4 0             
            }
            else {
              %tmp5 = $addtok(%tmp5,%tmp4,46)
              %tmp3 = $hget(CardStackHT,%tmp4)
              %tmp1 = $findtok(%Layers,$hget(StackBottomsHT,%tmp3),1,46)
              %tmp2 = $findtok(%Layers,$hget(StackTopsHT,%tmp3),1,46)
              while (%tmp1 <= %tmp2) {
                hadd CardPossessionHT $gettok(%Layers,%tmp1,46) 0
                inc %tmp1
              }              
            } 
          }
          inc %tmp0
        }  
        %tmp0 = 1
        while (%tmp0 <= $numtok(%tmp5,46)) {
          %Claimed = $remtok(%Claimed,$gettok(%tmp5,%tmp0,46),1,46)
          inc %tmp0
        }
      }
      if ($numtok(%HandPlayer2,46) > 0) {
        if ($hget(PlayerAngleHT,2) = 2) {
          %tmpx = 105
          %tmpy = 350
          %tmpangle = 3
        }
        elseif ($hget(PlayerAngleHT,2) = 3) {
          %tmpx = 350
          %tmpy = 105
          %tmpangle = 2
        }
        else {
          %tmpx = 595
          %tmpy = 350
          %tmpangle = 1
        }
        %tmp0 = 1
        %tmp1 = $numtok(%HandPlayer2,46)
        if (%tmp1 > 1) {
          %tmp2 = $true
          %tmp3 = 1
          while ($istok(%Stacks,%tmp3,46)) {
            inc %tmp3
          }
          %Stacks = $addtok(%Stacks,%tmp3,46)
          hadd StackTopsHT %tmp3 $gettok(%HandPlayer2,%tmp1,46)
          hadd StackBottomsHT %tmp3 $gettok(%HandPlayer2,1,46)
          hadd StackSizeHT %tmp3 %tmp1
        }
        else {
          %tmp2 = $false
        }
        while (%tmp0 <= %tmp1) {
          %tmp4 = $gettok(%HandPlayer2,%tmp0,46)
          hadd CardPlacementHT %tmp4 0
          hadd CardAngleHT %tmp4 %tmpangle
          hadd CardFlipFlagHT %tmp4 1
          hadd CardCoordinateXHT %tmp4 %tmpx
          if (%tmp2) {
            hadd CardCoordinateXHT %tmp4 %tmpx
            hadd CardCoordinateYHT %tmp4 $calc(%tmpy - $int($calc((%tmp0 - 1) * %StackSpacing)))
            hadd CardStackHT %tmp4 %tmp3
          }
          else {
            hadd CardCoordinateYHT %tmp4 %tmpy
          }
          %Layers = $remtok(%Layers,%tmp4,1,46)
          %Layers = $addtok(%Layers,%tmp4,46)         
          inc %tmp0 
        }
        %HandPlayer2 = $null
        drawhand 2       
      }
      if (%Server) {
        %Purgable2 = $false
      } 
    }
    if ($5) {
      if ($numtok(%Claimed,46) > 0) {
        %tmp0 = 1
        %tmp5 = $null
        while (%tmp0 <= $numtok(%Claimed,46)) {
          %tmp4 = $gettok(%Claimed,%tmp0,46)
          if ($hget(CardPossessionHT,%tmp4) == 3) {
            if ($hget(CardStackHT,%tmp4) == 0) {
              %tmp5 = $addtok(%tmp5,%tmp4,46)
              hadd CardPossessionHT %tmp4 0             
            }
            else {
              %tmp5 = $addtok(%tmp5,%tmp4,46)
              %tmp3 = $hget(CardStackHT,%tmp4)
              %tmp1 = $findtok(%Layers,$hget(StackBottomsHT,%tmp3),1,46)
              %tmp2 = $findtok(%Layers,$hget(StackTopsHT,%tmp3),1,46)
              while (%tmp1 <= %tmp2) {
                hadd CardPossessionHT $gettok(%Layers,%tmp1,46) 0
                inc %tmp1
              }              
            } 
          }
          inc %tmp0
        }  
        %tmp0 = 1
        while (%tmp0 <= $numtok(%tmp5,46)) {
          %Claimed = $remtok(%Claimed,$gettok(%tmp5,%tmp0,46),1,46)
          inc %tmp0
        }
      }
      if ($numtok(%HandPlayer3,46) > 0) {
        if ($hget(PlayerAngleHT,3) = 2) {
          %tmpx = 105
          %tmpy = 350
          %tmpangle = 3
        }
        elseif ($hget(PlayerAngleHT,3) = 3) {
          %tmpx = 350
          %tmpy = 105
          %tmpangle = 2
        }
        else {
          %tmpx = 595
          %tmpy = 350
          %tmpangle = 1
        }
        %tmp0 = 1
        %tmp1 = $numtok(%HandPlayer3,46)
        if (%tmp1 > 1) {
          %tmp2 = $true
          %tmp3 = 1
          while ($istok(%Stacks,%tmp3,46)) {
            inc %tmp3
          }
          %Stacks = $addtok(%Stacks,%tmp3,46)
          hadd StackTopsHT %tmp3 $gettok(%HandPlayer3,%tmp1,46)
          hadd StackBottomsHT %tmp3 $gettok(%HandPlayer3,1,46)
          hadd StackSizeHT %tmp3 %tmp1
        }
        else {
          %tmp2 = $false
        }
        while (%tmp0 <= %tmp1) {
          %tmp4 = $gettok(%HandPlayer3,%tmp0,46)
          hadd CardPlacementHT %tmp4 0
          hadd CardAngleHT %tmp4 %tmpangle
          hadd CardFlipFlagHT %tmp4 1
          hadd CardCoordinateXHT %tmp4 %tmpx
          if (%tmp2) {
            hadd CardCoordinateYHT %tmp4 $calc(%tmpy - $int($calc((%tmp0 - 1) * %StackSpacing)))
            hadd CardStackHT %tmp4 %tmp3
          }
          else {
            hadd CardCoordinateYHT %tmp4 %tmpy
          }
          %Layers = $remtok(%Layers,%tmp4,1,46)
          %Layers = $addtok(%Layers,%tmp4,46)         
          inc %tmp0 
        }
        %HandPlayer3 = $null
        drawhand 3       
      }
      if (%Server) {
        %Purgable3 = $false
      } 
    }
    if ($6) {
      if ($numtok(%Claimed,46) > 0) {
        %tmp0 = 1
        %tmp5 = $null
        while (%tmp0 <= $numtok(%Claimed,46)) {
          %tmp4 = $gettok(%Claimed,%tmp0,46)
          if ($hget(CardPossessionHT,%tmp4) == 4) {
            if ($hget(CardStackHT,%tmp4) == 0) {
              %tmp5 = $addtok(%tmp5,%tmp4,46)
              hadd CardPossessionHT %tmp4 0             
            }
            else {
              %tmp5 = $addtok(%tmp5,%tmp4,46)
              %tmp3 = $hget(CardStackHT,%tmp4)
              %tmp1 = $findtok(%Layers,$hget(StackBottomsHT,%tmp3),1,46)
              %tmp2 = $findtok(%Layers,$hget(StackTopsHT,%tmp3),1,46)
              while (%tmp1 <= %tmp2) {
                hadd CardPossessionHT $gettok(%Layers,%tmp1,46) 0
                inc %tmp1
              }              
            } 
          }
          inc %tmp0
        }  
        %tmp0 = 1
        while (%tmp0 <= $numtok(%tmp5,46)) {
          %Claimed = $remtok(%Claimed,$gettok(%tmp5,%tmp0,46),1,46)
          inc %tmp0
        }
      }
      if ($numtok(%HandPlayer4,46) > 0) {
        if ($hget(PlayerAngleHT,4) = 2) {
          %tmpx = 105
          %tmpy = 350
          %tmpangle = 3
        }
        elseif ($hget(PlayerAngleHT,4) = 3) {
          %tmpx = 350
          %tmpy = 105
          %tmpangle = 2
        }
        else {
          %tmpx = 595
          %tmpy = 350
          %tmpangle = 1
        }
        %tmp0 = 1
        %tmp1 = $numtok(%HandPlayer4,46)
        if (%tmp1 > 1) {
          %tmp2 = $true
          %tmp3 = 1
          while ($istok(%Stacks,%tmp3,46)) {
            inc %tmp3
          }
          %Stacks = $addtok(%Stacks,%tmp3,46)
          hadd StackTopsHT %tmp3 $gettok(%HandPlayer4,%tmp1,46)
          hadd StackBottomsHT %tmp3 $gettok(%HandPlayer4,1,46)
          hadd StackSizeHT %tmp3 %tmp1
        }
        else {
          %tmp2 = $false
        }
        while (%tmp0 <= %tmp1) {
          %tmp4 = $gettok(%HandPlayer4,%tmp0,46)
          hadd CardPlacementHT %tmp4 0
          hadd CardAngleHT %tmp4 %tmpangle
          hadd CardFlipFlagHT %tmp4 1
          hadd CardCoordinateXHT %tmp4 %tmpx
          if (%tmp2) {
            hadd CardCoordinateXHT %tmp4 %tmpx
            hadd CardCoordinateYHT %tmp4 $calc(%tmpy - $int($calc((%tmp0 - 1) * %StackSpacing)))
            hadd CardStackHT %tmp4 %tmp3
          }
          else {
            hadd CardCoordinateYHT %tmp4 %tmpy
          }
          %Layers = $remtok(%Layers,%tmp4,1,46)
          %Layers = $addtok(%Layers,%tmp4,46)         
          inc %tmp0 
        }
        %HandPlayer4 = $null
        drawhand 4       
      }
      if (%Server) {
        %Purgable4 = $false
      } 
    }
    drawtable
    drawfinal
  }
}

on *:socklisten:acServListen: {
  var %tmp0 = 1, %tmp1, %tmp2
  echo -t @AnyCardStatus Connection to server attempted.
  if (!$hget(PrePlayerFlagHT,1)) {
    hadd PrePlayerFlagHT 1 $true
    sockaccept acPreConnect1
    echo -t @AnyCardStatus Pre-Connect 1 accepted.
  }
  elseif (!$hget(PrePlayerFlagHT,2)) {
    hadd PrePlayerFlagHT 2 $true
    sockaccept acPreConnect2
    echo -t @AnyCardStatus Pre-Connect 2 accepted.
  }
  elseif (!$hget(PrePlayerFlagHT,3)) {
    hadd PrePlayerFlagHT 3 $true
    sockaccept acPreConnect3
    echo -t @AnyCardStatus Pre-Connect 3 accepted.
  }
}

on *:sockread:acPreConnect1: {
  if ($sockerr > 0) {
    sockclose acPreConnect1
    if (%PlayerConnecting1) {
      %ServerReady = $true
    }
    hadd PrePlayerFlagHT 1 $false
    %PlayerConnecting1 = $false
    echo -t @AnyCardStatus Pre-Connect 1 terminated.
    return
  }
  var %tmpinput, %tmpwrite, %tmp0
  sockread %tmpinput
  if ($sockerr > 0) {
    sockclose acPreConnect1
    if (%PlayerConnecting1) {
      %ServerReady = $true
    }
    hadd PrePlayerFlagHT 1 $false
    %PlayerConnecting1 = $false
    echo -t @AnyCardStatus Pre-Connect 1 terminated.
    return
  }
  if ($gettok(%tmpinput,1,32) == A) {
    %tmp0 = a.v.c.p
    if ($gettok(%tmpinput,2,32) == %VersionNumber) {
      %tmp0 = $remtok(%tmp0,v,1,46)
    }
    if ($gettok(%tmpinput,3,32) == $gettok(%MenuConfig,2,39)) && ($gettok(%tmpinput,4,32) == $crc($+(anycard/,$gettok(%MenuConfig,2,39)))) {
      %tmp0 = $remtok(%tmp0,c,1,46)
    }
    if ($gettok(%tmpinput,5,32) == $gettok(%MenuConfig,13,39)) || ($gettok(%MenuConfig,13,39) == null) {
      %tmp0 = $remtok(%tmp0,p,1,46)
    }
    if (%tmp0 == a) {
      %tmpwrite = J
    }
    else {
      hadd PrePlayerFlagHT 1 $false
      sockwrite -n acPreConnect1 I %tmp0
      sockclose acPreConnect1
      if (%PlayerConnecting1) {
        %ServerReady = $true
      }
      hadd PrePlayerFlagHT 1 $false
      %PlayerConnecting1 = $false
      echo -t @AnyCardStatus Client on Pre-Connect 1 used incompatible settings.  Pre-Connect 1 terminated.
      return
    }
  }
  elseif ($gettok(%tmpinput,1,32) == B) {
    if (%ServerReady) && (!%ActionDropCueFlag) {
      if ($hget(PlayerFlagHT,$gettok(%tmpinput,2,32)) == 0) && (!$hget(PlayerDisconnectHT,$gettok(%tmpinput,2,32))) {
        %ServerReady = $false
        %tmpwrite = M %CurrentPlayer
        %CurrentData1 = 1
        %PlayerToJoin1 = $gettok(%tmpinput,2,32)
        %PlayerConnecting1 = $true
        echo -t @AnyCardStatus Player join request received on Pre-Connect 1.
      }
      else {
        %tmpwrite = L $hget(PlayerFlagHT,1) $hget(PlayerFlagHT,2) $hget(PlayerFlagHT,3) $hget(PlayerFlagHT,4)
        echo -t @AnyCardStatus Client on Pre-Connect 1 attempted to join a filled seat.
      }
    }
    else {
      %tmpwrite = K
    }
  }
  elseif ($gettok(%tmpinput,1,32) == C) {
    if (%CurrentData1 <= %DeckSum) {
      %tmp0 = %CurrentData1
      %tmpwrite = N $hget(CardStackHT,%tmp0) $hget(CardCoordinateXHT,%tmp0) $hget(CardCoordinateYHT,%tmp0) $hget(CardAngleHT,%tmp0) $&
        $hget(CardPossessionHT,%tmp0) $hget(CardFlipFlagHT,%tmp0) $hget(CardPlacementHT,%tmp0)
    }
    elseif (%CurrentData1 == $calc(%DeckSum + 1)) {
      %tmpwrite = N $hget(GrabbedFlagHT,1) $hget(GrabbedFlagHT,2) $hget(GrabbedFlagHT,3) $hget(GrabbedFlagHT,4) $&
        $hget(GrabbedFromStackHT,1) $hget(GrabbedFromStackHT,2) $hget(GrabbedFromStackHT,3) $hget(GrabbedFromStackHT,4) $&
        $hget(GrabbedFromHandHT,1) $hget(GrabbedFromHandHT,2) $hget(GrabbedFromHandHT,3) $hget(GrabbedFromHandHT,4) $&
        $hget(GrabbedTypeHT,1) $hget(GrabbedTypeHT,2) $hget(GrabbedTypeHT,3) $hget(GrabbedTypeHT,4) $&
        $hget(GrabbedIDHT,1) $hget(GrabbedIDHT,2) $hget(GrabbedIDHT,3) $hget(GrabbedIDHT,4) $&
        $hget(GrabbedXHT,1) $hget(GrabbedXHT,2) $hget(GrabbedXHT,3) $hget(GrabbedXHT,4) $&
        $hget(GrabbedYHT,1) $hget(GrabbedYHT,2) $hget(GrabbedYHT,3) $hget(GrabbedYHT,4)
    }
    elseif (%CurrentData1 == $calc(%DeckSum + 2)) {
      %tmpwrite = N $hget(PlayerReadyFlagHT,1) $hget(PlayerReadyFlagHT,2) $hget(PlayerReadyFlagHT,3) $hget(PlayerReadyFlagHT,4)
    }
    elseif (%CurrentData1 > $calc(%DeckSum + 2)) && (%CurrentData1 <= $calc(%DeckSum + 2 + $int($calc(%DeckSum / 2)))) {
      %tmpwrite = N $hget(StackBottomsHT,$calc((%Currentdata1 - 2) - %DeckSum)) $hget(StackTopsHT,$calc((%Currentdata1 - 2) - %DeckSum)) $&
        $hget(StackSizeHT,$calc((%Currentdata1 - 2) - %DeckSum))
    }
    elseif (%CurrentData1 == $calc(%DeckSum + 3 + $int($calc(%DeckSum / 2)))) {
      %tmpwrite = N %HandPlayer1
    }
    elseif (%CurrentData1 == $calc(%DeckSum + 4 + $int($calc(%DeckSum / 2)))) {
      %tmpwrite = N %HandPlayer2
    }
    elseif (%CurrentData1 == $calc(%DeckSum + 5 + $int($calc(%DeckSum / 2)))) {
      %tmpwrite = N %HandPlayer3
    }
    elseif (%CurrentData1 == $calc(%DeckSum + 6 + $int($calc(%DeckSum / 2)))) {
      %tmpwrite = N %HandPlayer4
    }
    elseif (%CurrentData1 == $calc(%DeckSum + 7 + $int($calc(%DeckSum / 2)))) {
      %tmpwrite = N %Layers
    }
    elseif (%CurrentData1 == $calc(%DeckSum + 8 + $int($calc(%DeckSum / 2)))) {
      %tmpwrite = N %Claimed
    }
    elseif (%CurrentData1 == $calc(%DeckSum + 9 + $int($calc(%DeckSum / 2)))) {
      %tmpwrite = N %Stacks
    }
    elseif (%CurrentData1 == $calc(%DeckSum + 10 + $int($calc(%DeckSum / 2)))) {
      %tmpwrite = N $hget(ConnectedPlayerIPHT,1) $hget(ConnectedPlayerIPHT,2) $hget(ConnectedPlayerIPHT,3) $hget(ConnectedPlayerIPHT,4) 
    }
    elseif (%CurrentData1 == $calc(%DeckSum + 11 + $int($calc(%DeckSum / 2)))) {
      %tmpwrite = N $hget(PlayerFlagHT,1) $hget(PlayerFlagHT,2) $hget(PlayerFlagHT,3) $hget(PlayerFlagHT,4)
    }
    echo -t @AnyCardStatus Card data part %CurrentData1 of $calc(%DeckSum + 38) sent to Pre-Connect 1.
    inc %CurrentData1
  }
  elseif ($gettok(%tmpinput,1,32) == D) {
    %ServerReady = $true
    performaction %PlayerToJoin1 9 $sock(acPreConnect1).ip
    if (%PlayerToJoin1 == 1) {
      sockrename acPreConnect1 acPlayer1
      echo -t @AnyCardStatus Client on Pre-Connect 1 joined successfully as player 1.
      hadd PrePlayerFlagHT 1 $false
      %PlayerConnecting1 = $false
      sockwrite -n acPlayer1 Q
      if ($sockerr > 0) {
        sockclose acPlayer1
        acPlayer1dc
      }
    }
    elseif (%PlayerToJoin1 == 2) {
      sockrename acPreConnect1 acPlayer2
      echo -t @AnyCardStatus Client on Pre-Connect 1 joined successfully as player 2.
      hadd PrePlayerFlagHT 1 $false
      %PlayerConnecting1 = $false
      sockwrite -n acPlayer2 Q
      if ($sockerr > 0) {
        sockclose acPlayer2
        acPlayeSdc
      }
    }
    elseif (%PlayerToJoin1 == 3) {  
      sockrename acPreConnect1 acPlayer3
      echo -t @AnyCardStatus Client on Pre-Connect 1 joined successfully as player 3.
      hadd PrePlayerFlagHT 1 $false
      %PlayerConnecting1 = $false
      sockwrite -n acPlayer3 Q
      if ($sockerr > 0) {
        sockclose acPlayer3
        acPlayer3dc
      }
    }
    elseif (%PlayerToJoin1 == 4) {
      sockrename acPreConnect1 acPlayer4
      echo -t @AnyCardStatus Client on Pre-Connect 1 joined successfully as player 4.
      hadd PrePlayerFlagHT 1 $false
      %PlayerConnecting1 = $false
      sockwrite -n acPlayer4 Q      
      if ($sockerr > 0) {
        sockclose acPlayer4
        acPlayer4dc
      }
    }
    return
  }
  else {
    sockclose acPreConnect1
    if (%PlayerConnecting1) {
      %ServerReady = $true
    }
    hadd PrePlayerFlagHT 1 $false
    %PlayerConnecting1 = $false
    echo -t @AnyCardStatus Garbage data received.  Pre-Connect 1 terminated.
    return
  }
  sockwrite -n acPreConnect1 %tmpwrite
  if ($sockerr > 0) {
    sockclose acPreConnect1
    if (%PlayerConnecting1) {
      %ServerReady = $true
    }
    hadd PrePlayerFlagHT 1 $false
    %PlayerConnecting1 = $false
    echo -t @AnyCardStatus Pre-Connect 1 terminated.
  }
}

on *:sockclose:acPreConnect1: {
  if (%PlayerConnecting1) {
    %ServerReady = $true
  }
  hadd PrePlayerFlagHT 1 $false
  %PlayerConnecting1 = $false
  echo -t @AnyCardStatus Pre-Connect 1 terminated.
}

on *:sockread:acPreConnect2: {
  if ($sockerr > 0) {
    sockclose acPreConnect2
    if (%PlayerConnecting2) {
      %ServerReady = $true
    }
    hadd PrePlayerFlagHT 2 $false
    %PlayerConnecting2 = $false
    echo -t @AnyCardStatus Pre-Connect 2 terminated.
    return
  }
  var %tmpinput, %tmpwrite, %tmp0
  sockread %tmpinput
  if ($sockerr > 0) {
    sockclose acPreConnect2
    if (%PlayerConnecting2) {
      %ServerReady = $true
    }
    hadd PrePlayerFlagHT 2 $false
    %PlayerConnecting2 = $false
    echo -t @AnyCardStatus Pre-Connect 2 terminated.
    return
  }
  if ($gettok(%tmpinput,1,32) == A) {
    %tmp0 = a.v.c.p
    if ($gettok(%tmpinput,2,32) == %VersionNumber) {
      %tmp0 = $remtok(%tmp0,v,1,46)
    }
    if ($gettok(%tmpinput,3,32) == $gettok(%MenuConfig,2,39)) && ($gettok(%tmpinput,4,32) == $crc($+(anycard/,$gettok(%MenuConfig,2,39)))) {
      %tmp0 = $remtok(%tmp0,c,1,46)
    }
    if ($gettok(%tmpinput,5,32) == $gettok(%MenuConfig,13,39)) || ($gettok(%MenuConfig,13,39) == null) {
      %tmp0 = $remtok(%tmp0,p,1,46)
    }
    if (%tmp0 == a) {
      %tmpwrite = J
    }
    else {
      hadd PrePlayerFlagHT 2 $false
      sockwrite -n acPreConnect2 I %tmp0
      sockclose acPreConnect2
      if (%PlayerConnecting2) {
        %ServerReady = $true
      }
      hadd PrePlayerFlagHT 2 $false
      %PlayerConnecting2 = $false
      echo -t @AnyCardStatus Client on Pre-Connect 2 used incompatible settings.  Pre-Connect 2 terminated
      return
    }
  }
  elseif ($gettok(%tmpinput,1,32) == B) {
    if (%ServerReady) && (!%ActionDropCueFlag) {
      if ($hget(PlayerFlagHT,$gettok(%tmpinput,2,32)) == 0) && (!$hget(PlayerDisconnectHT,$gettok(%tmpinput,2,32))) {
        %ServerReady = $false
        %tmpwrite = M %CurrentPlayer
        %CurrentData2 = 1
        %PlayerToJoin2 = $gettok(%tmpinput,2,32)
        %PlayerConnecting2 = $true
        echo -t @AnyCardStatus Player join request received on Pre-Connect 2.
      }
      else {
        %tmpwrite = L $hget(PlayerFlagHT,1) $hget(PlayerFlagHT,2) $hget(PlayerFlagHT,3) $hget(PlayerFlagHT,4)
        echo -t @AnyCardStatus Client on Pre-Connect 2 attempted to join a filled seat.
      }
    }
    else {
      %tmpwrite = K
    }
  }
  elseif ($gettok(%tmpinput,1,32) == C) {
    if (%CurrentData2 <= %DeckSum) {
      %tmp0 = %CurrentData2
      %tmpwrite = N $hget(CardStackHT,%tmp0) $hget(CardCoordinateXHT,%tmp0) $hget(CardCoordinateYHT,%tmp0) $hget(CardAngleHT,%tmp0) $&
        $hget(CardPossessionHT,%tmp0) $hget(CardFlipFlagHT,%tmp0) $hget(CardPlacementHT,%tmp0)
    }
    elseif (%CurrentData2 == $calc(%DeckSum + 1)) {
      %tmpwrite = N $hget(GrabbedFlagHT,1) $hget(GrabbedFlagHT,2) $hget(GrabbedFlagHT,3) $hget(GrabbedFlagHT,4) $&
        $hget(GrabbedFromStackHT,1) $hget(GrabbedFromStackHT,2) $hget(GrabbedFromStackHT,3) $hget(GrabbedFromStackHT,4) $&
        $hget(GrabbedFromHandHT,1) $hget(GrabbedFromHandHT,2) $hget(GrabbedFromHandHT,3) $hget(GrabbedFromHandHT,4) $&
        $hget(GrabbedTypeHT,1) $hget(GrabbedTypeHT,2) $hget(GrabbedTypeHT,3) $hget(GrabbedTypeHT,4) $&
        $hget(GrabbedIDHT,1) $hget(GrabbedIDHT,2) $hget(GrabbedIDHT,3) $hget(GrabbedIDHT,4) $&
        $hget(GrabbedXHT,1) $hget(GrabbedXHT,2) $hget(GrabbedXHT,3) $hget(GrabbedXHT,4) $&
        $hget(GrabbedYHT,1) $hget(GrabbedYHT,2) $hget(GrabbedYHT,3) $hget(GrabbedYHT,4)
    }
    elseif (%CurrentData2 == $calc(%DeckSum + 2)) {
      %tmpwrite = N $hget(PlayerReadyFlagHT,1) $hget(PlayerReadyFlagHT,2) $hget(PlayerReadyFlagHT,3) $hget(PlayerReadyFlagHT,4)
    }
    elseif (%CurrentData2 > $calc(%DeckSum + 2)) && (%CurrentData2 <= $calc(%DeckSum + 2 + $int($calc(%DeckSum / 2)))) {
      %tmpwrite = N $hget(StackBottomsHT,$calc((%Currentdata2 - 2) - %DeckSum)) $hget(StackTopsHT,$calc((%Currentdata2 - 2) - %DeckSum)) $&
        $hget(StackSizeHT,$calc((%Currentdata2 - 2) - %DeckSum))
    }
    elseif (%CurrentData2 == $calc(%DeckSum + 3 + $int($calc(%DeckSum / 2)))) {
      %tmpwrite = N %HandPlayer1
    }
    elseif (%CurrentData2 == $calc(%DeckSum + 4 + $int($calc(%DeckSum / 2)))) {
      %tmpwrite = N %HandPlayer2
    }
    elseif (%CurrentData2 == $calc(%DeckSum + 5 + $int($calc(%DeckSum / 2)))) {
      %tmpwrite = N %HandPlayer3
    }
    elseif (%CurrentData2 == $calc(%DeckSum + 6 + $int($calc(%DeckSum / 2)))) {
      %tmpwrite = N %HandPlayer4
    }
    elseif (%CurrentData2 == $calc(%DeckSum + 7 + $int($calc(%DeckSum / 2)))) {
      %tmpwrite = N %Layers
    }
    elseif (%CurrentData2 == $calc(%DeckSum + 8 + $int($calc(%DeckSum / 2)))) {
      %tmpwrite = N %Claimed
    }
    elseif (%CurrentData2 == $calc(%DeckSum + 9 + $int($calc(%DeckSum / 2)))) {
      %tmpwrite = N %Stacks
    }
    elseif (%CurrentData2 == $calc(%DeckSum + 10 + $int($calc(%DeckSum / 2)))) {
      %tmpwrite = N $hget(ConnectedPlayerIPHT,1) $hget(ConnectedPlayerIPHT,2) $hget(ConnectedPlayerIPHT,3) $hget(ConnectedPlayerIPHT,4) 
    }
    elseif (%CurrentData2 == $calc(%DeckSum + 11 + $int($calc(%DeckSum / 2)))) {
      %tmpwrite = N $hget(PlayerFlagHT,1) $hget(PlayerFlagHT,2) $hget(PlayerFlagHT,3) $hget(PlayerFlagHT,4)
    }
    echo -t @AnyCardStatus Card data part %CurrentData2 of $calc(%DeckSum + 38) sent to Pre-Connect 2.
    inc %CurrentData2
  }
  elseif ($gettok(%tmpinput,1,32) == D) {
    %ServerReady = $true
    performaction %PlayerToJoin2 9 $sock(acPreConnect2).ip
    if (%PlayerToJoin2 == 1) {
      sockrename acPreConnect2 acPlayer1
      echo -t @AnyCardStatus Client on Pre-Connect 2 joined successfully as player 1.
      hadd PrePlayerFlagHT 2 $false
      %PlayerConnecting2 = $false
      sockwrite -n acPlayer1 Q
      if ($sockerr > 0) {
        sockclose acPlayer1
        acPlayer1dc
      }
    }
    elseif (%PlayerToJoin2 == 2) {
      sockrename acPreConnect2 acPlayer2
      echo -t @AnyCardStatus Client on Pre-Connect 2 joined successfully as player 2.
      hadd PrePlayerFlagHT 2 $false
      %PlayerConnecting2 = $false
      sockwrite -n acPlayer2 Q
      if ($sockerr > 0) {
        sockclose acPlayer2
        acPlayer2dc
      }
    }
    elseif (%PlayerToJoin2 == 3) {  
      sockrename acPreConnect2 acPlayer3
      echo -t @AnyCardStatus Client on Pre-Connect 2 joined successfully as player 3.
      hadd PrePlayerFlagHT 2 $false
      %PlayerConnecting2 = $false
      sockwrite -n acPlayer3 Q
      if ($sockerr > 0) {
        sockclose acPlayer3
        acPlayer3dc
      }
    }
    elseif (%PlayerToJoin2 == 4) {
      sockrename acPreConnect2 acPlayer4
      echo -t @AnyCardStatus Client on Pre-Connect 2 joined successfully as player 4.
      hadd PrePlayerFlagHT 2 $false
      %PlayerConnecting2 = $false
      sockwrite -n acPlayer4 Q      
      if ($sockerr > 0) {
        sockclose acPlayer4
        acPlayer4dc
      }
    }
    return
  }
  else {
    sockclose acPreConnect2
    if (%PlayerConnecting2) {
      %ServerReady = $true
    }
    hadd PrePlayerFlagHT 2 $false
    %PlayerConnecting2 = $false
    echo -t @AnyCardStatus Garbage data received.  Pre-Connect 2 terminated.
    return
  }
  sockwrite -n acPreConnect2 %tmpwrite
  if ($sockerr > 0) {
    sockclose acPreConnect2
    if (%PlayerConnecting2) {
      %ServerReady = $true
    }
    hadd PrePlayerFlagHT 2 $false
    %PlayerConnecting2 = $false
    echo -t @AnyCardStatus Pre-Connect 2 terminated.
  }
}

on *:sockclose:acPreConnect2: {
  if (%PlayerConnecting2) {
    %ServerReady = $true
  }
  hadd PrePlayerFlagHT 2 $false
  %PlayerConnecting2 = $false
  echo -t @AnyCardStatus Pre-Connect 2 terminated.
}

on *:sockread:acPreConnect3: {
  if ($sockerr > 0) {
    sockclose acPreConnect3
    if (%PlayerConnecting3) {
      %ServerReady = $true
    }
    hadd PrePlayerFlagHT 3 $false
    %PlayerConnecting3 = $false
    echo -t @AnyCardStatus Pre-Connect 3 terminated.
    return
  }
  var %tmpinput, %tmpwrite, %tmp0
  sockread %tmpinput
  if ($sockerr > 0) {
    sockclose acPreConnect3
    if (%PlayerConnecting3) {
      %ServerReady = $true
    }
    hadd PrePlayerFlagHT 3 $false
    %PlayerConnecting3 = $false
    echo -t @AnyCardStatus Pre-Connect 3 terminated.
    return
  }
  if ($gettok(%tmpinput,1,32) == A) {
    %tmp0 = a.v.c.p
    if ($gettok(%tmpinput,2,32) == %VersionNumber) {
      %tmp0 = $remtok(%tmp0,v,1,46)
    }
    if ($gettok(%tmpinput,3,32) == $gettok(%MenuConfig,2,39)) && ($gettok(%tmpinput,4,32) == $crc($+(anycard/,$gettok(%MenuConfig,2,39)))) {
      %tmp0 = $remtok(%tmp0,c,1,46)
    }
    if ($gettok(%tmpinput,5,32) == $gettok(%MenuConfig,13,39)) || ($gettok(%MenuConfig,13,39) == null) {
      %tmp0 = $remtok(%tmp0,p,1,46)
    }
    if (%tmp0 == a) {
      %tmpwrite = J
    }
    else {
      hadd PrePlayerFlagHT 3 $false
      sockwrite -n acPreConnect3 I %tmp0
      sockclose acPreConnect3
      if (%PlayerConnecting3) {
        %ServerReady = $true
      }
      hadd PrePlayerFlagHT 3 $false
      %PlayerConnecting3 = $false
      echo -t @AnyCardStatus Client on Pre-Connect 3 used incompatible settings.  Pre-Connect 3 terminated.
      return
    }
  }
  elseif ($gettok(%tmpinput,1,32) == B) {
    if (%ServerReady) && (!%ActionDropCueFlag) {
      if ($hget(PlayerFlagHT,$gettok(%tmpinput,2,32)) == 0) && (!$hget(PlayerDisconnectHT,$gettok(%tmpinput,2,32))) {
        %ServerReady = $false
        %tmpwrite = M %CurrentPlayer
        %CurrentData3 = 1
        %PlayerToJoin3 = $gettok(%tmpinput,2,32)
        %PlayerConnecting3 = $true
        echo -t @AnyCardStatus Player join request received on Pre-Connect 3.
      }
      else {
        %tmpwrite = L $hget(PlayerFlagHT,1) $hget(PlayerFlagHT,2) $hget(PlayerFlagHT,3) $hget(PlayerFlagHT,4)
        echo -t @AnyCardStatus Client on Pre-Connect 3 attempted to join a filled seat.
      }
    }
    else {
      %tmpwrite = K
    }
  }
  elseif ($gettok(%tmpinput,1,32) == C) {
    if (%CurrentData3 <= %DeckSum) {
      %tmp0 = %CurrentData3
      %tmpwrite = N $hget(CardStackHT,%tmp0) $hget(CardCoordinateXHT,%tmp0) $hget(CardCoordinateYHT,%tmp0) $hget(CardAngleHT,%tmp0) $&
        $hget(CardPossessionHT,%tmp0) $hget(CardFlipFlagHT,%tmp0) $hget(CardPlacementHT,%tmp0)
    }
    elseif (%CurrentData3 == $calc(%DeckSum + 1)) {
      %tmpwrite = N $hget(GrabbedFlagHT,1) $hget(GrabbedFlagHT,2) $hget(GrabbedFlagHT,3) $hget(GrabbedFlagHT,4) $&
        $hget(GrabbedFromStackHT,1) $hget(GrabbedFromStackHT,2) $hget(GrabbedFromStackHT,3) $hget(GrabbedFromStackHT,4) $&
        $hget(GrabbedFromHandHT,1) $hget(GrabbedFromHandHT,2) $hget(GrabbedFromHandHT,3) $hget(GrabbedFromHandHT,4) $&
        $hget(GrabbedTypeHT,1) $hget(GrabbedTypeHT,2) $hget(GrabbedTypeHT,3) $hget(GrabbedTypeHT,4) $&
        $hget(GrabbedIDHT,1) $hget(GrabbedIDHT,2) $hget(GrabbedIDHT,3) $hget(GrabbedIDHT,4) $&
        $hget(GrabbedXHT,1) $hget(GrabbedXHT,2) $hget(GrabbedXHT,3) $hget(GrabbedXHT,4) $&
        $hget(GrabbedYHT,1) $hget(GrabbedYHT,2) $hget(GrabbedYHT,3) $hget(GrabbedYHT,4)
    }
    elseif (%CurrentData3 == $calc(%DeckSum + 2)) {
      %tmpwrite = N $hget(PlayerReadyFlagHT,1) $hget(PlayerReadyFlagHT,2) $hget(PlayerReadyFlagHT,3) $hget(PlayerReadyFlagHT,4)
    }
    elseif (%CurrentData3 > $calc(%DeckSum + 2)) && (%CurrentData3 <= $calc(%DeckSum + 2 + $int($calc(%DeckSum / 2)))) {
      %tmpwrite = N $hget(StackBottomsHT,$calc((%Currentdata3 - 2) - %DeckSum)) $hget(StackTopsHT,$calc((%Currentdata3 - 2) - %DeckSum)) $&
        $hget(StackSizeHT,$calc((%Currentdata3 - 2) - %DeckSum))
    }
    elseif (%CurrentData3 == $calc(%DeckSum + 3 + $int($calc(%DeckSum / 2)))) {
      %tmpwrite = N %HandPlayer1
    }
    elseif (%CurrentData3 == $calc(%DeckSum + 4 + $int($calc(%DeckSum / 2)))) {
      %tmpwrite = N %HandPlayer2
    }
    elseif (%CurrentData3 == $calc(%DeckSum + 5 + $int($calc(%DeckSum / 2)))) {
      %tmpwrite = N %HandPlayer3
    }
    elseif (%CurrentData3 == $calc(%DeckSum + 6 + $int($calc(%DeckSum / 2)))) {
      %tmpwrite = N %HandPlayer4
    }
    elseif (%CurrentData3 == $calc(%DeckSum + 7 + $int($calc(%DeckSum / 2)))) {
      %tmpwrite = N %Layers
    }
    elseif (%CurrentData3 == $calc(%DeckSum + 8 + $int($calc(%DeckSum / 2)))) {
      %tmpwrite = N %Claimed
    }
    elseif (%CurrentData3 == $calc(%DeckSum + 9 + $int($calc(%DeckSum / 2)))) {
      %tmpwrite = N %Stacks
    }
    elseif (%CurrentData3 == $calc(%DeckSum + 10 + $int($calc(%DeckSum / 2)))) {
      %tmpwrite = N $hget(ConnectedPlayerIPHT,1) $hget(ConnectedPlayerIPHT,2) $hget(ConnectedPlayerIPHT,3) $hget(ConnectedPlayerIPHT,4) 
    }
    elseif (%CurrentData3 == $calc(%DeckSum + 11 + $int($calc(%DeckSum / 2)))) {
      %tmpwrite = N $hget(PlayerFlagHT,1) $hget(PlayerFlagHT,2) $hget(PlayerFlagHT,3) $hget(PlayerFlagHT,4)
    }
    echo -t @AnyCardStatus Card data part %CurrentData3 of $calc(%DeckSum + 38) sent to Pre-Connect 3.
    inc %CurrentData3
  }
  elseif ($gettok(%tmpinput,1,32) == D) {
    %ServerReady = $true
    performaction %PlayerToJoin3 9 $sock(acPreConnect3).ip
    if (%PlayerToJoin3 == 1) {
      sockrename acPreConnect3 acPlayer1
      echo -t @AnyCardStatus Client on Pre-Connect 3 joined successfully as player 1.
      hadd PrePlayerFlagHT 3 $false
      %PlayerConnecting3 = $false
      sockwrite -n acPlayer1 Q
      if ($sockerr > 0) {
        sockclose acPlayer1
        acPlayer1dc
      }
    }
    elseif (%PlayerToJoin3 == 2) {
      sockrename acPreConnect3 acPlayer2
      echo -t @AnyCardStatus Client on Pre-Connect 3 joined successfully as player 2.
      hadd PrePlayerFlagHT 3 $false
      %PlayerConnecting3 = $false
      sockwrite -n acPlayer2 Q
      if ($sockerr > 0) {
        sockclose acPlayer2
        acPlayeSdc
      }
    }
    elseif (%PlayerToJoin3 == 3) {  
      sockrename acPreConnect3 acPlayer3
      echo -t @AnyCardStatus Client on Pre-Connect 3 joined successfully as player 3.
      hadd PrePlayerFlagHT 3 $false
      %PlayerConnecting3 = $false
      sockwrite -n acPlayer3 Q
      if ($sockerr > 0) {
        sockclose acPlayer3
        acPlayer3dc
      }
    }
    elseif (%PlayerToJoin3 == 4) {
      sockrename acPreConnect3 acPlayer4
      echo -t @AnyCardStatus Client on Pre-Connect 3 joined successfully as player 4.
      hadd PrePlayerFlagHT 3 $false
      %PlayerConnecting3 = $false
      sockwrite -n acPlayer4 Q      
      if ($sockerr > 0) {
        sockclose acPlayer4
        acPlayer4dc
      }
    }
    return
  }
  else {
    sockclose acPreConnect3
    if (%PlayerConnecting3) {
      %ServerReady = $true
    }
    hadd PrePlayerFlagHT 3 $false
    %PlayerConnecting3 = $false
    echo -t @AnyCardStatus Garbage data received.  Pre-Connect 3 terminated.
    return
  }
  sockwrite -n acPreConnect3 %tmpwrite
  if ($sockerr > 0) {
    sockclose acPreConnect3
    if (%PlayerConnecting3) {
      %ServerReady = $true
    }
    hadd PrePlayerFlagHT 3 $false
    %PlayerConnecting3 = $false
    echo -t @AnyCardStatus Pre-Connect 3 terminated.
  }
}

on *:sockclose:acPreConnect3: {
  if (%PlayerConnecting3) {
    %ServerReady = $true
  }
  hadd PrePlayerFlagHT 3 $false
  %PlayerConnecting3 = $false
  echo -t @AnyCardStatus Pre-Connect 3 terminated.
}

alias acPlayer1dc {
  var %tmp0, %tmp1
  echo -t @AnyCardStatus Player 1 disconnected.
  hadd PlayerDisconnectHT 1 $true
  hadd PlayerFlagHT 1 0
  if ($hget(AwaitingPrimaryReqHT,1)) {
    hadd PlayerReadyNetHT 1 $false
    hadd AwaitingPrimaryReqHT 1 $false
    %tmp0 = 1
    %tmp1 = $true
    while (%tmp0 <= 4) {
      if ($hget(PlayerReadyNetHT,%tmp0) == $false) && ($hget(PlayerFlagHT,%tmp0) == 1) {
        if (%CurrentPlayer != %tmp0) {
          %tmp1 = $false
        }
      }
      inc %tmp0
    }
    if (%tmp1) {
      %ServerReady = $true
      %ActionCueFlag = $false
      hadd ActionCueHT 1 $null
      hadd ActionCueHT 2 $null
      hadd ActionCueHT 3 $null
      hadd ActionCueHT 4 $null
      hadd ActionCueHT 5 $null
      hadd ActionCueHT 6 $null
      hadd ActionCueHT 7 $null
      %tmp0 = 1
      while (%tmp0 <= 4) {
        hadd PlayerReadyNetHT %tmp0 $false
        inc %tmp0
      }
    }
  }
  if ($hget(AwaitingSecondaryReqHT,1)) {
    hadd PlayerReadyNet2HT 1 $false
    hadd AwaitingSecondaryReqHT 1 $false
    %tmp0 = 1
    %tmp1 = $true
    while (%tmp0 <= 4) {
      if ($hget(PlayerReadyNet2HT,%tmp0) == $false) && ($hget(PlayerFlagHT,%tmp0) == 1) {
        if (%CurrentPlayer != %tmp0) {
          %tmp1 = $false
        }
      }
      inc %tmp0
    }
    if (%tmp1) {
      %ServerReady = $true
      %ActionDropCueFlag = $false
      hadd ActionDropCueHT 1 $null
      hadd ActionDropCueHT 2 $null
      hadd ActionDropCueHT 3 $null
      hadd ActionDropCueHT 4 $null
      hadd ActionDropCueHT 5 $null
      hadd ActionDropCueHT 6 $null
      hadd ActionDropCueHT 7 $null      
      %tmp0 = 1
      while (%tmp0 <= 4) {
        hadd PlayerReadyNet2HT %tmp0 $false
        inc %tmp0
      }
    }
  }
}

on *:sockread:acPlayer1: {
  if ($sockerr > 0) {
    sockclose acPlayer1
    acPlayer1dc
    return
  }
  var %tmpinput, %tmpwrite, %tmp0, %tmp1, %tmp2, %tmp3, %tmp4, %tmp5
  sockread %tmpinput
  if ($sockerr > 0) {
    sockclose acPlayer1
    acPlayer1dc
    return
  }
  if ($gettok(%tmpinput,1,32) == E) {
    if (%ActionCueFlag) && ($hget(PlayerReadyNetHT,1) == $false) {
      %tmpwrite = R $hget(ActionCueHT,1) $hget(ActionCueHT,2) $hget(ActionCueHT,3) $hget(ActionCueHT,4) $hget(ActionCueHT,5) $&
        $hget(ActionCueHT,6) $hget(ActionCueHT,7)
      hadd AwaitingPrimaryReqHT 1 $true
    }
    elseif (%ActionDropCueFlag) && ($hget(PlayerReadyNet2HT,1) == $false) && (!%ActionCueFlag) {
      if (!%PlayerConnecting1) && (!%PlayerConnecting2) && (!%PlayerConnecting3) {
        if (%ServerActionCued) {
          if ($hget(ActionDropCueHT,2) == 2) {
            if ($hget(ActionDropCueHT,3) == 2) && ($hget(CardPlacementHT,$hget(ActionDropCueHT,4)) != 0) {
              hadd ActionDropCueHT 2 13
            }
            elseif ($hget(ActionDropCueHT,3) == 2) && ($hget(CardStackHT,$hget(ActionDropCueHT,4)) != 0) {
              hadd ActionDropCueHT 2 13
            }
            elseif ($hget(ActionDropCueHT,3) == 2) && ($hget(CardPossessionHT,$hget(ActionDropCueHT,4)) != 0) {
              hadd ActionDropCueHT 2 13
            }
            if ($hget(ActionDropCueHT,3) == 3) && (!$istok(%Stacks,$hget(ActionDropCueHT,4),46)) {
              hadd ActionDropCueHT 2 13
            }
            elseif ($hget(ActionDropCueHT,3) == 3) && ($hget(CardPlacementHT,$hget(StackTopsHT,$hget(ActionDropCueHT,4))) != 0) {
              hadd ActionDropCueHT 2 13
            }
            elseif ($hget(ActionDropCueHT,3) == 3) && ($hget(CardPossessionHT,$hget(StackTopsHT,$hget(ActionDropCueHT,4))) != 0) {
              hadd ActionDropCueHT 2 13
            }
          }
          %ServerReady = $false
          %ServerCommanded = $true
          performaction %CurrentPlayer $hget(ActionDropCueHT,2) $hget(ActionDropCueHT,3) $hget(ActionDropCueHT,4) $hget(ActionDropCueHT,5) $&
            $hget(ActionDropCueHT,6) $hget(ActionDropCueHT,7)
          %ServerCommanded = $false
          %ServerActionCued = $false
        }
        %tmpwrite = S $hget(ActionDropCueHT,1) $hget(ActionDropCueHT,2) $hget(ActionDropCueHT,3) $hget(ActionDropCueHT,4) $hget(ActionDropCueHT,5) $&
          $hget(ActionDropCueHT,6) $hget(ActionDropCueHT,7)
        hadd AwaitingSecondaryReqHT 1 $true
      }
    }
    elseif (%ServerReady) {
      if ($hget(GrabbedFlagHT,2)) {
        if ($hget(PlayerAngleHT,1) == 2) {
          %tmp0 = $hget(GrabbedYHT,2)
          %tmp1 = $calc(700 - $hget(GrabbedXHT,2))
        }
        elseif ($hget(PlayerAngleHT,1) == 3) {
          %tmp0 = $calc(700 - $hget(GrabbedXHT,2))
          %tmp1 = $calc(700 - $hget(GrabbedYHT,2))
        }
        else {
          %tmp0 = $calc(700 - $hget(GrabbedYHT,2))
          %tmp1 = $hget(GrabbedXHT,2)
        }
      }      
      else {
        %tmp0 = 0
        %tmp1 = 0
      }
      if ($hget(GrabbedFlagHT,3)) {
        if ($hget(PlayerAngleHT,1) == 2) {
          %tmp2 = $hget(GrabbedYHT,3)
          %tmp3 = $calc(700 - $hget(GrabbedXHT,3))
        }
        elseif ($hget(PlayerAngleHT,1) == 3) {
          %tmp2 = $calc(700 - $hget(GrabbedXHT,3))
          %tmp3 = $calc(700 - $hget(GrabbedYHT,3))
        }
        else {
          %tmp2 = $calc(700 - $hget(GrabbedYHT,3))
          %tmp3 = $hget(GrabbedXHT,3)
        }
      }
      else {
        %tmp2 = 0
        %tmp3 = 0
      }
      if ($hget(GrabbedFlagHT,4)) {
        if ($hget(PlayerAngleHT,1) == 2) {
          %tmp4 = $hget(GrabbedYHT,4)
          %tmp5 = $calc(700 - $hget(GrabbedXHT,4))
        }
        elseif ($hget(PlayerAngleHT,1) == 3) {
          %tmp4 = $calc(700 - $hget(GrabbedXHT,4))
          %tmp5 = $calc(700 - $hget(GrabbedYHT,4))
        }
        else {
          %tmp4 = $calc(700 - $hget(GrabbedYHT,4))
          %tmp5 = $hget(GrabbedXHT,4)
        }
      }
      else {
        %tmp4 = 0
        %tmp5 = 0
      }
      %tmpwrite = O %tmp0 %tmp1 %tmp2 %tmp3 %tmp4 %tmp5
    }
    else {
      %tmpwrite = Q
    }
    if ($hget(GrabbedFlagHT,1)) && ($gettok(%tmpinput,4,32)) {
      hadd GrabbedXHT 1 $gettok(%tmpinput,2,32)
      hadd GrabbedYHT 1 $gettok(%tmpinput,3,32)      
    }
  }
  elseif ($gettok(%tmpinput,1,32) == F ) {
    hadd PlayerReadyNetHT 1 $true
    hadd AwaitingPrimaryReqHT 1 $false
    %tmp0 = 1
    %tmp1 = $true
    while (%tmp0 <= 4) {
      if ($hget(PlayerReadyNetHT,%tmp0) == $false) && ($hget(PlayerFlagHT,%tmp0) == 1) {
        if (%CurrentPlayer != %tmp0) {
          %tmp1 = $false
        }
      }
      inc %tmp0
    }
    if (%tmp1) {
      %ServerReady = $true
      %ActionCueFlag = $false
      hadd ActionCueHT 1 $null
      hadd ActionCueHT 2 $null
      hadd ActionCueHT 3 $null
      hadd ActionCueHT 4 $null
      hadd ActionCueHT 5 $null
      hadd ActionCueHT 6 $null
      hadd ActionCueHT 7 $null
      %tmp0 = 1
      while (%tmp0 <= 4) {
        hadd PlayerReadyNetHT %tmp0 $false
        inc %tmp0
      }
    }
    if (%ServerReady) {
      if ($hget(GrabbedFlagHT,2)) {
        if ($hget(PlayerAngleHT,1) == 2) {
          %tmp0 = $hget(GrabbedYHT,2)
          %tmp1 = $calc(700 - $hget(GrabbedXHT,2))
        }
        elseif ($hget(PlayerAngleHT,1) == 3) {
          %tmp0 = $calc(700 - $hget(GrabbedXHT,2))
          %tmp1 = $calc(700 - $hget(GrabbedYHT,2))
        }
        else {
          %tmp0 = $calc(700 - $hget(GrabbedYHT,2))
          %tmp1 = $hget(GrabbedXHT,2)
        }
      }      
      else {
        %tmp0 = 0
        %tmp1 = 0
      }
      if ($hget(GrabbedFlagHT,3)) {
        if ($hget(PlayerAngleHT,1) == 2) {
          %tmp2 = $hget(GrabbedYHT,3)
          %tmp3 = $calc(700 - $hget(GrabbedXHT,3))
        }
        elseif ($hget(PlayerAngleHT,1) == 3) {
          %tmp2 = $calc(700 - $hget(GrabbedXHT,3))
          %tmp3 = $calc(700 - $hget(GrabbedYHT,3))
        }
        else {
          %tmp2 = $calc(700 - $hget(GrabbedYHT,3))
          %tmp3 = $hget(GrabbedXHT,3)
        }
      }
      else {
        %tmp2 = 0
        %tmp3 = 0
      }
      if ($hget(GrabbedFlagHT,4)) {
        if ($hget(PlayerAngleHT,1) == 2) {
          %tmp4 = $hget(GrabbedYHT,4)
          %tmp5 = $calc(700 - $hget(GrabbedXHT,4))
        }
        elseif ($hget(PlayerAngleHT,1) == 3) {
          %tmp4 = $calc(700 - $hget(GrabbedXHT,4))
          %tmp5 = $calc(700 - $hget(GrabbedYHT,4))
        }
        else {
          %tmp4 = $calc(700 - $hget(GrabbedYHT,4))
          %tmp5 = $hget(GrabbedXHT,4)
        }
      }
      else {
        %tmp4 = 0
        %tmp5 = 0
      }
      %tmpwrite = O %tmp0 %tmp1 %tmp2 %tmp3 %tmp4 %tmp5
    }
    else {
      %tmpwrite = Q
    }
    if ($hget(GrabbedFlagHT,1)) && ($gettok(%tmpinput,4,32)) {
      hadd GrabbedXHT 1 $gettok(%tmpinput,2,32)
      hadd GrabbedYHT 1 $gettok(%tmpinput,3,32)      
    }
  }
  elseif ($gettok(%tmpinput,1,32) == G ) {
    hadd PlayerReadyNet2HT 1 $true
    hadd AwaitingSecondaryReqHT 1 $false
    %tmp0 = 1
    %tmp1 = $true
    while (%tmp0 <= 4) {
      if ($hget(PlayerReadyNet2HT,%tmp0) == $false) && ($hget(PlayerFlagHT,%tmp0) == 1) {
        if (%CurrentPlayer != %tmp0) {
          %tmp1 = $false
        }
      }
      inc %tmp0
    }
    if (%tmp1) {
      %ServerReady = $true
      %ActionDropCueFlag = $false
      hadd ActionDropCueHT 1 $null
      hadd ActionDropCueHT 2 $null
      hadd ActionDropCueHT 3 $null
      hadd ActionDropCueHT 4 $null
      hadd ActionDropCueHT 5 $null
      hadd ActionDropCueHT 6 $null
      hadd ActionDropCueHT 7 $null      
      %tmp0 = 1
      while (%tmp0 <= 4) {
        hadd PlayerReadyNet2HT %tmp0 $false
        inc %tmp0
      }
    }
    if (%ServerReady) {
      if ($hget(GrabbedFlagHT,2)) {
        if ($hget(PlayerAngleHT,1) == 2) {
          %tmp0 = $hget(GrabbedYHT,2)
          %tmp1 = $calc(700 - $hget(GrabbedXHT,2))
        }
        elseif ($hget(PlayerAngleHT,1) == 3) {
          %tmp0 = $calc(700 - $hget(GrabbedXHT,2))
          %tmp1 = $calc(700 - $hget(GrabbedYHT,2))
        }
        else {
          %tmp0 = $calc(700 - $hget(GrabbedYHT,2))
          %tmp1 = $hget(GrabbedXHT,2)
        }
      }      
      else {
        %tmp0 = 0
        %tmp1 = 0
      }
      if ($hget(GrabbedFlagHT,3)) {
        if ($hget(PlayerAngleHT,1) == 2) {
          %tmp2 = $hget(GrabbedYHT,3)
          %tmp3 = $calc(700 - $hget(GrabbedXHT,3))
        }
        elseif ($hget(PlayerAngleHT,1) == 3) {
          %tmp2 = $calc(700 - $hget(GrabbedXHT,3))
          %tmp3 = $calc(700 - $hget(GrabbedYHT,3))
        }
        else {
          %tmp2 = $calc(700 - $hget(GrabbedYHT,3))
          %tmp3 = $hget(GrabbedXHT,3)
        }
      }
      else {
        %tmp2 = 0
        %tmp3 = 0
      }
      if ($hget(GrabbedFlagHT,4)) {
        if ($hget(PlayerAngleHT,1) == 2) {
          %tmp4 = $hget(GrabbedYHT,4)
          %tmp5 = $calc(700 - $hget(GrabbedXHT,4))
        }
        elseif ($hget(PlayerAngleHT,1) == 3) {
          %tmp4 = $calc(700 - $hget(GrabbedXHT,4))
          %tmp5 = $calc(700 - $hget(GrabbedYHT,4))
        }
        else {
          %tmp4 = $calc(700 - $hget(GrabbedYHT,4))
          %tmp5 = $hget(GrabbedXHT,4)
        }
      }
      else {
        %tmp4 = 0
        %tmp5 = 0
      }
      %tmpwrite = O %tmp0 %tmp1 %tmp2 %tmp3 %tmp4 %tmp5
    }
    else {
      %tmpwrite = Q
    }
    if ($hget(GrabbedFlagHT,1)) && ($gettok(%tmpinput,4,32)) {
      hadd GrabbedXHT 1 $gettok(%tmpinput,2,32)
      hadd GrabbedYHT 1 $gettok(%tmpinput,3,32)      
    }
  }  
  elseif ($gettok(%tmpinput,1,32) == H) {
    if (%ServerReady) && (!%ActionDropCueFlag) {
      %tmp2 = $gettok(%tmpinput,2,32)
      if (%tmp2 == 1) {
        if ($gettok(%tmpinput,3,32) == 1) && ($hget(CardPlacementHT,$gettok(%tmpinput,4,32)) != 0) {
          %tmp2 = cancel
        }
        elseif ($gettok(%tmpinput,3,32) == 1) && ($hget(CardStackHT,$gettok(%tmpinput,4,32)) != 0) {
          %tmp2 = cancel
        }
        elseif ($gettok(%tmpinput,3,32) == 1) && ($hget(CardPossessionHT,$gettok(%tmpinput,4,32)) != 0) {
          %tmp2 = cancel
        }
        if ($gettok(%tmpinput,3,32) == 4) && (!$istok(%Stacks,$gettok(%tmpinput,4,32),46)) {
          %tmp2 = cancel
        }
        elseif ($gettok(%tmpinput,3,32) == 4) && ($hget(CardPlacementHT,$hget(StackTopsHT,$gettok(%tmpinput,4,32))) != 0) {
          %tmp2 = cancel
        }
        elseif ($gettok(%tmpinput,3,32) == 4) && ($hget(CardPossessionHT,$hget(StackTopsHT,$gettok(%tmpinput,4,32))) != 0) {
          %tmp2 = cancel
        }
        if ($gettok(%tmpinput,3,32) == 2) && (!$istok(%Stacks,$gettok(%tmpinput,4,32),46)) {
          %tmp2 = cancel
        }
        elseif ($gettok(%tmpinput,3,32) == 2) && ($hget(CardPlacementHT,$hget(StackTopsHT,$gettok(%tmpinput,4,32))) != 0) {
          %tmp2 = cancel
        }
        elseif ($gettok(%tmpinput,3,32) == 2) && ($hget(CardPossessionHT,$hget(StackTopsHT,$gettok(%tmpinput,4,32))) != 0) {
          %tmp2 = cancel
        }
      }
      elseif (%tmp2 == 2) && (!$hget(GrabbedFlagHT,1)) {
        %tmp2 = cancel
      }
      elseif (%tmp2 == 2) && ($hget(GrabbedFlagHT,1)) {
        if ($gettok(%tmpinput,3,32) == 2) && ($hget(CardPlacementHT,$gettok(%tmpinput,4,32)) != 0) {
          %tmp2 = 13
        }
        elseif ($gettok(%tmpinput,3,32) == 2) && ($hget(CardStackHT,$gettok(%tmpinput,4,32)) != 0) {
          %tmp2 = 13
        }
        elseif ($gettok(%tmpinput,3,32) == 2) && ($hget(CardPossessionHT,$gettok(%tmpinput,4,32)) != 0) {
          %tmp2 = 13
        }
        elseif ($gettok(%tmpinput,3,32) == 2) && ($gettok(%tmpinput,4,32) == $hget(GrabbedIDHT,1)) && ($hget(GrabbedTypeHT,1) == 1) {
          %tmp2 = 13
        }
        if ($gettok(%tmpinput,3,32) == 3) && (!$istok(%Stacks,$gettok(%tmpinput,4,32),46)) {
          %tmp2 = 13
        }
        elseif ($gettok(%tmpinput,3,32) == 3) && ($hget(CardPlacementHT,$hget(StackTopsHT,$gettok(%tmpinput,4,32))) != 0) {
          %tmp2 = 13
        }
        elseif ($gettok(%tmpinput,3,32) == 3) && ($hget(CardPossessionHT,$hget(StackTopsHT,$gettok(%tmpinput,4,32))) != 0) {
          %tmp2 = 13
        }
        elseif ($gettok(%tmpinput,3,32) == 3) && ($gettok(%tmpinput,4,32) == $hget(GrabbedIDHT,1)) && ($hget(GrabbedTypeHT,1) == 2) {
          %tmp2 = 13
        }
      }
      elseif (%tmp2 == 3) {
        if ($gettok(%tmpinput,3,32) == 1) && ($hget(CardPlacementHT,$gettok(%tmpinput,4,32)) != 0) {
          %tmp2 = cancel
        }
        elseif ($gettok(%tmpinput,3,32) == 1) && ($hget(CardStackHT,$gettok(%tmpinput,4,32)) != 0) {
          %tmp2 = cancel
        }
        elseif ($gettok(%tmpinput,3,32) == 1) && ($hget(CardPossessionHT,$gettok(%tmpinput,4,32)) != 0) {
          %tmp2 = cancel
        }
        if ($gettok(%tmpinput,3,32) == 2) && (!$istok(%Stacks,$gettok(%tmpinput,4,32),46)) {
          %tmp2 = cancel
        }
        elseif ($gettok(%tmpinput,3,32) == 2) && ($hget(CardPlacementHT,$hget(StackTopsHT,$gettok(%tmpinput,4,32))) != 0) {
          %tmp2 = cancel
        }
        elseif ($gettok(%tmpinput,3,32) == 2) && ($hget(CardPossessionHT,$hget(StackTopsHT,$gettok(%tmpinput,4,32))) != 0) {
          %tmp2 = cancel
        }        
      }
      elseif (%tmp2 == 4) && ($hget(GrabbedFlagHT,1)) {
      }
      elseif (%tmp2 == 4) {
        if ($gettok(%tmpinput,3,32) == 1) && ($hget(CardPlacementHT,$gettok(%tmpinput,4,32)) != 0) {
          %tmp2 = cancel
        }
        elseif ($gettok(%tmpinput,3,32) == 1) && ($hget(CardStackHT,$gettok(%tmpinput,4,32)) != 0) {
          %tmp2 = cancel
        }
        elseif ($gettok(%tmpinput,3,32) == 1) && ($hget(CardPossessionHT,$gettok(%tmpinput,4,32)) != 0) {
          %tmp2 = cancel
        }
        if ($gettok(%tmpinput,3,32) == 2) && (!$istok(%Stacks,$gettok(%tmpinput,4,32),46)) {
          %tmp2 = cancel
        }
        elseif ($gettok(%tmpinput,3,32) == 2) && ($hget(CardPlacementHT,$hget(StackTopsHT,$gettok(%tmpinput,4,32))) != 0) {
          %tmp2 = cancel
        }
        elseif ($gettok(%tmpinput,3,32) == 2) && ($hget(CardPossessionHT,$hget(StackTopsHT,$gettok(%tmpinput,4,32))) != 0) {
          %tmp2 = cancel
        }        
      }
      elseif (%tmp2 == 5) {
        if ($gettok(%tmpinput,3,32) == 1) && ($hget(CardPlacementHT,$gettok(%tmpinput,4,32)) != 0) {
          %tmp2 = cancel
        }
        elseif ($gettok(%tmpinput,3,32) == 1) && ($hget(CardStackHT,$gettok(%tmpinput,4,32)) != 0) {
          %tmp2 = cancel
        }
        elseif ($gettok(%tmpinput,3,32) == 1) && ($hget(CardPossessionHT,$gettok(%tmpinput,4,32)) != 0) {
          %tmp2 = cancel
        }
      }
      elseif (%tmp2 == 6) {
        if ($gettok(%tmpinput,3,32) == 1) && ($hget(CardPlacementHT,$gettok(%tmpinput,4,32)) != 0) {
          %tmp2 = cancel
        }
        elseif ($gettok(%tmpinput,3,32) == 1) && ($hget(CardStackHT,$gettok(%tmpinput,4,32)) != 0) {
          %tmp2 = cancel
        }
        elseif ($gettok(%tmpinput,3,32) == 1) && ($hget(CardPossessionHT,$gettok(%tmpinput,4,32)) != 0) && ($hget(CardPossessionHT,$gettok(%tmpinput,4,32)) != 1) {
          %tmp2 = cancel
        }
        if ($gettok(%tmpinput,3,32) == 2) && (!$istok(%Stacks,$gettok(%tmpinput,4,32),46)) {
          %tmp2 = cancel
        }
        elseif ($gettok(%tmpinput,3,32) == 2) && ($hget(CardPlacementHT,$hget(StackTopsHT,$gettok(%tmpinput,4,32))) != 0) {
          %tmp2 = cancel
        }
        elseif ($gettok(%tmpinput,3,32) == 2) && ($hget(CardPossessionHT,$hget(StackTopsHT,$gettok(%tmpinput,4,32))) != 0) && $&
          ($hget(CardPossessionHT,$hget(StackTopsHT,$gettok(%tmpinput,4,32))) != 1) {
          %tmp2 = cancel
        }        
      }
      elseif (%tmp2 == 7) && (!$hget(GrabbedFlagHT,1)) {
        %tmp2 = cancel
      }
      elseif (%tmp2 == 13) && (!$hget(GrabbedFlagHT,1)) {
        %tmp2 = cancel
      }
      if (%tmp2 != cancel) {
        if ($gettok(%tmpinput,2,32) == 2) && ($gettok(%tmpinput,3,32) == 1) {
          if ($hget(PlayerAngleHT,1) == 2) {
            %tmp0 = $calc(700 - $gettok(%tmpinput,5,32))
            %tmp1 = $gettok(%tmpinput,4,32)
          }
          elseif ($hget(PlayerAngleHT,1) == 3) {
            %tmp0 = $calc(700 - $gettok(%tmpinput,4,32))
            %tmp1 = $calc(700 - $gettok(%tmpinput,5,32))
          }
          else {
            %tmp0 = $gettok(%tmpinput,5,32)
            %tmp1 = $calc(700 - $gettok(%tmpinput,4,32))
          }
        }
        else {
          %tmp0 = $gettok(%tmpinput,4,32)
          %tmp1 = $gettok(%tmpinput,5,32)
        }
        performaction 1 %tmp2 $gettok(%tmpinput,3,32) %tmp0 %tmp1 $gettok(%tmpinput,6,32) $gettok(%tmpinput,7,32)
        %tmpwrite = P
      }
      else {
        %tmpwrite = P
      }
    }
    else {
      %tmpwrite = Q
    }
  }
  else {
    echo 9 -t @AnyCardStatus Player 1 sent garbage data to server.
    sockclose acPlayer1
    acPlayer1dc
    return
  }
  sockwrite -n acPlayer1 %tmpwrite
  if ($sockerr > 0) {
    sockclose acPlayer1
    acPlayer1dc
  }
}

on *:sockclose:acPlayer1: {
  acPlayer1dc
}

alias acPlayer2dc {
  var %tmp0, %tmp1
  echo -t @AnyCardStatus Player 2 disconnected.
  hadd PlayerDisconnectHT 2 $true
  hadd PlayerFlagHT 2 0
  if ($hget(AwaitingPrimaryReqHT,2)) {
    hadd PlayerReadyNetHT 2 $false
    hadd AwaitingPrimaryReqHT 2 $false
    %tmp0 = 1
    %tmp1 = $true
    while (%tmp0 <= 4) {
      if ($hget(PlayerReadyNetHT,%tmp0) == $false) && ($hget(PlayerFlagHT,%tmp0) == 1) {
        if (%CurrentPlayer != %tmp0) {
          %tmp1 = $false
        }
      }
      inc %tmp0
    }
    if (%tmp1) {
      %ServerReady = $true
      %ActionCueFlag = $false
      hadd ActionCueHT 1 $null
      hadd ActionCueHT 2 $null
      hadd ActionCueHT 3 $null
      hadd ActionCueHT 4 $null
      hadd ActionCueHT 5 $null
      hadd ActionCueHT 6 $null
      hadd ActionCueHT 7 $null
      %tmp0 = 1
      while (%tmp0 <= 4) {
        hadd PlayerReadyNetHT %tmp0 $false
        inc %tmp0
      } 
    }
  }
  if ($hget(AwaitingSecondaryReqHT,2)) {
    hadd PlayerReadyNet2HT 2 $false
    hadd AwaitingSecondaryReqHT 2 $false
    %tmp0 = 1
    %tmp1 = $true
    while (%tmp0 <= 4) {
      if ($hget(PlayerReadyNet2HT,%tmp0) == $false) && ($hget(PlayerFlagHT,%tmp0) == 1) {
        if (%CurrentPlayer != %tmp0) {
          %tmp1 = $false
        }
      }
      inc %tmp0
    }
    if (%tmp1) {
      %ServerReady = $true
      %ActionDropCueFlag = $false
      hadd ActionDropCueHT 1 $null
      hadd ActionDropCueHT 2 $null
      hadd ActionDropCueHT 3 $null
      hadd ActionDropCueHT 4 $null
      hadd ActionDropCueHT 5 $null
      hadd ActionDropCueHT 6 $null
      hadd ActionDropCueHT 7 $null      
      %tmp0 = 1
      while (%tmp0 <= 4) {
        hadd PlayerReadyNet2HT %tmp0 $false
        inc %tmp0
      }
    }
  }
}

on *:sockread:acPlayer2: {
  if ($sockerr > 0) {
    sockclose acPlayer2
    acPlayer2dc
    return
  }
  var %tmpinput, %tmpwrite, %tmp0, %tmp1, %tmp2, %tmp3, %tmp4, %tmp5
  sockread %tmpinput
  if ($sockerr > 0) {
    sockclose acPlayer2
    acPlayer2dc
    return
  }
  if ($gettok(%tmpinput,1,32) == E) {
    if (%ActionCueFlag) && ($hget(PlayerReadyNetHT,2) == $false) {
      %tmpwrite = R $hget(ActionCueHT,1) $hget(ActionCueHT,2) $hget(ActionCueHT,3) $hget(ActionCueHT,4) $hget(ActionCueHT,5) $&
        $hget(ActionCueHT,6) $hget(ActionCueHT,7)
      hadd AwaitingPrimaryReqHT 2 $true
    }
    elseif (%ActionDropCueFlag) && ($hget(PlayerReadyNet2HT,2) == $false) && (!%ActionCueFlag) {
      if (!%PlayerConnecting1) && (!%PlayerConnecting2) && (!%PlayerConnecting3) {
        if (%ServerActionCued) {
          if ($hget(ActionDropCueHT,2) == 2) {
            if ($hget(ActionDropCueHT,3) == 2) && ($hget(CardPlacementHT,$hget(ActionDropCueHT,4)) != 0) {
              hadd ActionDropCueHT 2 13
            }
            elseif ($hget(ActionDropCueHT,3) == 2) && ($hget(CardStackHT,$hget(ActionDropCueHT,4)) != 0) {
              hadd ActionDropCueHT 2 13
            }
            elseif ($hget(ActionDropCueHT,3) == 2) && ($hget(CardPossessionHT,$hget(ActionDropCueHT,4)) != 0) {
              hadd ActionDropCueHT 2 13
            }
            if ($hget(ActionDropCueHT,3) == 3) && (!$istok(%Stacks,$hget(ActionDropCueHT,4),46)) {
              hadd ActionDropCueHT 2 13
            }
            elseif ($hget(ActionDropCueHT,3) == 3) && ($hget(CardPlacementHT,$hget(StackTopsHT,$hget(ActionDropCueHT,4))) != 0) {
              hadd ActionDropCueHT 2 13
            }
            elseif ($hget(ActionDropCueHT,3) == 3) && ($hget(CardPossessionHT,$hget(StackTopsHT,$hget(ActionDropCueHT,4))) != 0) {
              hadd ActionDropCueHT 2 13
            }
          }
          %ServerReady = $false
          %ServerCommanded = $true
          performaction %CurrentPlayer $hget(ActionDropCueHT,2) $hget(ActionDropCueHT,3) $hget(ActionDropCueHT,4) $hget(ActionDropCueHT,5) $&
            $hget(ActionDropCueHT,6) $hget(ActionDropCueHT,7)
          %ServerCommanded = $false
          %ServerActionCued = $false
        }
        %tmpwrite = S $hget(ActionDropCueHT,1) $hget(ActionDropCueHT,2) $hget(ActionDropCueHT,3) $hget(ActionDropCueHT,4) $hget(ActionDropCueHT,5) $&
          $hget(ActionDropCueHT,6) $hget(ActionDropCueHT,7)
        hadd AwaitingSecondaryReqHT 2 $true
      }
    }
    elseif (%ServerReady) {
      if ($hget(GrabbedFlagHT,1)) {
        if ($hget(PlayerAngleHT,2) == 2) {
          %tmp0 = $hget(GrabbedYHT,1)
          %tmp1 = $calc(700 - $hget(GrabbedXHT,1))
        }
        elseif ($hget(PlayerAngleHT,2) == 3) {
          %tmp0 = $calc(700 - $hget(GrabbedXHT,1))
          %tmp1 = $calc(700 - $hget(GrabbedYHT,1))
        }
        else {
          %tmp0 = $calc(700 - $hget(GrabbedYHT,1))
          %tmp1 = $hget(GrabbedXHT,1)
        }
      }      
      else {
        %tmp0 = 0
        %tmp1 = 0
      }
      if ($hget(GrabbedFlagHT,3)) {
        if ($hget(PlayerAngleHT,2) == 2) {
          %tmp2 = $hget(GrabbedYHT,3)
          %tmp3 = $calc(700 - $hget(GrabbedXHT,3))
        }
        elseif ($hget(PlayerAngleHT,2) == 3) {
          %tmp2 = $calc(700 - $hget(GrabbedXHT,3))
          %tmp3 = $calc(700 - $hget(GrabbedYHT,3))
        }
        else {
          %tmp2 = $calc(700 - $hget(GrabbedYHT,3))
          %tmp3 = $hget(GrabbedXHT,3)
        }
      }
      else {
        %tmp2 = 0
        %tmp3 = 0
      }
      if ($hget(GrabbedFlagHT,4)) {
        if ($hget(PlayerAngleHT,2) == 2) {
          %tmp4 = $hget(GrabbedYHT,4)
          %tmp5 = $calc(700 - $hget(GrabbedXHT,4))
        }
        elseif ($hget(PlayerAngleHT,2) == 3) {
          %tmp4 = $calc(700 - $hget(GrabbedXHT,4))
          %tmp5 = $calc(700 - $hget(GrabbedYHT,4))
        }
        else {
          %tmp4 = $calc(700 - $hget(GrabbedYHT,4))
          %tmp5 = $hget(GrabbedXHT,4)
        }
      }
      else {
        %tmp4 = 0
        %tmp5 = 0
      }
      %tmpwrite = O %tmp0 %tmp1 %tmp2 %tmp3 %tmp4 %tmp5
    }
    else {
      %tmpwrite = Q
    }
    if ($hget(GrabbedFlagHT,2)) && ($gettok(%tmpinput,4,32)) {
      hadd GrabbedXHT 2 $gettok(%tmpinput,2,32)
      hadd GrabbedYHT 2 $gettok(%tmpinput,3,32)      
    }
  }
  elseif ($gettok(%tmpinput,1,32) == F ) {
    hadd PlayerReadyNetHT 2 $true
    hadd AwaitingPrimaryReqHT 2 $false
    %tmp0 = 1
    %tmp1 = $true
    while (%tmp0 <= 4) {
      if ($hget(PlayerReadyNetHT,%tmp0) == $false) && ($hget(PlayerFlagHT,%tmp0) == 1) {
        if (%CurrentPlayer != %tmp0) {
          %tmp1 = $false
        }
      }
      inc %tmp0
    }
    if (%tmp1) {
      %ServerReady = $true
      %ActionCueFlag = $false
      hadd ActionCueHT 1 $null
      hadd ActionCueHT 2 $null
      hadd ActionCueHT 3 $null
      hadd ActionCueHT 4 $null
      hadd ActionCueHT 5 $null
      hadd ActionCueHT 6 $null
      hadd ActionCueHT 7 $null
      %tmp0 = 1
      while (%tmp0 <= 4) {
        hadd PlayerReadyNetHT %tmp0 $false
        inc %tmp0
      }
    }
    if (%ServerReady) {
      if ($hget(GrabbedFlagHT,1)) {
        if ($hget(PlayerAngleHT,2) == 2) {
          %tmp0 = $hget(GrabbedYHT,1)
          %tmp1 = $calc(700 - $hget(GrabbedXHT,1))
        }
        elseif ($hget(PlayerAngleHT,2) == 3) {
          %tmp0 = $calc(700 - $hget(GrabbedXHT,1))
          %tmp1 = $calc(700 - $hget(GrabbedYHT,1))
        }
        else {
          %tmp0 = $calc(700 - $hget(GrabbedYHT,1))
          %tmp1 = $hget(GrabbedXHT,1)
        }
      }      
      else {
        %tmp0 = 0
        %tmp1 = 0
      }
      if ($hget(GrabbedFlagHT,3)) {
        if ($hget(PlayerAngleHT,2) == 2) {
          %tmp2 = $hget(GrabbedYHT,3)
          %tmp3 = $calc(700 - $hget(GrabbedXHT,3))
        }
        elseif ($hget(PlayerAngleHT,2) == 3) {
          %tmp2 = $calc(700 - $hget(GrabbedXHT,3))
          %tmp3 = $calc(700 - $hget(GrabbedYHT,3))
        }
        else {
          %tmp2 = $calc(700 - $hget(GrabbedYHT,3))
          %tmp3 = $hget(GrabbedXHT,3)
        }
      }
      else {
        %tmp2 = 0
        %tmp3 = 0
      }
      if ($hget(GrabbedFlagHT,4)) {
        if ($hget(PlayerAngleHT,2) == 2) {
          %tmp4 = $hget(GrabbedYHT,4)
          %tmp5 = $calc(700 - $hget(GrabbedXHT,4))
        }
        elseif ($hget(PlayerAngleHT,2) == 3) {
          %tmp4 = $calc(700 - $hget(GrabbedXHT,4))
          %tmp5 = $calc(700 - $hget(GrabbedYHT,4))
        }
        else {
          %tmp4 = $calc(700 - $hget(GrabbedYHT,4))
          %tmp5 = $hget(GrabbedXHT,4)
        }
      }
      else {
        %tmp4 = 0
        %tmp5 = 0
      }
      %tmpwrite = O %tmp0 %tmp1 %tmp2 %tmp3 %tmp4 %tmp5
    }
    else {
      %tmpwrite = Q
    }
    if ($hget(GrabbedFlagHT,2)) && ($gettok(%tmpinput,4,32)) {
      hadd GrabbedXHT 2 $gettok(%tmpinput,2,32)
      hadd GrabbedYHT 2 $gettok(%tmpinput,3,32)      
    }    
  }
  elseif ($gettok(%tmpinput,1,32) == G ) {
    hadd PlayerReadyNet2HT 2 $true
    hadd AwaitingSecondaryReqHT 2 $false
    %tmp0 = 1
    %tmp1 = $true
    while (%tmp0 <= 4) {
      if ($hget(PlayerReadyNet2HT,%tmp0) == $false) && ($hget(PlayerFlagHT,%tmp0) == 1) {
        if (%CurrentPlayer != %tmp0) {
          %tmp1 = $false
        }
      }
      inc %tmp0
    }
    if (%tmp1) {
      %ServerReady = $true
      %ActionDropCueFlag = $false
      hadd ActionDropCueHT 1 $null
      hadd ActionDropCueHT 2 $null
      hadd ActionDropCueHT 3 $null
      hadd ActionDropCueHT 4 $null
      hadd ActionDropCueHT 5 $null
      hadd ActionDropCueHT 6 $null
      hadd ActionDropCueHT 7 $null      
      %tmp0 = 1
      while (%tmp0 <= 4) {
        hadd PlayerReadyNet2HT %tmp0 $false
        inc %tmp0
      }
    }
    if (%ServerReady) {
      if ($hget(GrabbedFlagHT,1)) {
        if ($hget(PlayerAngleHT,2) == 2) {
          %tmp0 = $hget(GrabbedYHT,1)
          %tmp1 = $calc(700 - $hget(GrabbedXHT,1))
        }
        elseif ($hget(PlayerAngleHT,2) == 3) {
          %tmp0 = $calc(700 - $hget(GrabbedXHT,1))
          %tmp1 = $calc(700 - $hget(GrabbedYHT,1))
        }
        else {
          %tmp0 = $calc(700 - $hget(GrabbedYHT,1))
          %tmp1 = $hget(GrabbedXHT,1)
        }
      }      
      else {
        %tmp0 = 0
        %tmp1 = 0
      }
      if ($hget(GrabbedFlagHT,3)) {
        if ($hget(PlayerAngleHT,2) == 2) {
          %tmp2 = $hget(GrabbedYHT,3)
          %tmp3 = $calc(700 - $hget(GrabbedXHT,3))
        }
        elseif ($hget(PlayerAngleHT,2) == 3) {
          %tmp2 = $calc(700 - $hget(GrabbedXHT,3))
          %tmp3 = $calc(700 - $hget(GrabbedYHT,3))
        }
        else {
          %tmp2 = $calc(700 - $hget(GrabbedYHT,3))
          %tmp3 = $hget(GrabbedXHT,3)
        }
      }
      else {
        %tmp2 = 0
        %tmp3 = 0
      }
      if ($hget(GrabbedFlagHT,4)) {
        if ($hget(PlayerAngleHT,2) == 2) {
          %tmp4 = $hget(GrabbedYHT,4)
          %tmp5 = $calc(700 - $hget(GrabbedXHT,4))
        }
        elseif ($hget(PlayerAngleHT,2) == 3) {
          %tmp4 = $calc(700 - $hget(GrabbedXHT,4))
          %tmp5 = $calc(700 - $hget(GrabbedYHT,4))
        }
        else {
          %tmp4 = $calc(700 - $hget(GrabbedYHT,4))
          %tmp5 = $hget(GrabbedXHT,4)
        }
      }
      else {
        %tmp4 = 0
        %tmp5 = 0
      }
      %tmpwrite = O %tmp0 %tmp1 %tmp2 %tmp3 %tmp4 %tmp5
    }
    else {
      %tmpwrite = Q
    }
    if ($hget(GrabbedFlagHT,2)) && ($gettok(%tmpinput,4,32)) {
      hadd GrabbedXHT 2 $gettok(%tmpinput,2,32)
      hadd GrabbedYHT 2 $gettok(%tmpinput,3,32)      
    }
  }  
  elseif ($gettok(%tmpinput,1,32) == H) { 
    if (%ServerReady) && (!%ActionDropCueFlag) {
      %tmp2 = $gettok(%tmpinput,2,32)
      if (%tmp2 == 1) {
        if ($gettok(%tmpinput,3,32) == 1) && ($hget(CardPlacementHT,$gettok(%tmpinput,4,32)) != 0) {
          %tmp2 = cancel
        }
        elseif ($gettok(%tmpinput,3,32) == 1) && ($hget(CardStackHT,$gettok(%tmpinput,4,32)) != 0) {
          %tmp2 = cancel
        }
        elseif ($gettok(%tmpinput,3,32) == 1) && ($hget(CardPossessionHT,$gettok(%tmpinput,4,32)) != 0) {
          %tmp2 = cancel
        }
        if ($gettok(%tmpinput,3,32) == 4) && (!$istok(%Stacks,$gettok(%tmpinput,4,32),46)) {
          %tmp2 = cancel
        }
        elseif ($gettok(%tmpinput,3,32) == 4) && ($hget(CardPlacementHT,$hget(StackTopsHT,$gettok(%tmpinput,4,32))) != 0) {
          %tmp2 = cancel
        }
        elseif ($gettok(%tmpinput,3,32) == 4) && ($hget(CardPossessionHT,$hget(StackTopsHT,$gettok(%tmpinput,4,32))) != 0) {
          %tmp2 = cancel
        }
        if ($gettok(%tmpinput,3,32) == 2) && (!$istok(%Stacks,$gettok(%tmpinput,4,32),46)) {
          %tmp2 = cancel
        }
        elseif ($gettok(%tmpinput,3,32) == 2) && ($hget(CardPlacementHT,$hget(StackTopsHT,$gettok(%tmpinput,4,32))) != 0) {
          %tmp2 = cancel
        }
        elseif ($gettok(%tmpinput,3,32) == 2) && ($hget(CardPossessionHT,$hget(StackTopsHT,$gettok(%tmpinput,4,32))) != 0) {
          %tmp2 = cancel
        }
      }
      elseif (%tmp2 == 2) && (!$hget(GrabbedFlagHT,2)) {
        %tmp2 = cancel
      }
      elseif (%tmp2 == 2) && ($hget(GrabbedFlagHT,2)) {
        if ($gettok(%tmpinput,3,32) == 2) && ($hget(CardPlacementHT,$gettok(%tmpinput,4,32)) != 0) {
          %tmp2 = 13
        }
        elseif ($gettok(%tmpinput,3,32) == 2) && ($hget(CardStackHT,$gettok(%tmpinput,4,32)) != 0) {
          %tmp2 = 13
        }
        elseif ($gettok(%tmpinput,3,32) == 2) && ($hget(CardPossessionHT,$gettok(%tmpinput,4,32)) != 0) {
          %tmp2 = 13
        }
        elseif ($gettok(%tmpinput,3,32) == 2) && ($gettok(%tmpinput,4,32) == $hget(GrabbedIDHT,2)) && ($hget(GrabbedTypeHT,2) == 1) {
          %tmp2 = 13
        }
        if ($gettok(%tmpinput,3,32) == 3) && (!$istok(%Stacks,$gettok(%tmpinput,4,32),46)) {
          %tmp2 = 13
        }
        elseif ($gettok(%tmpinput,3,32) == 3) && ($hget(CardPlacementHT,$hget(StackTopsHT,$gettok(%tmpinput,4,32))) != 0) {
          %tmp2 = 13
        }
        elseif ($gettok(%tmpinput,3,32) == 3) && ($hget(CardPossessionHT,$hget(StackTopsHT,$gettok(%tmpinput,4,32))) != 0) {
          %tmp2 = 13
        }
        elseif ($gettok(%tmpinput,3,32) == 3) && ($gettok(%tmpinput,4,32) == $hget(GrabbedIDHT,2)) && ($hget(GrabbedTypeHT,2) == 2) {
          %tmp2 = 13
        }
      }
      elseif (%tmp2 == 3) {
        if ($gettok(%tmpinput,3,32) == 1) && ($hget(CardPlacementHT,$gettok(%tmpinput,4,32)) != 0) {
          %tmp2 = cancel
        }
        elseif ($gettok(%tmpinput,3,32) == 1) && ($hget(CardStackHT,$gettok(%tmpinput,4,32)) != 0) {
          %tmp2 = cancel
        }
        elseif ($gettok(%tmpinput,3,32) == 1) && ($hget(CardPossessionHT,$gettok(%tmpinput,4,32)) != 0) {
          %tmp2 = cancel
        }
        if ($gettok(%tmpinput,3,32) == 2) && (!$istok(%Stacks,$gettok(%tmpinput,4,32),46)) {
          %tmp2 = cancel
        }
        elseif ($gettok(%tmpinput,3,32) == 2) && ($hget(CardPlacementHT,$hget(StackTopsHT,$gettok(%tmpinput,4,32))) != 0) {
          %tmp2 = cancel
        }
        elseif ($gettok(%tmpinput,3,32) == 2) && ($hget(CardPossessionHT,$hget(StackTopsHT,$gettok(%tmpinput,4,32))) != 0) {
          %tmp2 = cancel
        }        
      }
      elseif (%tmp2 == 4) && ($hget(GrabbedFlagHT,2)) {
      }
      elseif (%tmp2 == 4) {
        if ($gettok(%tmpinput,3,32) == 1) && ($hget(CardPlacementHT,$gettok(%tmpinput,4,32)) != 0) {
          %tmp2 = cancel
        }
        elseif ($gettok(%tmpinput,3,32) == 1) && ($hget(CardStackHT,$gettok(%tmpinput,4,32)) != 0) {
          %tmp2 = cancel
        }
        elseif ($gettok(%tmpinput,3,32) == 1) && ($hget(CardPossessionHT,$gettok(%tmpinput,4,32)) != 0) {
          %tmp2 = cancel
        }
        if ($gettok(%tmpinput,3,32) == 2) && (!$istok(%Stacks,$gettok(%tmpinput,4,32),46)) {
          %tmp2 = cancel
        }
        elseif ($gettok(%tmpinput,3,32) == 2) && ($hget(CardPlacementHT,$hget(StackTopsHT,$gettok(%tmpinput,4,32))) != 0) {
          %tmp2 = cancel
        }
        elseif ($gettok(%tmpinput,3,32) == 2) && ($hget(CardPossessionHT,$hget(StackTopsHT,$gettok(%tmpinput,4,32))) != 0) {
          %tmp2 = cancel
        }        
      }
      elseif (%tmp2 == 5) {
        if ($gettok(%tmpinput,3,32) == 1) && ($hget(CardPlacementHT,$gettok(%tmpinput,4,32)) != 0) {
          %tmp2 = cancel
        }
        elseif ($gettok(%tmpinput,3,32) == 1) && ($hget(CardStackHT,$gettok(%tmpinput,4,32)) != 0) {
          %tmp2 = cancel
        }
        elseif ($gettok(%tmpinput,3,32) == 1) && ($hget(CardPossessionHT,$gettok(%tmpinput,4,32)) != 0) {
          %tmp2 = cancel
        }
      }
      elseif (%tmp2 == 6) {
        if ($gettok(%tmpinput,3,32) == 1) && ($hget(CardPlacementHT,$gettok(%tmpinput,4,32)) != 0) {
          %tmp2 = cancel
        }
        elseif ($gettok(%tmpinput,3,32) == 1) && ($hget(CardStackHT,$gettok(%tmpinput,4,32)) != 0) {
          %tmp2 = cancel
        }
        elseif ($gettok(%tmpinput,3,32) == 1) && ($hget(CardPossessionHT,$gettok(%tmpinput,4,32)) != 0) && ($hget(CardPossessionHT,$gettok(%tmpinput,4,32)) != 2) {
          %tmp2 = cancel
        }
        if ($gettok(%tmpinput,3,32) == 2) && (!$istok(%Stacks,$gettok(%tmpinput,4,32),46)) {
          %tmp2 = cancel
        }
        elseif ($gettok(%tmpinput,3,32) == 2) && ($hget(CardPlacementHT,$hget(StackTopsHT,$gettok(%tmpinput,4,32))) != 0) {
          %tmp2 = cancel
        }
        elseif ($gettok(%tmpinput,3,32) == 2) && ($hget(CardPossessionHT,$hget(StackTopsHT,$gettok(%tmpinput,4,32))) != 0) && $&
          ($hget(CardPossessionHT,$hget(StackTopsHT,$gettok(%tmpinput,4,32))) != 2) {
          %tmp2 = cancel
        }        
      }
      elseif (%tmp2 == 7) && (!$hget(GrabbedFlagHT,2)) {
        %tmp2 = cancel
      }
      elseif (%tmp2 == 13) && (!$hget(GrabbedFlagHT,2)) {
        %tmp2 = cancel
      }
      if (%tmp2 != cancel) {
        if ($gettok(%tmpinput,2,32) == 2) && ($gettok(%tmpinput,3,32) == 1) {
          if ($hget(PlayerAngleHT,2) == 2) {
            %tmp0 = $calc(700 - $gettok(%tmpinput,5,32))
            %tmp1 = $gettok(%tmpinput,4,32)
          }
          elseif ($hget(PlayerAngleHT,2) == 3) {
            %tmp0 = $calc(700 - $gettok(%tmpinput,4,32))
            %tmp1 = $calc(700 - $gettok(%tmpinput,5,32))
          }
          else {
            %tmp0 = $gettok(%tmpinput,5,32)
            %tmp1 = $calc(700 - $gettok(%tmpinput,4,32))
          }
        }
        else {
          %tmp0 = $gettok(%tmpinput,4,32)
          %tmp1 = $gettok(%tmpinput,5,32)
        }
        performaction 2 %tmp2 $gettok(%tmpinput,3,32) %tmp0 %tmp1 $gettok(%tmpinput,6,32) $gettok(%tmpinput,7,32)
        %tmpwrite = P
      }
      else {
        %tmpwrite = P
      }
    }
    else {
      %tmpwrite = Q
    }
  }
  else {
    echo 8 -t @AnyCardStatus Player 2 sent garbage data to server.
    sockclose acPlayer2
    acPlayer2dc
    return
  }  
  sockwrite -n acPlayer2 %tmpwrite
  if ($sockerr > 0) {
    sockclose acPlayer2
    acPlayer2dc
  }
}

on *:sockclose:acPlayer2: {
  acPlayer2dc
}

alias -l acPlayer3dc {
  var %tmp0, %tmp1
  echo -t @AnyCardStatus Player 3 disconnected.
  hadd PlayerDisconnectHT 3 $true
  hadd PlayerFlagHT 3 0
  if ($hget(AwaitingPrimaryReqHT,3)) {
    hadd PlayerReadyNetHT 3 $false
    hadd AwaitingPrimaryReqHT 3 $false
    %tmp0 = 1
    %tmp1 = $true
    while (%tmp0 <= 4) {
      if ($hget(PlayerReadyNetHT,%tmp0) == $false) && ($hget(PlayerFlagHT,%tmp0) == 1) {
        if (%CurrentPlayer != %tmp0) {
          %tmp1 = $false
        }
      }
      inc %tmp0
    }
    if (%tmp1) {
      %ServerReady = $true
      %ActionCueFlag = $false
      hadd ActionCueHT 1 $null
      hadd ActionCueHT 2 $null
      hadd ActionCueHT 3 $null
      hadd ActionCueHT 4 $null
      hadd ActionCueHT 5 $null
      hadd ActionCueHT 6 $null
      hadd ActionCueHT 7 $null
      %tmp0 = 1
      while (%tmp0 <= 4) {
        hadd PlayerReadyNetHT %tmp0 $false
        inc %tmp0
      }  
    }
  }
  if ($hget(AwaitingSecondaryReqHT,3)) {
    hadd PlayerReadyNet2HT 3 $false
    hadd AwaitingSecondaryReqHT 3 $false
    %tmp0 = 1
    %tmp1 = $true
    while (%tmp0 <= 4) {
      if ($hget(PlayerReadyNet2HT,%tmp0) == $false) && ($hget(PlayerFlagHT,%tmp0) == 1) {
        if (%CurrentPlayer != %tmp0) {
          %tmp1 = $false
        }
      }
      inc %tmp0
    }
    if (%tmp1) {
      %ServerReady = $true
      %ActionDropCueFlag = $false
      hadd ActionDropCueHT 1 $null
      hadd ActionDropCueHT 2 $null
      hadd ActionDropCueHT 3 $null
      hadd ActionDropCueHT 4 $null
      hadd ActionDropCueHT 5 $null
      hadd ActionDropCueHT 6 $null
      hadd ActionDropCueHT 7 $null      
      %tmp0 = 1
      while (%tmp0 <= 4) {
        hadd PlayerReadyNet2HT %tmp0 $false
        inc %tmp0
      }
    }
  }
}

on *:sockread:acPlayer3: {
  if ($sockerr > 0) {
    sockclose acPlayer3
    acPlayer3dc
    return
  }
  var %tmpinput, %tmpwrite, %tmp0, %tmp1, %tmp2, %tmp3, %tmp4, %tmp5
  sockread %tmpinput
  if ($sockerr > 0) {
    sockclose acPlayer3
    acPlayer3dc
    return
  }
  if ($gettok(%tmpinput,1,32) == E) {
    if (%ActionCueFlag) && ($hget(PlayerReadyNetHT,3) == $false) {
      %tmpwrite = R $hget(ActionCueHT,1) $hget(ActionCueHT,2) $hget(ActionCueHT,3) $hget(ActionCueHT,4) $hget(ActionCueHT,5) $&
        $hget(ActionCueHT,6) $hget(ActionCueHT,7)
      hadd AwaitingPrimaryReqHT 3 $true
    }
    elseif (%ActionDropCueFlag) && ($hget(PlayerReadyNet2HT,3) == $false) && (!%ActionCueFlag) {
      if (!%PlayerConnecting1) && (!%PlayerConnecting2) && (!%PlayerConnecting3) {
        if (%ServerActionCued) {
          if ($hget(ActionDropCueHT,2) == 2) {
            if ($hget(ActionDropCueHT,3) == 2) && ($hget(CardPlacementHT,$hget(ActionDropCueHT,4)) != 0) {
              hadd ActionDropCueHT 2 13
            }
            elseif ($hget(ActionDropCueHT,3) == 2) && ($hget(CardStackHT,$hget(ActionDropCueHT,4)) != 0) {
              hadd ActionDropCueHT 2 13
            }
            elseif ($hget(ActionDropCueHT,3) == 2) && ($hget(CardPossessionHT,$hget(ActionDropCueHT,4)) != 0) {
              hadd ActionDropCueHT 2 13
            }
            if ($hget(ActionDropCueHT,3) == 3) && (!$istok(%Stacks,$hget(ActionDropCueHT,4),46)) {
              hadd ActionDropCueHT 2 13
            }
            elseif ($hget(ActionDropCueHT,3) == 3) && ($hget(CardPlacementHT,$hget(StackTopsHT,$hget(ActionDropCueHT,4))) != 0) {
              hadd ActionDropCueHT 2 13
            }
            elseif ($hget(ActionDropCueHT,3) == 3) && ($hget(CardPossessionHT,$hget(StackTopsHT,$hget(ActionDropCueHT,4))) != 0) {
              hadd ActionDropCueHT 2 13
            }
          }
          %ServerReady = $false
          %ServerCommanded = $true
          performaction %CurrentPlayer $hget(ActionDropCueHT,2) $hget(ActionDropCueHT,3) $hget(ActionDropCueHT,4) $hget(ActionDropCueHT,5) $&
            $hget(ActionDropCueHT,6) $hget(ActionDropCueHT,7)
          %ServerCommanded = $false
          %ServerActionCued = $false
        }
        %tmpwrite = S $hget(ActionDropCueHT,1) $hget(ActionDropCueHT,2) $hget(ActionDropCueHT,3) $hget(ActionDropCueHT,4) $hget(ActionDropCueHT,5) $&
          $hget(ActionDropCueHT,6) $hget(ActionDropCueHT,7)
        hadd AwaitingSecondaryReqHT 3 $true
      }
    }
    elseif (%ServerReady) {
      if ($hget(GrabbedFlagHT,1)) {
        if ($hget(PlayerAngleHT,3) == 2) {
          %tmp0 = $hget(GrabbedYHT,1)
          %tmp1 = $calc(700 - $hget(GrabbedXHT,1))
        }
        elseif ($hget(PlayerAngleHT,3) == 3) {
          %tmp0 = $calc(700 - $hget(GrabbedXHT,1))
          %tmp1 = $calc(700 - $hget(GrabbedYHT,1))
        }
        else {
          %tmp0 = $calc(700 - $hget(GrabbedYHT,1))
          %tmp1 = $hget(GrabbedXHT,1)
        }
      }      
      else {
        %tmp0 = 0
        %tmp1 = 0
      }
      if ($hget(GrabbedFlagHT,2)) {
        if ($hget(PlayerAngleHT,3) == 2) {
          %tmp2 = $hget(GrabbedYHT,2)
          %tmp3 = $calc(700 - $hget(GrabbedXHT,2))
        }
        elseif ($hget(PlayerAngleHT,3) == 3) {
          %tmp2 = $calc(700 - $hget(GrabbedXHT,2))
          %tmp3 = $calc(700 - $hget(GrabbedYHT,2))
        }
        else {
          %tmp2 = $calc(700 - $hget(GrabbedYHT,2))
          %tmp3 = $hget(GrabbedXHT,2)
        }
      }
      else {
        %tmp2 = 0
        %tmp3 = 0
      }
      if ($hget(GrabbedFlagHT,4)) {
        if ($hget(PlayerAngleHT,3) == 2) {
          %tmp4 = $hget(GrabbedYHT,4)
          %tmp5 = $calc(700 - $hget(GrabbedXHT,4))
        }
        elseif ($hget(PlayerAngleHT,3) == 3) {
          %tmp4 = $calc(700 - $hget(GrabbedXHT,4))
          %tmp5 = $calc(700 - $hget(GrabbedYHT,4))
        }
        else {
          %tmp4 = $calc(700 - $hget(GrabbedYHT,4))
          %tmp5 = $hget(GrabbedXHT,4)
        }
      }
      else {
        %tmp4 = 0
        %tmp5 = 0
      }
      %tmpwrite = O %tmp0 %tmp1 %tmp2 %tmp3 %tmp4 %tmp5
    }
    else {
      %tmpwrite = Q
    }
    if ($hget(GrabbedFlagHT,3)) && ($gettok(%tmpinput,4,32)) {
      hadd GrabbedXHT 3 $gettok(%tmpinput,2,32)
      hadd GrabbedYHT 3 $gettok(%tmpinput,3,32)      
    }
  }
  elseif ($gettok(%tmpinput,1,32) == F ) {
    hadd PlayerReadyNetHT 3 $true
    hadd AwaitingPrimaryReqHT 3 $false
    %tmp0 = 1
    %tmp1 = $true
    while (%tmp0 <= 4) {
      if ($hget(PlayerReadyNetHT,%tmp0) == $false) && ($hget(PlayerFlagHT,%tmp0) == 1) {
        if (%CurrentPlayer != %tmp0) {
          %tmp1 = $false
        }
      }
      inc %tmp0
    }
    if (%tmp1) {
      %ServerReady = $true
      %ActionCueFlag = $false
      hadd ActionCueHT 1 $null
      hadd ActionCueHT 2 $null
      hadd ActionCueHT 3 $null
      hadd ActionCueHT 4 $null
      hadd ActionCueHT 5 $null
      hadd ActionCueHT 6 $null
      hadd ActionCueHT 7 $null
      %tmp0 = 1
      while (%tmp0 <= 4) {
        hadd PlayerReadyNetHT %tmp0 $false
        inc %tmp0
      }
    }
    if (%ServerReady) {
      if ($hget(GrabbedFlagHT,1)) {
        if ($hget(PlayerAngleHT,3) == 2) {
          %tmp0 = $hget(GrabbedYHT,1)
          %tmp1 = $calc(700 - $hget(GrabbedXHT,1))
        }
        elseif ($hget(PlayerAngleHT,3) == 3) {
          %tmp0 = $calc(700 - $hget(GrabbedXHT,1))
          %tmp1 = $calc(700 - $hget(GrabbedYHT,1))
        }
        else {
          %tmp0 = $calc(700 - $hget(GrabbedYHT,1))
          %tmp1 = $hget(GrabbedXHT,1)
        }
      }      
      else {
        %tmp0 = 0
        %tmp1 = 0
      }
      if ($hget(GrabbedFlagHT,2)) {
        if ($hget(PlayerAngleHT,3) == 2) {
          %tmp2 = $hget(GrabbedYHT,2)
          %tmp3 = $calc(700 - $hget(GrabbedXHT,2))
        }
        elseif ($hget(PlayerAngleHT,3) == 3) {
          %tmp2 = $calc(700 - $hget(GrabbedXHT,2))
          %tmp3 = $calc(700 - $hget(GrabbedYHT,2))
        }
        else {
          %tmp2 = $calc(700 - $hget(GrabbedYHT,2))
          %tmp3 = $hget(GrabbedXHT,2)
        }
      }
      else {
        %tmp2 = 0
        %tmp3 = 0
      }
      if ($hget(GrabbedFlagHT,4)) {
        if ($hget(PlayerAngleHT,3) == 2) {
          %tmp4 = $hget(GrabbedYHT,4)
          %tmp5 = $calc(700 - $hget(GrabbedXHT,4))
        }
        elseif ($hget(PlayerAngleHT,3) == 3) {
          %tmp4 = $calc(700 - $hget(GrabbedXHT,4))
          %tmp5 = $calc(700 - $hget(GrabbedYHT,4))
        }
        else {
          %tmp4 = $calc(700 - $hget(GrabbedYHT,4))
          %tmp5 = $hget(GrabbedXHT,4)
        }
      }
      else {
        %tmp4 = 0
        %tmp5 = 0
      }
      %tmpwrite = O %tmp0 %tmp1 %tmp2 %tmp3 %tmp4 %tmp5
    }
    else {
      %tmpwrite = Q
    }
    if ($hget(GrabbedFlagHT,3)) && ($gettok(%tmpinput,4,32)) {
      hadd GrabbedXHT 3 $gettok(%tmpinput,2,32)
      hadd GrabbedYHT 3 $gettok(%tmpinput,3,32)      
    }
  }
  elseif ($gettok(%tmpinput,1,32) == G ) {
    hadd PlayerReadyNet2HT 3 $true
    hadd AwaitingSecondaryReqHT 3 $false
    %tmp0 = 1
    %tmp1 = $true
    while (%tmp0 <= 4) {
      if ($hget(PlayerReadyNet2HT,%tmp0) == $false) && ($hget(PlayerFlagHT,%tmp0) == 1) {
        if (%CurrentPlayer != %tmp0) {
          %tmp1 = $false
        }
      }
      inc %tmp0
    }
    if (%tmp1) {
      %ServerReady = $true
      %ActionDropCueFlag = $false
      hadd ActionDropCueHT 1 $null
      hadd ActionDropCueHT 2 $null
      hadd ActionDropCueHT 3 $null
      hadd ActionDropCueHT 4 $null
      hadd ActionDropCueHT 5 $null
      hadd ActionDropCueHT 6 $null
      hadd ActionDropCueHT 7 $null      
      %tmp0 = 1
      while (%tmp0 <= 4) {
        hadd PlayerReadyNet2HT %tmp0 $false
        inc %tmp0
      }
    }
    if (%ServerReady) {
      if ($hget(GrabbedFlagHT,1)) {
        if ($hget(PlayerAngleHT,3) == 2) {
          %tmp0 = $hget(GrabbedYHT,1)
          %tmp1 = $calc(700 - $hget(GrabbedXHT,1))
        }
        elseif ($hget(PlayerAngleHT,3) == 3) {
          %tmp0 = $calc(700 - $hget(GrabbedXHT,1))
          %tmp1 = $calc(700 - $hget(GrabbedYHT,1))
        }
        else {
          %tmp0 = $calc(700 - $hget(GrabbedYHT,1))
          %tmp1 = $hget(GrabbedXHT,1)
        }
      }      
      else {
        %tmp0 = 0
        %tmp1 = 0
      }
      if ($hget(GrabbedFlagHT,2)) {
        if ($hget(PlayerAngleHT,3) == 2) {
          %tmp2 = $hget(GrabbedYHT,2)
          %tmp3 = $calc(700 - $hget(GrabbedXHT,2))
        }
        elseif ($hget(PlayerAngleHT,3) == 3) {
          %tmp2 = $calc(700 - $hget(GrabbedXHT,2))
          %tmp3 = $calc(700 - $hget(GrabbedYHT,2))
        }
        else {
          %tmp2 = $calc(700 - $hget(GrabbedYHT,2))
          %tmp3 = $hget(GrabbedXHT,2)
        }
      }
      else {
        %tmp2 = 0
        %tmp3 = 0
      }
      if ($hget(GrabbedFlagHT,4)) {
        if ($hget(PlayerAngleHT,3) == 2) {
          %tmp4 = $hget(GrabbedYHT,4)
          %tmp5 = $calc(700 - $hget(GrabbedXHT,4))
        }
        elseif ($hget(PlayerAngleHT,3) == 3) {
          %tmp4 = $calc(700 - $hget(GrabbedXHT,4))
          %tmp5 = $calc(700 - $hget(GrabbedYHT,4))
        }
        else {
          %tmp4 = $calc(700 - $hget(GrabbedYHT,4))
          %tmp5 = $hget(GrabbedXHT,4)
        }
      }
      else {
        %tmp4 = 0
        %tmp5 = 0
      }
      %tmpwrite = O %tmp0 %tmp1 %tmp2 %tmp3 %tmp4 %tmp5
    }
    else {
      %tmpwrite = Q
    }
    if ($hget(GrabbedFlagHT,3)) && ($gettok(%tmpinput,4,32)) {
      hadd GrabbedXHT 3 $gettok(%tmpinput,2,32)
      hadd GrabbedYHT 3 $gettok(%tmpinput,3,32)      
    }
  }  
  elseif ($gettok(%tmpinput,1,32) == H) { 
    if (%ServerReady) && (!%ActionDropCueFlag) {
      %tmp2 = $gettok(%tmpinput,2,32)
      if (%tmp2 == 1) {
        if ($gettok(%tmpinput,3,32) == 1) && ($hget(CardPlacementHT,$gettok(%tmpinput,4,32)) != 0) {
          %tmp2 = cancel
        }
        elseif ($gettok(%tmpinput,3,32) == 1) && ($hget(CardStackHT,$gettok(%tmpinput,4,32)) != 0) {
          %tmp2 = cancel
        }
        elseif ($gettok(%tmpinput,3,32) == 1) && ($hget(CardPossessionHT,$gettok(%tmpinput,4,32)) != 0) {
          %tmp2 = cancel
        }
        if ($gettok(%tmpinput,3,32) == 4) && (!$istok(%Stacks,$gettok(%tmpinput,4,32),46)) {
          %tmp2 = cancel
        }
        elseif ($gettok(%tmpinput,3,32) == 4) && ($hget(CardPlacementHT,$hget(StackTopsHT,$gettok(%tmpinput,4,32))) != 0) {
          %tmp2 = cancel
        }
        elseif ($gettok(%tmpinput,3,32) == 4) && ($hget(CardPossessionHT,$hget(StackTopsHT,$gettok(%tmpinput,4,32))) != 0) {
          %tmp2 = cancel
        }
        if ($gettok(%tmpinput,3,32) == 2) && (!$istok(%Stacks,$gettok(%tmpinput,4,32),46)) {
          %tmp2 = cancel
        }
        elseif ($gettok(%tmpinput,3,32) == 2) && ($hget(CardPlacementHT,$hget(StackTopsHT,$gettok(%tmpinput,4,32))) != 0) {
          %tmp2 = cancel
        }
        elseif ($gettok(%tmpinput,3,32) == 2) && ($hget(CardPossessionHT,$hget(StackTopsHT,$gettok(%tmpinput,4,32))) != 0) {
          %tmp2 = cancel
        }
      }
      elseif (%tmp2 == 2) && (!$hget(GrabbedFlagHT,3)) {
        %tmp2 = cancel
      }
      elseif (%tmp2 == 2) && ($hget(GrabbedFlagHT,3)) {
        if ($gettok(%tmpinput,3,32) == 2) && ($hget(CardPlacementHT,$gettok(%tmpinput,4,32)) != 0) {
          %tmp2 = 13
        }
        elseif ($gettok(%tmpinput,3,32) == 2) && ($hget(CardStackHT,$gettok(%tmpinput,4,32)) != 0) {
          %tmp2 = 13
        }
        elseif ($gettok(%tmpinput,3,32) == 2) && ($hget(CardPossessionHT,$gettok(%tmpinput,4,32)) != 0) {
          %tmp2 = 13
        }
        elseif ($gettok(%tmpinput,3,32) == 2) && ($gettok(%tmpinput,4,32) == $hget(GrabbedIDHT,3)) && ($hget(GrabbedTypeHT,3) == 1) {
          %tmp2 = 13
        }
        if ($gettok(%tmpinput,3,32) == 3) && (!$istok(%Stacks,$gettok(%tmpinput,4,32),46)) {
          %tmp2 = 13
        }
        elseif ($gettok(%tmpinput,3,32) == 3) && ($hget(CardPlacementHT,$hget(StackTopsHT,$gettok(%tmpinput,4,32))) != 0) {
          %tmp2 = 13
        }
        elseif ($gettok(%tmpinput,3,32) == 3) && ($hget(CardPossessionHT,$hget(StackTopsHT,$gettok(%tmpinput,4,32))) != 0) {
          %tmp2 = 13
        }
        elseif ($gettok(%tmpinput,3,32) == 3) && ($gettok(%tmpinput,4,32) == $hget(GrabbedIDHT,3)) && ($hget(GrabbedTypeHT,3) == 2) {
          %tmp2 = 13
        }
      }
      elseif (%tmp2 == 3) {
        if ($gettok(%tmpinput,3,32) == 1) && ($hget(CardPlacementHT,$gettok(%tmpinput,4,32)) != 0) {
          %tmp2 = cancel
        }
        elseif ($gettok(%tmpinput,3,32) == 1) && ($hget(CardStackHT,$gettok(%tmpinput,4,32)) != 0) {
          %tmp2 = cancel
        }
        elseif ($gettok(%tmpinput,3,32) == 1) && ($hget(CardPossessionHT,$gettok(%tmpinput,4,32)) != 0) {
          %tmp2 = cancel
        }
        if ($gettok(%tmpinput,3,32) == 2) && (!$istok(%Stacks,$gettok(%tmpinput,4,32),46)) {
          %tmp2 = cancel
        }
        elseif ($gettok(%tmpinput,3,32) == 2) && ($hget(CardPlacementHT,$hget(StackTopsHT,$gettok(%tmpinput,4,32))) != 0) {
          %tmp2 = cancel
        }
        elseif ($gettok(%tmpinput,3,32) == 2) && ($hget(CardPossessionHT,$hget(StackTopsHT,$gettok(%tmpinput,4,32))) != 0) {
          %tmp2 = cancel
        }        
      }
      elseif (%tmp2 == 4) && ($hget(GrabbedFlagHT,3)) {
      }
      elseif (%tmp2 == 4) {
        if ($gettok(%tmpinput,3,32) == 1) && ($hget(CardPlacementHT,$gettok(%tmpinput,4,32)) != 0) {
          %tmp2 = cancel
        }
        elseif ($gettok(%tmpinput,3,32) == 1) && ($hget(CardStackHT,$gettok(%tmpinput,4,32)) != 0) {
          %tmp2 = cancel
        }
        elseif ($gettok(%tmpinput,3,32) == 1) && ($hget(CardPossessionHT,$gettok(%tmpinput,4,32)) != 0) {
          %tmp2 = cancel
        }
        if ($gettok(%tmpinput,3,32) == 2) && (!$istok(%Stacks,$gettok(%tmpinput,4,32),46)) {
          %tmp2 = cancel
        }
        elseif ($gettok(%tmpinput,3,32) == 2) && ($hget(CardPlacementHT,$hget(StackTopsHT,$gettok(%tmpinput,4,32))) != 0) {
          %tmp2 = cancel
        }
        elseif ($gettok(%tmpinput,3,32) == 2) && ($hget(CardPossessionHT,$hget(StackTopsHT,$gettok(%tmpinput,4,32))) != 0) {
          %tmp2 = cancel
        }        
      }
      elseif (%tmp2 == 5) {
        if ($gettok(%tmpinput,3,32) == 1) && ($hget(CardPlacementHT,$gettok(%tmpinput,4,32)) != 0) {
          %tmp2 = cancel
        }
        elseif ($gettok(%tmpinput,3,32) == 1) && ($hget(CardStackHT,$gettok(%tmpinput,4,32)) != 0) {
          %tmp2 = cancel
        }
        elseif ($gettok(%tmpinput,3,32) == 1) && ($hget(CardPossessionHT,$gettok(%tmpinput,4,32)) != 0) {
          %tmp2 = cancel
        }
      }
      elseif (%tmp2 == 6) {
        if ($gettok(%tmpinput,3,32) == 1) && ($hget(CardPlacementHT,$gettok(%tmpinput,4,32)) != 0) {
          %tmp2 = cancel
        }
        elseif ($gettok(%tmpinput,3,32) == 1) && ($hget(CardStackHT,$gettok(%tmpinput,4,32)) != 0) {
          %tmp2 = cancel
        }
        elseif ($gettok(%tmpinput,3,32) == 1) && ($hget(CardPossessionHT,$gettok(%tmpinput,4,32)) != 0) && ($hget(CardPossessionHT,$gettok(%tmpinput,4,32)) != 3) {
          %tmp2 = cancel
        }
        if ($gettok(%tmpinput,3,32) == 2) && (!$istok(%Stacks,$gettok(%tmpinput,4,32),46)) {
          %tmp2 = cancel
        }
        elseif ($gettok(%tmpinput,3,32) == 2) && ($hget(CardPlacementHT,$hget(StackTopsHT,$gettok(%tmpinput,4,32))) != 0) {
          %tmp2 = cancel
        }
        elseif ($gettok(%tmpinput,3,32) == 2) && ($hget(CardPossessionHT,$hget(StackTopsHT,$gettok(%tmpinput,4,32))) != 0) && $&
          ($hget(CardPossessionHT,$hget(StackTopsHT,$gettok(%tmpinput,4,32))) != 3) {
          %tmp2 = cancel
        }        
      }
      elseif (%tmp2 == 7) && (!$hget(GrabbedFlagHT,3)) {
        %tmp2 = cancel
      }
      elseif (%tmp2 == 13) && (!$hget(GrabbedFlagHT,3)) {
        %tmp2 = cancel
      }
      if (%tmp2 != cancel) {
        if ($gettok(%tmpinput,2,32) == 2) && ($gettok(%tmpinput,3,32) == 1) {
          if ($hget(PlayerAngleHT,3) == 2) {
            %tmp0 = $calc(700 - $gettok(%tmpinput,5,32))
            %tmp1 = $gettok(%tmpinput,4,32)
          }
          elseif ($hget(PlayerAngleHT,3) == 3) {
            %tmp0 = $calc(700 - $gettok(%tmpinput,4,32))
            %tmp1 = $calc(700 - $gettok(%tmpinput,5,32))
          }
          else {
            %tmp0 = $gettok(%tmpinput,5,32)
            %tmp1 = $calc(700 - $gettok(%tmpinput,4,32))
          }
        }
        else {
          %tmp0 = $gettok(%tmpinput,4,32)
          %tmp1 = $gettok(%tmpinput,5,32)
        }
        performaction 3 %tmp2 $gettok(%tmpinput,3,32) %tmp0 %tmp1 $gettok(%tmpinput,6,32) $gettok(%tmpinput,7,32)
        %tmpwrite = P
      }
      else {
        %tmpwrite = P
      }
    }
    else {
      %tmpwrite = Q
    }
  }
  else {
    echo 12 -t @AnyCardStatus Player 3 sent garbage data to server.
    sockclose acPlayer3
    acPlayer3dc
    return
  }  
  sockwrite -n acPlayer3 %tmpwrite
  if ($sockerr > 0) {
    sockclose acPlayer3
    acPlayer3dc
  }
}

on *:sockclose:acPlayer3: {
  acPlayer3dc
}

alias -l acPlayer4dc {
  var %tmp0, %tmp1
  echo -t @AnyCardStatus Player 4 disconnected.
  hadd PlayerDisconnectHT 4 $true
  hadd PlayerFlagHT 4 0
  if ($hget(AwaitingPrimaryReqHT,4)) {
    hadd PlayerReadyNetHT 4 $false
    hadd AwaitingPrimaryReqHT 4 $false
    %tmp0 = 1
    %tmp1 = $true
    while (%tmp0 <= 4) {
      if ($hget(PlayerReadyNetHT,%tmp0) == $false) && ($hget(PlayerFlagHT,%tmp0) == 1) {
        if (%CurrentPlayer != %tmp0) {
          %tmp1 = $false
        }
      }
      inc %tmp0
    }
    if (%tmp1) {
      %ServerReady = $true
      %ActionCueFlag = $false
      hadd ActionCueHT 1 $null
      hadd ActionCueHT 2 $null
      hadd ActionCueHT 3 $null
      hadd ActionCueHT 4 $null
      hadd ActionCueHT 5 $null
      hadd ActionCueHT 6 $null
      hadd ActionCueHT 7 $null
      %tmp0 = 1
      while (%tmp0 <= 4) {
        hadd PlayerReadyNetHT %tmp0 $false
        inc %tmp0
      }
    }
  }
  if ($hget(AwaitingSecondaryReqHT,4)) {
    hadd PlayerReadyNet2HT 4 $false
    hadd AwaitingSecondaryReqHT 4 $false
    %tmp0 = 1
    %tmp1 = $true
    while (%tmp0 <= 4) {
      if ($hget(PlayerReadyNet2HT,%tmp0) == $false) && ($hget(PlayerFlagHT,%tmp0) == 1) {
        if (%CurrentPlayer != %tmp0) {
          %tmp1 = $false
        }
      }
      inc %tmp0
    }
    if (%tmp1) {
      %ServerReady = $true
      %ActionDropCueFlag = $false
      hadd ActionDropCueHT 1 $null
      hadd ActionDropCueHT 2 $null
      hadd ActionDropCueHT 3 $null
      hadd ActionDropCueHT 4 $null
      hadd ActionDropCueHT 5 $null
      hadd ActionDropCueHT 6 $null
      hadd ActionDropCueHT 7 $null      
      %tmp0 = 1
      while (%tmp0 <= 4) {
        hadd PlayerReadyNet2HT %tmp0 $false
        inc %tmp0
      }
    }
  }
}

on *:sockread:acPlayer4: {
  if ($sockerr > 0) {
    sockclose acPlayer4
    acPlayer4dc
    return
  }
  var %tmpinput, %tmpwrite, %tmp0, %tmp1, %tmp2, %tmp3, %tmp4, %tmp5
  sockread %tmpinput
  if ($sockerr > 0) {
    sockclose acPlayer4
    acPlayer4dc
    return
  }
  if ($gettok(%tmpinput,1,32) == E) {
    if (%ActionCueFlag) && ($hget(PlayerReadyNetHT,4) == $false) {
      %tmpwrite = R $hget(ActionCueHT,1) $hget(ActionCueHT,2) $hget(ActionCueHT,3) $hget(ActionCueHT,4) $hget(ActionCueHT,5) $&
        $hget(ActionCueHT,6) $hget(ActionCueHT,7)
      hadd AwaitingPrimaryReqHT 4 $true
    }
    elseif (%ActionDropCueFlag) && ($hget(PlayerReadyNet2HT,4) == $false) && (!%ActionCueFlag) {
      if (!%PlayerConnecting1) && (!%PlayerConnecting2) && (!%PlayerConnecting3) {
        if (%ServerActionCued) {
          if ($hget(ActionDropCueHT,2) == 2) {
            if ($hget(ActionDropCueHT,3) == 2) && ($hget(CardPlacementHT,$hget(ActionDropCueHT,4)) != 0) {
              hadd ActionDropCueHT 2 13
            }
            elseif ($hget(ActionDropCueHT,3) == 2) && ($hget(CardStackHT,$hget(ActionDropCueHT,4)) != 0) {
              hadd ActionDropCueHT 2 13
            }
            elseif ($hget(ActionDropCueHT,3) == 2) && ($hget(CardPossessionHT,$hget(ActionDropCueHT,4)) != 0) {
              hadd ActionDropCueHT 2 13
            }
            if ($hget(ActionDropCueHT,3) == 3) && (!$istok(%Stacks,$hget(ActionDropCueHT,4),46)) {
              hadd ActionDropCueHT 2 13
            }
            elseif ($hget(ActionDropCueHT,3) == 3) && ($hget(CardPlacementHT,$hget(StackTopsHT,$hget(ActionDropCueHT,4))) != 0) {
              hadd ActionDropCueHT 2 13
            }
            elseif ($hget(ActionDropCueHT,3) == 3) && ($hget(CardPossessionHT,$hget(StackTopsHT,$hget(ActionDropCueHT,4))) != 0) {
              hadd ActionDropCueHT 2 13
            }
          }
          %ServerReady = $false
          %ServerCommanded = $true
          performaction %CurrentPlayer $hget(ActionDropCueHT,2) $hget(ActionDropCueHT,3) $hget(ActionDropCueHT,4) $hget(ActionDropCueHT,5) $&
            $hget(ActionDropCueHT,6) $hget(ActionDropCueHT,7)
          %ServerCommanded = $false
          %ServerActionCued = $false
        }
        %tmpwrite = S $hget(ActionDropCueHT,1) $hget(ActionDropCueHT,2) $hget(ActionDropCueHT,3) $hget(ActionDropCueHT,4) $hget(ActionDropCueHT,5) $&
          $hget(ActionDropCueHT,6) $hget(ActionDropCueHT,7)
        hadd AwaitingSecondaryReqHT 3 $true
      }
    }
    elseif (%ServerReady) {
      if ($hget(GrabbedFlagHT,1)) {
        if ($hget(PlayerAngleHT,4) == 2) {
          %tmp0 = $hget(GrabbedYHT,1)
          %tmp1 = $calc(700 - $hget(GrabbedXHT,1))
        }
        elseif ($hget(PlayerAngleHT,4) == 3) {
          %tmp0 = $calc(700 - $hget(GrabbedXHT,1))
          %tmp1 = $calc(700 - $hget(GrabbedYHT,1))
        }
        else {
          %tmp0 = $calc(700 - $hget(GrabbedYHT,1))
          %tmp1 = $hget(GrabbedXHT,1)
        }
      }      
      else {
        %tmp0 = 0
        %tmp1 = 0
      }
      if ($hget(GrabbedFlagHT,2)) {
        if ($hget(PlayerAngleHT,4) == 2) {
          %tmp2 = $hget(GrabbedYHT,2)
          %tmp3 = $calc(700 - $hget(GrabbedXHT,2))
        }
        elseif ($hget(PlayerAngleHT,4) == 3) {
          %tmp2 = $calc(700 - $hget(GrabbedXHT,2))
          %tmp3 = $calc(700 - $hget(GrabbedYHT,2))
        }
        else {
          %tmp2 = $calc(700 - $hget(GrabbedYHT,2))
          %tmp3 = $hget(GrabbedXHT,2)
        }
      }
      else {
        %tmp2 = 0
        %tmp3 = 0
      }
      if ($hget(GrabbedFlagHT,3)) {
        if ($hget(PlayerAngleHT,4) == 2) {
          %tmp4 = $hget(GrabbedYHT,3)
          %tmp5 = $calc(700 - $hget(GrabbedXHT,3))
        }
        elseif ($hget(PlayerAngleHT,4) == 3) {
          %tmp4 = $calc(700 - $hget(GrabbedXHT,3))
          %tmp5 = $calc(700 - $hget(GrabbedYHT,3))
        }
        else {
          %tmp4 = $calc(700 - $hget(GrabbedYHT,3))
          %tmp5 = $hget(GrabbedXHT,3)
        }
      }
      else {
        %tmp4 = 0
        %tmp5 = 0
      }
      %tmpwrite = O %tmp0 %tmp1 %tmp2 %tmp3 %tmp4 %tmp5
    }
    else {
      %tmpwrite = Q
    }
    if ($hget(GrabbedFlagHT,4)) && ($gettok(%tmpinput,4,32)) {
      hadd GrabbedXHT 4 $gettok(%tmpinput,2,32)
      hadd GrabbedYHT 4 $gettok(%tmpinput,3,32)      
    }
  }
  elseif ($gettok(%tmpinput,1,32) == F ) {
    hadd PlayerReadyNetHT 4 $true
    hadd AwaitingPrimaryReqHT 4 $false
    %tmp0 = 1
    %tmp1 = $true
    while (%tmp0 <= 4) {
      if ($hget(PlayerReadyNetHT,%tmp0) == $false) && ($hget(PlayerFlagHT,%tmp0) == 1) {
        if (%CurrentPlayer != %tmp0) {
          %tmp1 = $false
        }
      }
      inc %tmp0
    }
    if (%tmp1) {
      %ServerReady = $true
      %ActionCueFlag = $false
      hadd ActionCueHT 1 $null
      hadd ActionCueHT 2 $null
      hadd ActionCueHT 3 $null
      hadd ActionCueHT 4 $null
      hadd ActionCueHT 5 $null
      hadd ActionCueHT 6 $null
      hadd ActionCueHT 7 $null
      %tmp0 = 1
      while (%tmp0 <= 4) {
        hadd PlayerReadyNetHT %tmp0 $false
        inc %tmp0
      }
    }
    if (%ServerReady) {
      if ($hget(GrabbedFlagHT,1)) {
        if ($hget(PlayerAngleHT,4) == 2) {
          %tmp0 = $hget(GrabbedYHT,1)
          %tmp1 = $calc(700 - $hget(GrabbedXHT,1))
        }
        elseif ($hget(PlayerAngleHT,4) == 3) {
          %tmp0 = $calc(700 - $hget(GrabbedXHT,1))
          %tmp1 = $calc(700 - $hget(GrabbedYHT,1))
        }
        else {
          %tmp0 = $calc(700 - $hget(GrabbedYHT,1))
          %tmp1 = $hget(GrabbedXHT,1)
        }
      }      
      else {
        %tmp0 = 0
        %tmp1 = 0
      }
      if ($hget(GrabbedFlagHT,2)) {
        if ($hget(PlayerAngleHT,4) == 2) {
          %tmp2 = $hget(GrabbedYHT,2)
          %tmp3 = $calc(700 - $hget(GrabbedXHT,2))
        }
        elseif ($hget(PlayerAngleHT,4) == 3) {
          %tmp2 = $calc(700 - $hget(GrabbedXHT,2))
          %tmp3 = $calc(700 - $hget(GrabbedYHT,2))
        }
        else {
          %tmp2 = $calc(700 - $hget(GrabbedYHT,2))
          %tmp3 = $hget(GrabbedXHT,2)
        }
      }
      else {
        %tmp2 = 0
        %tmp3 = 0
      }
      if ($hget(GrabbedFlagHT,3)) {
        if ($hget(PlayerAngleHT,4) == 2) {
          %tmp4 = $hget(GrabbedYHT,3)
          %tmp5 = $calc(700 - $hget(GrabbedXHT,3))
        }
        elseif ($hget(PlayerAngleHT,4) == 3) {
          %tmp4 = $calc(700 - $hget(GrabbedXHT,3))
          %tmp5 = $calc(700 - $hget(GrabbedYHT,3))
        }
        else {
          %tmp4 = $calc(700 - $hget(GrabbedYHT,3))
          %tmp5 = $hget(GrabbedXHT,3)
        }
      }
      else {
        %tmp4 = 0
        %tmp5 = 0
      }
      %tmpwrite = O %tmp0 %tmp1 %tmp2 %tmp3 %tmp4 %tmp5
    }
    else {
      %tmpwrite = Q
    }
    if ($hget(GrabbedFlagHT,4)) && ($gettok(%tmpinput,4,32)) {
      hadd GrabbedXHT 4 $gettok(%tmpinput,2,32)
      hadd GrabbedYHT 4 $gettok(%tmpinput,3,32)      
    }
  }
  elseif ($gettok(%tmpinput,1,32) == G ) {
    hadd PlayerReadyNet2HT 4 $true
    hadd AwaitingSecondaryReqHT 4 $false
    %tmp0 = 1
    %tmp1 = $true
    while (%tmp0 <= 4) {
      if ($hget(PlayerReadyNet2HT,%tmp0) == $false) && ($hget(PlayerFlagHT,%tmp0) == 1) {
        if (%CurrentPlayer != %tmp0) {
          %tmp1 = $false
        }
      }
      inc %tmp0
    }
    if (%tmp1) {
      %ServerReady = $true
      %ActionDropCueFlag = $false
      hadd ActionDropCueHT 1 $null
      hadd ActionDropCueHT 2 $null
      hadd ActionDropCueHT 3 $null
      hadd ActionDropCueHT 4 $null
      hadd ActionDropCueHT 5 $null
      hadd ActionDropCueHT 6 $null
      hadd ActionDropCueHT 7 $null      
      %tmp0 = 1
      while (%tmp0 <= 4) {
        hadd PlayerReadyNet2HT %tmp0 $false
        inc %tmp0
      }
    }
    if (%ServerReady) {
      if ($hget(GrabbedFlagHT,1)) {
        if ($hget(PlayerAngleHT,4) == 2) {
          %tmp0 = $hget(GrabbedYHT,1)
          %tmp1 = $calc(700 - $hget(GrabbedXHT,1))
        }
        elseif ($hget(PlayerAngleHT,4) == 3) {
          %tmp0 = $calc(700 - $hget(GrabbedXHT,1))
          %tmp1 = $calc(700 - $hget(GrabbedYHT,1))
        }
        else {
          %tmp0 = $calc(700 - $hget(GrabbedYHT,1))
          %tmp1 = $hget(GrabbedXHT,1)
        }
      }      
      else {
        %tmp0 = 0
        %tmp1 = 0
      }
      if ($hget(GrabbedFlagHT,2)) {
        if ($hget(PlayerAngleHT,4) == 2) {
          %tmp2 = $hget(GrabbedYHT,2)
          %tmp3 = $calc(700 - $hget(GrabbedXHT,2))
        }
        elseif ($hget(PlayerAngleHT,4) == 3) {
          %tmp2 = $calc(700 - $hget(GrabbedXHT,2))
          %tmp3 = $calc(700 - $hget(GrabbedYHT,2))
        }
        else {
          %tmp2 = $calc(700 - $hget(GrabbedYHT,2))
          %tmp3 = $hget(GrabbedXHT,2)
        }
      }
      else {
        %tmp2 = 0
        %tmp3 = 0
      }
      if ($hget(GrabbedFlagHT,3)) {
        if ($hget(PlayerAngleHT,4) == 2) {
          %tmp4 = $hget(GrabbedYHT,3)
          %tmp5 = $calc(700 - $hget(GrabbedXHT,3))
        }
        elseif ($hget(PlayerAngleHT,4) == 3) {
          %tmp4 = $calc(700 - $hget(GrabbedXHT,3))
          %tmp5 = $calc(700 - $hget(GrabbedYHT,3))
        }
        else {
          %tmp4 = $calc(700 - $hget(GrabbedYHT,3))
          %tmp5 = $hget(GrabbedXHT,3)
        }
      }
      else {
        %tmp4 = 0
        %tmp5 = 0
      }
      %tmpwrite = O %tmp0 %tmp1 %tmp2 %tmp3 %tmp4 %tmp5
    }
    else {
      %tmpwrite = Q
    }
    if ($hget(GrabbedFlagHT,4)) && ($gettok(%tmpinput,4,32)) {
      hadd GrabbedXHT 4 $gettok(%tmpinput,2,32)
      hadd GrabbedYHT 4 $gettok(%tmpinput,3,32)      
    }
  }  
  elseif ($gettok(%tmpinput,1,32) == H) {
    if (%ServerReady) && (!%ActionDropCueFlag) {
      %tmp2 = $gettok(%tmpinput,2,32)
      if (%tmp2 == 1) {
        if ($gettok(%tmpinput,3,32) == 1) && ($hget(CardPlacementHT,$gettok(%tmpinput,4,32)) != 0) {
          %tmp2 = cancel
        }
        elseif ($gettok(%tmpinput,3,32) == 1) && ($hget(CardStackHT,$gettok(%tmpinput,4,32)) != 0) {
          %tmp2 = cancel
        }
        elseif ($gettok(%tmpinput,3,32) == 1) && ($hget(CardPossessionHT,$gettok(%tmpinput,4,32)) != 0) {
          %tmp2 = cancel
        }
        if ($gettok(%tmpinput,3,32) == 4) && (!$istok(%Stacks,$gettok(%tmpinput,4,32),46)) {
          %tmp2 = cancel
        }
        elseif ($gettok(%tmpinput,3,32) == 4) && ($hget(CardPlacementHT,$hget(StackTopsHT,$gettok(%tmpinput,4,32))) != 0) {
          %tmp2 = cancel
        }
        elseif ($gettok(%tmpinput,3,32) == 4) && ($hget(CardPossessionHT,$hget(StackTopsHT,$gettok(%tmpinput,4,32))) != 0) {
          %tmp2 = cancel
        }
        if ($gettok(%tmpinput,3,32) == 2) && (!$istok(%Stacks,$gettok(%tmpinput,4,32),46)) {
          %tmp2 = cancel
        }
        elseif ($gettok(%tmpinput,3,32) == 2) && ($hget(CardPlacementHT,$hget(StackTopsHT,$gettok(%tmpinput,4,32))) != 0) {
          %tmp2 = cancel
        }
        elseif ($gettok(%tmpinput,3,32) == 2) && ($hget(CardPossessionHT,$hget(StackTopsHT,$gettok(%tmpinput,4,32))) != 0) {
          %tmp2 = cancel
        }
      }
      elseif (%tmp2 == 2) && (!$hget(GrabbedFlagHT,4)) {
        %tmp2 = cancel
      }
      elseif (%tmp2 == 2) && ($hget(GrabbedFlagHT,4)) {
        if ($gettok(%tmpinput,3,32) == 2) && ($hget(CardPlacementHT,$gettok(%tmpinput,4,32)) != 0) {
          %tmp2 = 13
        }
        elseif ($gettok(%tmpinput,3,32) == 2) && ($hget(CardStackHT,$gettok(%tmpinput,4,32)) != 0) {
          %tmp2 = 13
        }
        elseif ($gettok(%tmpinput,3,32) == 2) && ($hget(CardPossessionHT,$gettok(%tmpinput,4,32)) != 0) {
          %tmp2 = 13
        }
        elseif ($gettok(%tmpinput,3,32) == 2) && ($gettok(%tmpinput,4,32) == $hget(GrabbedIDHT,4)) && ($hget(GrabbedTypeHT,4) == 1) {
          %tmp2 = 13
        }
        if ($gettok(%tmpinput,3,32) == 3) && (!$istok(%Stacks,$gettok(%tmpinput,4,32),46)) {
          %tmp2 = 13
        }
        elseif ($gettok(%tmpinput,3,32) == 3) && ($hget(CardPlacementHT,$hget(StackTopsHT,$gettok(%tmpinput,4,32))) != 0) {
          %tmp2 = 13
        }
        elseif ($gettok(%tmpinput,3,32) == 3) && ($hget(CardPossessionHT,$hget(StackTopsHT,$gettok(%tmpinput,4,32))) != 0) {
          %tmp2 = 13
        }
        elseif ($gettok(%tmpinput,3,32) == 3) && ($gettok(%tmpinput,4,32) == $hget(GrabbedIDHT,4)) && ($hget(GrabbedTypeHT,4) == 2) {
          %tmp2 = 13
        }
      }
      elseif (%tmp2 == 3) {
        if ($gettok(%tmpinput,3,32) == 1) && ($hget(CardPlacementHT,$gettok(%tmpinput,4,32)) != 0) {
          %tmp2 = cancel
        }
        elseif ($gettok(%tmpinput,3,32) == 1) && ($hget(CardStackHT,$gettok(%tmpinput,4,32)) != 0) {
          %tmp2 = cancel
        }
        elseif ($gettok(%tmpinput,3,32) == 1) && ($hget(CardPossessionHT,$gettok(%tmpinput,4,32)) != 0) {
          %tmp2 = cancel
        }
        if ($gettok(%tmpinput,3,32) == 2) && (!$istok(%Stacks,$gettok(%tmpinput,4,32),46)) {
          %tmp2 = cancel
        }
        elseif ($gettok(%tmpinput,3,32) == 2) && ($hget(CardPlacementHT,$hget(StackTopsHT,$gettok(%tmpinput,4,32))) != 0) {
          %tmp2 = cancel
        }
        elseif ($gettok(%tmpinput,3,32) == 2) && ($hget(CardPossessionHT,$hget(StackTopsHT,$gettok(%tmpinput,4,32))) != 0) {
          %tmp2 = cancel
        }        
      }
      elseif (%tmp2 == 4) && ($hget(GrabbedFlagHT,4)) {
      }
      elseif (%tmp2 == 4) {
        if ($gettok(%tmpinput,3,32) == 1) && ($hget(CardPlacementHT,$gettok(%tmpinput,4,32)) != 0) {
          %tmp2 = cancel
        }
        elseif ($gettok(%tmpinput,3,32) == 1) && ($hget(CardStackHT,$gettok(%tmpinput,4,32)) != 0) {
          %tmp2 = cancel
        }
        elseif ($gettok(%tmpinput,3,32) == 1) && ($hget(CardPossessionHT,$gettok(%tmpinput,4,32)) != 0) {
          %tmp2 = cancel
        }
        if ($gettok(%tmpinput,3,32) == 2) && (!$istok(%Stacks,$gettok(%tmpinput,4,32),46)) {
          %tmp2 = cancel
        }
        elseif ($gettok(%tmpinput,3,32) == 2) && ($hget(CardPlacementHT,$hget(StackTopsHT,$gettok(%tmpinput,4,32))) != 0) {
          %tmp2 = cancel
        }
        elseif ($gettok(%tmpinput,3,32) == 2) && ($hget(CardPossessionHT,$hget(StackTopsHT,$gettok(%tmpinput,4,32))) != 0) {
          %tmp2 = cancel
        }        
      }
      elseif (%tmp2 == 5) {
        if ($gettok(%tmpinput,3,32) == 1) && ($hget(CardPlacementHT,$gettok(%tmpinput,4,32)) != 0) {
          %tmp2 = cancel
        }
        elseif ($gettok(%tmpinput,3,32) == 1) && ($hget(CardStackHT,$gettok(%tmpinput,4,32)) != 0) {
          %tmp2 = cancel
        }
        elseif ($gettok(%tmpinput,3,32) == 1) && ($hget(CardPossessionHT,$gettok(%tmpinput,4,32)) != 0) {
          %tmp2 = cancel
        }
      }
      elseif (%tmp2 == 6) {
        if ($gettok(%tmpinput,3,32) == 1) && ($hget(CardPlacementHT,$gettok(%tmpinput,4,32)) != 0) {
          %tmp2 = cancel
        }
        elseif ($gettok(%tmpinput,3,32) == 1) && ($hget(CardStackHT,$gettok(%tmpinput,4,32)) != 0) {
          %tmp2 = cancel
        }
        elseif ($gettok(%tmpinput,3,32) == 1) && ($hget(CardPossessionHT,$gettok(%tmpinput,4,32)) != 0) && ($hget(CardPossessionHT,$gettok(%tmpinput,4,32)) != 4) {
          %tmp2 = cancel
        }
        if ($gettok(%tmpinput,3,32) == 2) && (!$istok(%Stacks,$gettok(%tmpinput,4,32),46)) {
          %tmp2 = cancel
        }
        elseif ($gettok(%tmpinput,3,32) == 2) && ($hget(CardPlacementHT,$hget(StackTopsHT,$gettok(%tmpinput,4,32))) != 0) {
          %tmp2 = cancel
        }
        elseif ($gettok(%tmpinput,3,32) == 2) && ($hget(CardPossessionHT,$hget(StackTopsHT,$gettok(%tmpinput,4,32))) != 0) && $&
          ($hget(CardPossessionHT,$hget(StackTopsHT,$gettok(%tmpinput,4,32))) != 4) {
          %tmp2 = cancel
        }        
      }
      elseif (%tmp2 == 7) && (!$hget(GrabbedFlagHT,4)) {
        %tmp2 = cancel
      }
      elseif (%tmp2 == 13) && (!$hget(GrabbedFlagHT,4)) {
        %tmp2 = cancel
      }      
      if (%tmp2 != cancel) {
        if ($gettok(%tmpinput,2,32) == 2) && ($gettok(%tmpinput,3,32) == 1) {
          if ($hget(PlayerAngleHT,4) == 2) {
            %tmp0 = $calc(700 - $gettok(%tmpinput,5,32))
            %tmp1 = $gettok(%tmpinput,4,32)
          }
          elseif ($hget(PlayerAngleHT,4) == 3) {
            %tmp0 = $calc(700 - $gettok(%tmpinput,4,32))
            %tmp1 = $calc(700 - $gettok(%tmpinput,5,32))
          }
          else {
            %tmp0 = $gettok(%tmpinput,5,32)
            %tmp1 = $calc(700 - $gettok(%tmpinput,4,32))
          }
        }
        else {
          %tmp0 = $gettok(%tmpinput,4,32)
          %tmp1 = $gettok(%tmpinput,5,32)
        }
        performaction 4 %tmp2 $gettok(%tmpinput,3,32) %tmp0 %tmp1 $gettok(%tmpinput,6,32) $gettok(%tmpinput,7,32)
        %tmpwrite = P
      }
      else {
        %tmpwrite = P
      }
    }
    else {
      %tmpwrite = Q
    }
  }
  else {
    echo 4 -t @AnyCardStatus Player 4 sent garbage data to server.
    sockclose acPlayer4
    acPlayer4dc
    return
  }  
  sockwrite -n acPlayer4 %tmpwrite
  if ($sockerr > 0) {
    sockclose acPlayer4
    acPlayer4dc
  }
}

on *:sockclose:acPlayer4: {
  acPlayer4dc
}

on *:sockread:acServRequest: {
  if ($sockerr > 0) {
    echo -t @AnyCardStatus Disconnected. Socket error $sockerr found.
    sockclose acServRequest
    acclose
    return
  }
  var %tmpinput, %tmpwrite, %tmp0, %tmp1, %tmp2, %tmp3, %tmp4, %tmpx = $hget(GrabbedYHT,%CurrentPlayer), %tmpy = $hget(GrabbedXHT,%CurrentPlayer)
  sockread %tmpinput
  if ($sockerr > 0) {
    echo -t @AnyCardStatus Disconnected. Socket error $sockerr found.
    sockclose acServRequest
    acclose
    return
  }
  if ($gettok(%tmpinput,1,32) == I) {
    if (v isin $gettok(%tmpinput,2,32)) {
      echo -t @AnyCardStatus This server is using a different version of the AnyCard script.  In order to ensure compatibility between client and server, you should $&
        always use the same, and presumably, the latest version of this script.
    }
    elseif (c isin $gettok(%tmpinput,2,32)) {
      echo -t @AnyCardStatus This server is using a different card deck config file.  It may share the same file name, but the checksum indicates the contents are $&
        different.
    }
    else {
      echo -t @AnyCardStatus This server's password does not match your setting.  Access denied sucka!
    }
    sockclose acServRequest
    acclose
    return    
  }
  elseif ($gettok(%tmpinput,1,32) == J) {
    %tmpwrite = B %CurrentPlayer
    %CurrentData = 1
  }
  elseif ($gettok(%tmpinput,1,32) == K) {
    %tmpwrite = B %CurrentPlayer
    echo -t @AnyCardStatus Server is busy... attempting connection again.
  }
  elseif ($gettok(%tmpinput,1,32) == L) {
    %tmp0 = $null
    if ($gettok(%tmpinput,2,32) == 0) {
      %tmp0 = $addtok(%tmp0,(green),32)
    }
    if ($gettok(%tmpinput,3,32) == 0) {
      %tmp0 = $addtok(%tmp0,(yellow),32)
    }
    if ($gettok(%tmpinput,4,32) == 0) {
      %tmp0 = $addtok(%tmp0,(blue),32)
    }
    if ($gettok(%tmpinput,5,32) == 0) {
      %tmp0 = $addtok(%tmp0,(red),32)
    }
    if (%tmp0 = $null) {
      %tmp0 = none
    }
    echo -t @AnyCardStatus This seat is taken.  Available seating: %tmp0
    sockclose acServRequest
    acclose
    return
  }
  elseif ($gettok(%tmpinput,1,32) == M) {
    %ConnectedToServer = $gettok(%tmpinput,2,32)
    %tmpwrite = C
    echo -t @AnyCardStatus Connecting, please wait.
  }
  elseif ($gettok(%tmpinput,1,32) == N) {
    if (%CurrentData <= %DeckSum) {
      hadd CardStackHT %CurrentData $gettok(%tmpinput,2,32)
      if ($hget(PlayerAngleHT,%ConnectedtoServer) == 2) {
        hadd CardCoordinateXHT %CurrentData $calc(700 - $gettok(%tmpinput,4,32))
        hadd CardCoordinateYHT %CurrentData $gettok(%tmpinput,3,32)
        if ($calc($gettok(%tmpinput,5,32) + 1) <= 4) {
          hadd CardAngleHT %CurrentData $calc($gettok(%tmpinput,5,32) + 1)
        }
        else {
          hadd CardAngleHT %CurrentData 1
        }
      }
      elseif ($hget(PlayerAngleHT,%ConnectedtoServer) == 3) {
        hadd CardCoordinateXHT %CurrentData $calc(700 - $gettok(%tmpinput,3,32))
        hadd CardCoordinateYHT %CurrentData $calc(700 - $gettok(%tmpinput,4,32))
        if ($calc($gettok(%tmpinput,5,32) + 2) <= 4) {
          hadd CardAngleHT %CurrentData $calc($gettok(%tmpinput,5,32) + 2)
        }
        else {
          hadd CardAngleHT %CurrentData $calc(($gettok(%tmpinput,5,32) + 2) % 4)
        }
      }
      else {
        hadd CardCoordinateXHT %CurrentData $gettok(%tmpinput,4,32)
        hadd CardCoordinateYHT %CurrentData $calc(700 - $gettok(%tmpinput,3,32))
        if ($calc($gettok(%tmpinput,5,32) + 3) <= 4) {
          hadd CardAngleHT %CurrentData $calc($gettok(%tmpinput,5,32) + 3)
        }
        else {
          hadd CardAngleHT %CurrentData $calc(($gettok(%tmpinput,5,32) + 3) % 4)
        }
      }
      hadd CardPossessionHT %CurrentData $gettok(%tmpinput,6,32)
      hadd CardFlipFlagHT %CurrentData $gettok(%tmpinput,7,32)
      hadd CardPlacementHT %CurrentData $gettok(%tmpinput,8,32)
      %tmpwrite = C
      inc %CurrentData
    }
    elseif (%CurrentData == $calc(%DeckSum + 1)) {
      %tmp0 = 1
      while (%tmp0 <= 4) {
        hadd GrabbedFlagHT %tmp0 $gettok(%tmpinput,$calc(%tmp0 + 1),32)
        inc %tmp0
      }
      while (%tmp0 <= 8) {
        hadd GrabbedFromStackHT $calc(%tmp0 - 4) $gettok(%tmpinput,$calc(%tmp0 + 1),32)
        inc %tmp0
      }
      while (%tmp0 <= 12) {
        hadd GrabbedFromHandHT $calc(%tmp0 - 8) $gettok(%tmpinput,$calc(%tmp0 + 1),32)
        inc %tmp0
      }
      while (%tmp0 <= 16) {
        hadd GrabbedTypeHT $calc(%tmp0 - 12) $gettok(%tmpinput,$calc(%tmp0 + 1),32)
        inc %tmp0
      }
      while (%tmp0 <= 20) {
        hadd GrabbedIDHT $calc(%tmp0 - 16) $gettok(%tmpinput,$calc(%tmp0 + 1),32)
        inc %tmp0
      }
      while (%tmp0 <= 24) {
        hadd GrabbedXHT $calc(%tmp0 - 16) $gettok(%tmpinput,$calc(%tmp0 + 1),32)
        inc %tmp0
      }
      while (%tmp0 <= 28) {
        hadd GrabbedYHT $calc(%tmp0 - 16) $gettok(%tmpinput,$calc(%tmp0 + 1),32)
        inc %tmp0
      }
      %tmpwrite = C
      inc %CurrentData
    }
    elseif (%CurrentData == $calc(%DeckSum + 2)) {
      %tmp0 = 1
      while (%tmp0 <= 4) {
        hadd PlayerReadyFlagHT %tmp0 $gettok(%tmpinput,$calc(%tmp0 + 1),32)
        inc %tmp0
      }
      %tmpwrite = C
      inc %CurrentData
    }
    elseif (%CurrentData > $calc(%DeckSum + 2)) && (%CurrentData <= $calc(%DeckSum + 2 + $int($calc(%DeckSum / 2)))) {
      %tmp0 = $calc((%CurrentData - 2) - %Decksum)
      hadd StackBottomsHT %tmp0 $gettok(%tmpinput,2,32)
      hadd StackTopsHT %tmp0 $gettok(%tmpinput,3,32)
      hadd StackSizeHT %tmp0 $gettok(%tmpinput,4,32)
      %tmpwrite = C
      inc %CurrentData
    }
    elseif (%CurrentData == $calc(%DeckSum + 3 + $int($calc(%DeckSum / 2)))) {
      if ($numtok(%tmpinput,32) > 1) {
        %HandPlayer1 = $gettok(%tmpinput,2 - $numtok(%tmpinput,32),32)        
      }
      %tmpwrite = C
      inc %CurrentData
    }
    elseif (%CurrentData == $calc(%DeckSum + 4 + $int($calc(%DeckSum / 2)))) {
      if ($numtok(%tmpinput,32) > 1) {
        %HandPlayer2 = $gettok(%tmpinput,2 - $numtok(%tmpinput,32),32)
      }
      %tmpwrite = C
      inc %CurrentData
    }
    elseif (%CurrentData == $calc(%DeckSum + 5 + $int($calc(%DeckSum / 2)))) {
      if ($numtok(%tmpinput,32) > 1) {
        %HandPlayer3 = $gettok(%tmpinput,2 - $numtok(%tmpinput,32),32)
      }
      %tmpwrite = C
      inc %CurrentData
    }
    elseif (%CurrentData == $calc(%DeckSum + 6 + $int($calc(%DeckSum / 2)))) {
      if ($numtok(%tmpinput,32) > 1) {
        %HandPlayer4 = $gettok(%tmpinput,2 - $numtok(%tmpinput,32),32)
      }
      %tmpwrite = C
      inc %CurrentData
    }
    elseif (%CurrentData == $calc(%DeckSum + 7 + $int($calc(%DeckSum / 2)))) {
      if ($numtok(%tmpinput,32) > 1) {
        %Layers = $gettok(%tmpinput,2 - $numtok(%tmpinput,32),32)
      }
      %tmpwrite = C
      inc %CurrentData
    }
    elseif (%CurrentData == $calc(%DeckSum + 8 + $int($calc(%DeckSum / 2)))) {
      if ($numtok(%tmpinput,32) > 1) {
        %Claimed = $gettok(%tmpinput,2 - $numtok(%tmpinput,32),32)
      }
      %tmpwrite = C
      inc %CurrentData
    }
    elseif (%CurrentData == $calc(%DeckSum + 9 + $int($calc(%DeckSum / 2)))) {
      if ($numtok(%tmpinput,32) > 1) {
        %Stacks = $gettok(%tmpinput,2 - $numtok(%tmpinput,32),32)
        %tmp0 = 1
        while (%tmp0 <= $numtok(%Stacks,46)) {
          %tmp1 = $findtok(%Layers,$hget(StackBottomsHT,$gettok(%Stacks,%tmp0,46)),1,46)
          %tmp3 = $calc(%tmp1 + 1)
          %tmp5 = $hget(StackBottomsHT,$gettok(%Stacks,%tmp0,46))
          %tmp2 = $findtok(%Layers,$hget(StackTopsHT,$gettok(%Stacks,%tmp0,46)),1,46)
          while (%tmp3 <= %tmp2) {
            %tmp4 = $gettok(%Layers,%tmp3,46)
            hadd CardCoordinateXHT %tmp4 $hget(CardCoordinateXHT,%tmp5)
            hadd CardCoordinateYHT %tmp4 $calc($hget(CardCoordinateYHT,%tmp5) - $int($calc((%tmp3 - %tmp1) * %StackSpacing)))
            inc %tmp3
          }
          inc %tmp0
        }
      }
      %tmpwrite = C
      inc %CurrentData
    }
    elseif (%CurrentData == $calc(%DeckSum + 10 + $int($calc(%DeckSum / 2)))) {
      hadd ConnectedPlayerIPHT 1 $gettok(%tmpinput,2,32)
      hadd ConnectedPlayerIPHT 2 $gettok(%tmpinput,3,32)
      hadd ConnectedPlayerIPHT 3 $gettok(%tmpinput,4,32)
      hadd ConnectedPlayerIPHT 4 $gettok(%tmpinput,5,32)
      %tmpwrite = C
      inc %CurrentData
    }
    elseif (%CurrentData == $calc(%DeckSum + 11 + $int($calc(%DeckSum / 2)))) {
      if (%CurrentPlayer != 1) {
        hadd PlayerFlagHT 1 $gettok(%tmpinput,2,32)
      }
      if (%CurrentPlayer != 2) {
        hadd PlayerFlagHT 2 $gettok(%tmpinput,3,32)
      }
      if (%CurrentPlayer != 3) {
        hadd PlayerFlagHT 3 $gettok(%tmpinput,4,32)
      }
      if (%CurrentPlayer != 4) {
        hadd PlayerFlagHT 4 $gettok(%tmpinput,5,32)
      }    
      %tmpwrite = D
      inc %CurrentData
    }
    if (%CurrentData == $calc(%DeckSum + 12 + $int($calc(%DeckSum / 2)))) {
      hadd ConnectedPlayerIPHT %ConnectedToServer %ConnectedToServerIP 
      %tmp0 = 1
      drawcopy @TcharBuffer 0 0 258 154 @MenuBuffer 223 22
      while (%tmp0 <= 700) {
        drawcopy @MenuBuffer 0 0 700 700 @DrawBuffer 0 0
        drawcopy @CardTable 0 0 700 700 @Drawbuffer $int($calc(350 - (%tmp0 / 2))) $int($calc(350 - (%tmp0 / 2))) %tmp0 %tmp0
        drawcopy @DrawBuffer 0 0 700 700 @AnyCard 0 0
        inc %tmp0 5
      }
      drawcopy -t @TableShadow $rgb(164,64,64) 0 660 700 40 @CardTable 0 660
      %tmp0 = 1
      while (%tmp0 <= 4) {
        drawhand %tmp0
        inc %tmp0
      }
      drawtable
      %FullyConnected = $true
      drawfinal
      .timeracanimate off
      %GameMode = 2
      .timeraccycle -o 0 0 acmaincycle
      echo -t @AnyCardStatus Client started.
      echo -t @AnyCardStatus Please remember that cheating by manipulating this script isn't a stretch.  Choose your opponents carefully.
    }
  }
  elseif ($gettok(%tmpinput,1,32) == O) {
    if (%CurrentPlayer == 1) {
      if ($hget(GrabbedFlagHT,2)) {
        hadd GrabbedXHT 2 $gettok(%tmpinput,2,32)
        hadd GrabbedYHT 2 $gettok(%tmpinput,3,32)
      }
      if ($hget(GrabbedFlagHT,3)) {
        hadd GrabbedXHT 3 $gettok(%tmpinput,4,32)
        hadd GrabbedYHT 3 $gettok(%tmpinput,5,32)
      }
      if ($hget(GrabbedFlagHT,4)) {
        hadd GrabbedXHT 4 $gettok(%tmpinput,6,32)
        hadd GrabbedYHT 4 $gettok(%tmpinput,7,32)    
      }
    }
    elseif (%CurrentPlayer == 2) {
      if ($hget(GrabbedFlagHT,1)) {
        hadd GrabbedXHT 1 $gettok(%tmpinput,2,32)
        hadd GrabbedYHT 1 $gettok(%tmpinput,3,32)
      }
      if ($hget(GrabbedFlagHT,3)) {
        hadd GrabbedXHT 3 $gettok(%tmpinput,4,32)
        hadd GrabbedYHT 3 $gettok(%tmpinput,5,32)
      }
      if ($hget(GrabbedFlagHT,4)) {
        hadd GrabbedXHT 4 $gettok(%tmpinput,6,32)
        hadd GrabbedYHT 4 $gettok(%tmpinput,7,32)    
      }  
    }
    elseif (%CurrentPlayer == 3) {
      if ($hget(GrabbedFlagHT,1)) {
        hadd GrabbedXHT 1 $gettok(%tmpinput,2,32)
        hadd GrabbedYHT 1 $gettok(%tmpinput,3,32)
      }
      if ($hget(GrabbedFlagHT,2)) {
        hadd GrabbedXHT 2 $gettok(%tmpinput,4,32)
        hadd GrabbedYHT 2 $gettok(%tmpinput,5,32)
      }
      if ($hget(GrabbedFlagHT,4)) {
        hadd GrabbedXHT 4 $gettok(%tmpinput,6,32)
        hadd GrabbedYHT 4 $gettok(%tmpinput,7,32)    
      }
    }
    else {
      if ($hget(GrabbedFlagHT,1)) {
        hadd GrabbedXHT 1 $gettok(%tmpinput,2,32)
        hadd GrabbedYHT 1 $gettok(%tmpinput,3,32)
      }
      if ($hget(GrabbedFlagHT,2)) {
        hadd GrabbedXHT 2 $gettok(%tmpinput,4,32)
        hadd GrabbedYHT 2 $gettok(%tmpinput,5,32)
      }
      if ($hget(GrabbedFlagHT,3)) {
        hadd GrabbedXHT 3 $gettok(%tmpinput,6,32)
        hadd GrabbedYHT 3 $gettok(%tmpinput,7,32)    
      }
    }
    if (%ActionCueFlag) && (!%WaitingOnSecReq) {
      %tmpwrite = H $hget(ActionCueHT,2) $hget(ActionCueHT,3) $hget(ActionCueHT,4) $hget(ActionCueHT,5) $&
        $hget(ActionCueHT,6) $hget(ActionCueHT,7) 
    }
    elseif (%ActionDropCueFlag) {
      %tmpwrite = H $hget(ActionDropCueHT,2) $hget(ActionDropCueHT,3) $hget(ActionDropCueHT,4) $hget(ActionDropCueHT,5) $&
        $hget(ActionDropCueHT,6) $hget(ActionDropCueHT,7)
      %WaitingOnSecReq = $true
    }    
    else {
      %ServerReady = $true
      if ($hget(GrabbedFlagHT,%CurrentPlayer)) {
        if ($hget(PlayerAngleHT,%ConnectedToServer) == 2) {
          %tmp0 = $hget(GrabbedYHT,%CurrentPlayer)
          %tmp1 = $calc(700 - $hget(GrabbedXHT,%CurrentPlayer))
        }
        elseif ($hget(PlayerAngleHT,%ConnectedToServer) == 3) {
          %tmp0 = $calc(700 - $hget(GrabbedXHT,%CurrentPlayer))
          %tmp1 = $calc(700 - $hget(GrabbedYHT,%CurrentPlayer))
        }
        else {
          %tmp0 = $calc(700 - $hget(GrabbedYHT,%CurrentPlayer))
          %tmp1 = $hget(GrabbedXHT,%CurrentPlayer)
        }
        %tmp2 = $true
      }
      else {
        %tmp0 = %tmpx
        %tmp1 = %tmpy
        %tmp2 = $false
      }
      %tmpwrite = E %tmp0 %tmp1 %tmp2
    }
  }
  elseif ($gettok(%tmpinput,1,32) == P) {
    if (%ActionCueFlag) && (!%WaitingOnSecReq) {
      %ServerReady = $false
      %ActionCueFlag = $false
      if ($gettok(%tmpinput,3,32) == 13) || ($gettok(%tmpinput,3,32) == 2) {
        %AvoidRepeat = $true
      }
    }
    elseif (%ActionDropCueFlag) {
      %ServerReady = $false
      %ActionDropCueFlag = $false
      if ($gettok(%tmpinput,3,32) == 13) || ($gettok(%tmpinput,3,32) == 2) {
        %AvoidRepeat = $true
      }
      %WaitingOnSecReq = $false
    }    
    if ($hget(GrabbedFlagHT,%CurrentPlayer)) {
      if ($hget(PlayerAngleHT,%ConnectedToServer) == 2) {
        %tmp0 = $hget(GrabbedYHT,%CurrentPlayer)
        %tmp1 = $calc(700 - $hget(GrabbedXHT,%CurrentPlayer))
      }
      elseif ($hget(PlayerAngleHT,%ConnectedToServer) == 3) {
        %tmp0 = $calc(700 - $hget(GrabbedXHT,%CurrentPlayer))
        %tmp1 = $calc(700 - $hget(GrabbedYHT,%CurrentPlayer))
      }
      else {
        %tmp0 = $calc(700 - $hget(GrabbedYHT,%CurrentPlayer))
        %tmp1 = $hget(GrabbedXHT,%CurrentPlayer)
      }
      %tmp2 = $true
    }
    else {
      %tmp0 = %tmpx
      %tmp1 = %tmpy
      %tmp2 = $false
    }
    %tmpwrite = E %tmp0 %tmp1 %tmp2
  }
  elseif ($gettok(%tmpinput,1,32) == Q) {
    %ServerReady = $false
    if ($hget(GrabbedFlagHT,%CurrentPlayer)) {
      if ($hget(PlayerAngleHT,%ConnectedToServer) == 2) {
        %tmp0 = $hget(GrabbedYHT,%CurrentPlayer)
        %tmp1 = $calc(700 - $hget(GrabbedXHT,%CurrentPlayer))
      }
      elseif ($hget(PlayerAngleHT,%ConnectedToServer) == 3) {
        %tmp0 = $calc(700 - $hget(GrabbedXHT,%CurrentPlayer))
        %tmp1 = $calc(700 - $hget(GrabbedYHT,%CurrentPlayer))
      }
      else {
        %tmp0 = $calc(700 - $hget(GrabbedYHT,%CurrentPlayer))
        %tmp1 = $hget(GrabbedXHT,%CurrentPlayer)
      }
      %tmp2 = $true
    }
    else {
      %tmp0 = %tmpx
      %tmp1 = %tmpy
      %tmp2 = $false
    }
    %tmpwrite = E %tmp0 %tmp1 %tmp2
  }
  elseif ($gettok(%tmpinput,1,32) == R) {
    if ($gettok(%tmpinput,3,32) == 2) && ($gettok(%tmpinput,4,32) == 1) {
      if ($hget(PlayerAngleHT,%ConnectedToServer) == 2) {
        %tmp0 = $calc(700 - $gettok(%tmpinput,6,32))
        %tmp1 = $gettok(%tmpinput,5,32)
      }
      elseif ($hget(PlayerAngleHT,%ConnectedToServer) == 3) {
        %tmp0 = $calc(700 - $gettok(%tmpinput,5,32))
        %tmp1 = $calc(700 - $gettok(%tmpinput,6,32))
      }
      else {
        %tmp0 = $gettok(%tmpinput,6,32)
        %tmp1 = $calc(700 - $gettok(%tmpinput,5,32))
      }
    }
    else {
      %tmp0 = $gettok(%tmpinput,5,32)
      %tmp1 = $gettok(%tmpinput,6,32)
    }
    %ServerCommanded = $true
    performaction $gettok(%tmpinput,2,32) $gettok(%tmpinput,3,32) $gettok(%tmpinput,4,32) %tmp0 %tmp1 $gettok(%tmpinput,7,32) $&
      $gettok(%tmpinput,8,32)
    %ServerCommanded = $false
    if ($gettok(%tmpinput,2,32) == %CurrentPlayer) && ($gettok(%tmpinput,3,32) == 1) {
      if (%CuedGrab) {
        %CuedGrab = $false
      }
    }
    if ($hget(GrabbedFlagHT,%CurrentPlayer)) {
      if ($hget(PlayerAngleHT,%ConnectedToServer) == 2) {
        %tmp0 = $hget(GrabbedYHT,%CurrentPlayer)
        %tmp1 = $calc(700 - $hget(GrabbedXHT,%CurrentPlayer))
      }
      elseif ($hget(PlayerAngleHT,%ConnectedToServer) == 3) {
        %tmp0 = $calc(700 - $hget(GrabbedXHT,%CurrentPlayer))
        %tmp1 = $calc(700 - $hget(GrabbedYHT,%CurrentPlayer))
      }
      else {
        %tmp0 = $calc(700 - $hget(GrabbedYHT,%CurrentPlayer))
        %tmp1 = $hget(GrabbedXHT,%CurrentPlayer)
      }
      %tmp2 = $true
    }
    else {
      %tmp0 = %tmpx
      %tmp1 = %tmpy
      %tmp2 = $false
    }
    %tmpwrite = F %tmp0 %tmp1 %tmp2
  }
  elseif ($gettok(%tmpinput,1,32) == S) {
    if ($gettok(%tmpinput,3,32) == 2) && ($gettok(%tmpinput,4,32) == 1) {
      if ($hget(PlayerAngleHT,%ConnectedToServer) == 2) {
        %tmp0 = $calc(700 - $gettok(%tmpinput,6,32))
        %tmp1 = $gettok(%tmpinput,5,32)
      }
      elseif ($hget(PlayerAngleHT,%ConnectedToServer) == 3) {
        %tmp0 = $calc(700 - $gettok(%tmpinput,5,32))
        %tmp1 = $calc(700 - $gettok(%tmpinput,6,32))
      }
      else {
        %tmp0 = $gettok(%tmpinput,6,32)
        %tmp1 = $calc(700 - $gettok(%tmpinput,5,32))
      }
    }
    else {
      %tmp0 = $gettok(%tmpinput,5,32)
      %tmp1 = $gettok(%tmpinput,6,32)
    }
    %ServerCommanded = $true
    performaction $gettok(%tmpinput,2,32) $gettok(%tmpinput,3,32) $gettok(%tmpinput,4,32) %tmp0 %tmp1 $gettok(%tmpinput,7,32) $&
      $gettok(%tmpinput,8,32)
    %ServerCommanded = $false
    if ($gettok(%tmpinput,2,32) == %CurrentPlayer) && ($gettok(%tmpinput,3,32) == 1) {
      if (%CuedGrab) {
        %CuedGrab = $false
      }
    }
    if ($hget(GrabbedFlagHT,%CurrentPlayer)) {
      if ($hget(PlayerAngleHT,%ConnectedToServer) == 2) {
        %tmp0 = $hget(GrabbedYHT,%CurrentPlayer)
        %tmp1 = $calc(700 - $hget(GrabbedXHT,%CurrentPlayer))
      }
      elseif ($hget(PlayerAngleHT,%ConnectedToServer) == 3) {
        %tmp0 = $calc(700 - $hget(GrabbedXHT,%CurrentPlayer))
        %tmp1 = $calc(700 - $hget(GrabbedYHT,%CurrentPlayer))
      }
      else {
        %tmp0 = $calc(700 - $hget(GrabbedYHT,%CurrentPlayer))
        %tmp1 = $hget(GrabbedXHT,%CurrentPlayer)
      }
      %tmp2 = $true
    }
    else {
      %tmp0 = %tmpx
      %tmp1 = %tmpy
      %tmp2 = $false
    }
    %tmpwrite = G %tmp0 %tmp1 %tmp2
  }
  else {
    echo -t @AnyCardStatus Disconnected. Received bad data from server.
    acclose
    return
  }
  sockwrite -n acServRequest %tmpwrite
  if ($sockerr > 0) {
    echo -t @AnyCardStatus Disconnected. Socket error $sockerr found.
    sockclose acServRequest
    acclose
  }
}

on *:sockopen:acServRequest: {
  if ($sockerr > 0) {
    sockclose acServRequest
    echo -t @AnyCardStatus Unable to connect to server.  If you're certain that you entered the address information correctly, it may be that the server is busy.
    acclose
    return
  }
  sockwrite -n acServRequest A %VersionNumber $gettok(%MenuConfig,2,39) $crc($+(anycard/,$gettok(%MenuConfig,2,39)),2) $gettok(%MenuConfig,11,39)
  if ($sockerr > 0) {
    echo -t @AnyCardStatus Disconnected. Socket error $sockerr found.
    sockclose acServRequest
    acclose
  }
}

on *:sockclose:acServRequest: {
  echo -t @AnyCardStatus Disconnected.
  acclose
}

on *:CLOSE:@AnyCard:acmainclose

on *:KEYDOWN:@AnyCard:48,49,50,51,52,53,54,55,56,57: {
  var %tmpx = $mouse.x, %tmpy = $mouse.y
  if (%GameMode == 1) && (%Editing) {
    if ($keyval == 51) && ($keychar != 3) {
      editinfo %EditID $chr(35)
    }
    else {
      editinfo %EditID $calc($keyval - 48)
    }
  }
  elseif (%GameMode == 2) {
    if (!$hget(GrabbedFlagHT,%CurrentPlayer)) && (%Peaked == 0) {
      if ($keyval == 49) {
        if ($inrect(%tmpx,%tmpy,65,65,570,570)) && (!$inrect(%tmpx,%tmpy,65,595,528,80)) {
          %CardMode = 0
          drawmouse
        }
        elseif ($inrect(%tmpx,%tmpy,65,595,528,80)) && (%CardMode == 1) {
          %CardMode = 0
          drawmouse
        }
      }
      elseif ($keyval == 50) {
        if ($inrect(%tmpx,%tmpy,65,65,570,570)) && (!$inrect(%tmpx,%tmpy,65,595,528,80)) {
          %CardMode = 1
          drawmouse
        }
        elseif ($inrect(%tmpx,%tmpy,65,595,528,80)) && (%CardMode == 0) {
          %CardMode = 1
          drawmouse
        }
      }
      elseif ($keyval == 51) {
        if ($inrect(%tmpx,%tmpy,65,65,570,570)) && (!$inrect(%tmpx,%tmpy,65,595,528,80)) {
          %CardMode = 2
          drawmouse
        }
      }
      elseif ($keyval == 52) {
        if ($inrect(%tmpx,%tmpy,65,65,570,570)) && (!$inrect(%tmpx,%tmpy,65,595,528,80)) {
          %CardMode = 3
          drawmouse
        }
      }
      elseif ($keyval == 53) {
        if ($inrect(%tmpx,%tmpy,65,65,570,570)) && (!$inrect(%tmpx,%tmpy,65,595,528,80)) {
          %CardMode = 4
          drawmouse
        }
      }
      elseif ($keyval == 54) {
        if ($inrect(%tmpx,%tmpy,65,65,570,570)) && (!$inrect(%tmpx,%tmpy,65,595,528,80)) {
          %CardMode = 5
          drawmouse
        }
      }
    }
  }
}

on *:KEYDOWN:@AnyCard:65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90: {
  if (%GameMode == 1) && (%Editing) {
    editinfo %EditID $lower($keychar)
  }
}

on *:KEYDOWN:@AnyCard:8,13,189,190: {
  if (%GameMode == 1) && (%Editing) {
    if ($keyval == 8) {
      editinfo %EditID backspace
    }
    elseif ($keyval == 13) {
      editinfo %EditID finish
    }
    elseif ($keyval == 189) && ($keychar == _) {
      editinfo %EditID $keychar
    }
    elseif ($keychar == .) {
      editinfo %EditID $keychar
    }
  }
}

on *:KEYDOWN:@AnyCard:37,81: {
  if (%ActionsMarker > 1) && (%GameMode == 2) {
    dec %ActionsMarker
    drawactions
    drawfinal
  }
}

on *:KEYDOWN:@AnyCard:39,87: {
  if (%ActionsMarker < 35) && (%GameMode == 2) {
    inc %ActionsMarker
    drawactions
    drawfinal
  }
}

menu @AnyCard {
  leave: {
    %MouseInWindow = $false
  }
  mouse: {
    var %tmpx = $mouse.x, %tmpy = $mouse.y
    %MouseInWindow = $true
    if (%GameMode == 1) {
    }
    elseif (%GameMode == 2) {
      drawmouse
      if ($hget(GrabbedFlagHT,%CurrentPlayer)) || (%CuedGrab) {
        if (!$inrect(%tmpx,%tmpy,65,635,528,40)) && (!$inrect(%tmpx,%tmpy,65,65,570,570)) {
          if (%Server) && (%ActionDropCueFlag) {
            return
          }
          elseif (!%Server) {
            if (%AvoidRepeat) {
              return
            }
            if (%ActionCueFlag) {
              if ($hget(ActionCueHT,2) == 13) || ($hget(ActionCueHT,2) == 2) {
                return
              }
            }
            if (%ActionDropCueFlag) {
              if ($hget(ActionDropCueHT,2) == 13) || ($hget(ActionDropCueHT,2) == 2) {
                return
              }
            }
          }
          performaction %CurrentPlayer 13 out of bounds
        }
      }
    }
  }
  sclick: {
    var %tmpx = $mouse.x, %tmpy = $mouse.y, %tmpselect, %tmphand, %p1 = $false, %p2 = $false, %p3 = $false, %p4 = $false, %tmp0, %tmp1
    if (%GameMode == 1) && (!%LoadingTable) {
      if ($inrect(%tmpx,%tmpy,82,202,206,21)) {        
        if (!%Editing) {
          editinfo 1 start
        }
        elseif (%Editing) && (%EditID != 1) {
          editinfo %EditID finish
          editinfo 1 start
        }
      }
      elseif ($inrect(%tmpx,%tmpy,82,252,206,21)) {
        if (!%Editing) {
          editinfo 2 start
        }
        elseif (%Editing) && (%EditID != 2) {
          editinfo %EditID finish
          editinfo 2 start
        }
      }
      elseif ($inrect(%tmpx,%tmpy,82,302,206,21)) {
        if (!%Editing) {
          editinfo 3 start
        }
        elseif (%Editing) && (%EditID != 3) {
          editinfo %EditID finish
          editinfo 3 start
        }
      }
      elseif ($inrect(%tmpx,%tmpy,82,412,206,21)) {
        if (!%Editing) {
          editinfo 4 start
        }
        elseif (%Editing) && (%EditID != 4) {
          editinfo %EditID finish
          editinfo 4 start
        }
      }
      elseif ($inrect(%tmpx,%tmpy,82,462,206,21)) {
        if (!%Editing) {
          editinfo 5 start
        }
        elseif (%Editing) && (%EditID != 5) {
          editinfo %EditID finish
          editinfo 5 start
        } 
      }
      elseif ($inrect(%tmpx,%tmpy,82,512,206,21)) {
        if (!%Editing) {
          editinfo 6 start
        }
        elseif (%Editing) && (%EditID != 6) {
          editinfo %EditID finish
          editinfo 6 start
        } 
      }
      elseif ($inrect(%tmpx,%tmpy,82,562,101,21)) {
        if (!%Editing) {
          editinfo 7 start
        }
        elseif (%Editing) && (%EditID != 7) {
          editinfo %EditID finish
          editinfo 7 start
        } 
      }
      elseif ($inrect(%tmpx,%tmpy,382,232,206,21)) {
        if (!%Editing) {
          editinfo 8 start
        }
        elseif (%Editing) && (%EditID != 8) {
          editinfo %EditID finish
          editinfo 8 start
        } 
      }
      elseif ($inrect(%tmpx,%tmpy,382,282,101,21)) {
        if (!%Editing) {
          editinfo 9 start
        }
        elseif (%Editing) && (%EditID != 9) {
          editinfo %EditID finish
          editinfo 9 start
        } 
      }
      elseif ($inrect(%tmpx,%tmpy,382,332,206,21)) {
        if (!%Editing) {
          editinfo 10 start
        }
        elseif (%Editing) && (%EditID != 10) {
          editinfo %EditID finish
          editinfo 10 start
        } 
      }
      elseif ($inrect(%tmpx,%tmpy,382,442,101,21)) {
        if (!%Editing) {
          editinfo 11 start
        }
        elseif (%Editing) && (%EditID != 11) {
          editinfo %EditID finish
          editinfo 11 start
        } 
      }
      elseif ($inrect(%tmpx,%tmpy,382,492,206,21)) {
        if (!%Editing) {
          editinfo 12 start
        }
        elseif (%Editing) && (%EditID != 12) {
          editinfo %EditID finish
          editinfo 12 start
        } 
      }
      elseif ($inrect(%tmpx,%tmpy,295,360,25,25)) {
        %MenuConfig = $puttok(%MenuConfig,$xor($gettok(%MenuConfig,4,39),1),4,39)
        drawmenu 13
      }
      elseif ($inrect(%tmpx,%tmpy,595,180,25,25)) {
        if (%Editing) {
          editinfo %EditID finish
        }
        %MenuConfig = $puttok(%MenuConfig,$editcheck(1),15,39)
        %MenuConfig = $puttok(%MenuConfig,$editcheck(2),16,39)
        %MenuConfig = $puttok(%MenuConfig,$editcheck(3),17,39)
        %MenuConfig = $puttok(%MenuConfig,$editcheck(8),22,39)
        %MenuConfig = $puttok(%MenuConfig,$editcheck(9),23,39)                
        drawmenu 15
        if ($gettok(%MenuConfig,22,39)) && ($gettok(%MenuConfig,23,39)) {
          if ($gettok(%MenuConfig,15,39)) && ($gettok(%MenuConfig,16,39)) && ($gettok(%MenuConfig,17,39)) {
            acstart $false
          }
        }
      }
      elseif ($inrect(%tmpx,%tmpy,595,390,25,25)) {
        if (%Editing) {
          editinfo %EditID finish
        }
        %MenuConfig = $puttok(%MenuConfig,$editcheck(1),15,39)
        %MenuConfig = $puttok(%MenuConfig,$editcheck(2),16,39)
        %MenuConfig = $puttok(%MenuConfig,$editcheck(3),17,39)
        %MenuConfig = $puttok(%MenuConfig,$editcheck(11),25,39)                
        drawmenu 15
        if ($gettok(%MenuConfig,25,39)) {
          if ($gettok(%MenuConfig,15,39)) && ($gettok(%MenuConfig,16,39)) && ($gettok(%MenuConfig,17,39)) {
            acstart $true
          }
        }        
      }
      elseif ($inrect(%tmpx,%tmpy,410,570,25,25)) {
        %MenuConfig = $puttok(%MenuConfig,1,14,39)
        drawmenu 14
      }
      elseif ($inrect(%tmpx,%tmpy,470,570,25,25)) {
        %MenuConfig = $puttok(%MenuConfig,2,14,39)
        drawmenu 14
      }
      elseif ($inrect(%tmpx,%tmpy,530,570,25,25)) {
        %MenuConfig = $puttok(%MenuConfig,3,14,39)
        drawmenu 14
      }
      elseif ($inrect(%tmpx,%tmpy,590,570,25,25)) {
        %MenuConfig = $puttok(%MenuConfig,4,14,39)
        drawmenu 14      
      }
    }
    elseif (%GameMode == 2) {
      if ($inrect(%tmpx,%tmpy,20,600,25,25)) && (%Server) {
        if (%Purgable1) || (%Purgable2) || (%Purgable3) || (%Purgable4) {
          if (%Purgable1) {
            %p1 = $true
          }
          if (%Purgable2) {
            %p2 = $true
          }
          if (%Purgable3) {
            %p3 = $true
          }
          if (%Purgable4) {
            %p4 = $true
          }
          performaction %CurrentPlayer 14 %p1 %p2 %p3 %p4
        }
      }
      elseif ($inrect(%tmpx,%tmpy,52,52,25,25)) && (%Server) {
        if ($hget(PlayerAngleHT,2) == 1) && ($hget(PlayerFlagHT,1) == 1) {
          sockclose acplayer1
          acplayer1dc
        }
        if ($hget(PlayerAngleHT,2) == 2) && ($hget(PlayerFlagHT,2) == 1) {
          sockclose acPlayer2
          acPlayer2dc
        }
        if ($hget(PlayerAngleHT,2) == 3) && ($hget(PlayerFlagHT,3) == 1) {
          sockclose acplayer3
          acplayer3dc
        }
        if ($hget(PlayerAngleHT,2) == 4) && ($hget(PlayerFlagHT,4) == 1) {
          sockclose acplayer4
          acplayer4dc
        }
      }
      elseif ($inrect(%tmpx,%tmpy,622,52,25,25)) && (%Server) {
        if ($hget(PlayerAngleHT,3) == 1) && ($hget(PlayerFlagHT,1) == 1) {
          sockclose acplayer1
          acplayer1dc
        }
        if ($hget(PlayerAngleHT,3) == 2) && ($hget(PlayerFlagHT,2) == 1) {
          sockclose acPlayer2
          acPlayer2dc
        }
        if ($hget(PlayerAngleHT,3) == 3) && ($hget(PlayerFlagHT,3) == 1) {
          sockclose acplayer3
          acplayer3dc
        }
        if ($hget(PlayerAngleHT,3) == 4) && ($hget(PlayerFlagHT,4) == 1) {
          sockclose acplayer4
          acplayer4dc
        }
      }
      elseif ($inrect(%tmpx,%tmpy,622,622,25,25)) && (%Server) {
        if ($hget(PlayerAngleHT,4) == 1) && ($hget(PlayerFlagHT,1) == 1) {
          sockclose acplayer1
          acplayer1dc
        }
        if ($hget(PlayerAngleHT,4) == 2) && ($hget(PlayerFlagHT,2) == 1) {
          sockclose acPlayer2
          acPlayer2dc
        }
        if ($hget(PlayerAngleHT,4) == 3) && ($hget(PlayerFlagHT,3) == 1) {
          sockclose acplayer3
          acplayer3dc
        }
        if ($hget(PlayerAngleHT,4) == 4) && ($hget(PlayerFlagHT,4) == 1) {
          sockclose acplayer4
          acplayer4dc
        }
      } 
      elseif ($inrect(%tmpx,%tmpy,675,0,25,25)) {
        acclose
      }
      elseif ($inrect(%tmpx,%tmpy,20,635,25,25)) {
        if (%ActionsMarker > 1) {
          dec %ActionsMarker
          drawactions
          drawfinal
        }
      }
      elseif ($inrect(%tmpx,%tmpy,655,635,25,25)) {
        if (%ActionsMarker < 35) {
          inc %ActionsMarker
          drawactions
          drawfinal
        }
      }
      elseif ($inrect(%tmpx,%tmpy,20,600,25,25)) {
        if (%PurgableHands) {
          performaction 14
        }
      }
      elseif ($inrect(%tmpx,%tmpy,45,615,40,40)) {
        performaction %CurrentPlayer 12
      }
      elseif ($inrect(%tmpx,%tmpy,65,595,528,80)) && (!$inrect(%tmpx,%tmpy,65,615,20,40)) {      
        if (%CurrentPlayer == 1) {
          %tmphand = %HandPlayer1
        }
        elseif (%CurrentPlayer == 2) {
          %tmphand = %HandPlayer2
        }
        elseif (%CurrentPlayer == 3) {
          %tmphand = %HandPlayer3
        }
        else {
          %tmphand = %HandPlayer4
        }
        %tmpselect = $int($calc(((%tmpx - 65) / 12) + 1))
        if ($numtok(%tmphand,46) <= %tmpselect) && ($numtok(%tmphand,46) > 0) {
          if (%tmpx < $calc(($numtok(%tmphand,46) * 12) + 65 + 48)) {
            %tmpselect = $numtok(%tmphand,46)
          }
        }
        if (%tmpselect <= $numtok(%tmphand,46)) {
          if (%CardMode <= 1) {
            performaction %CurrentPlayer 1 3 %tmpselect
          }
        }
      }
      elseif ($inrect(%tmpx,%tmpy,65,65,570,570)) && (!$inrect(%tmpx,%tmpy,65,595,528,80)) {
        %tmpselect = $int($rgb($getdot(@DetectCard,%tmpx,%tmpy)))
        if (%tmpselect != 0) {
          if (%CardMode == 0) {
            if ($hget(CardPossessionHT,%tmpselect) == 0) {
              if ($hget(CardStackHT,%tmpselect) == 0) {
                performaction %CurrentPlayer 1 1 %tmpselect
              }
              else {
                performaction %CurrentPlayer 1 4 $hget(CardStackHT,%tmpselect)
              }
            }
          }
          elseif (%CardMode == 1) {
            if ($hget(CardPossessionHT,%tmpselect) == 0) {
              if ($hget(CardStackHT,%tmpselect) == 0) {
                performaction %CurrentPlayer 1 1 %tmpselect
              }
              else {
                performaction %CurrentPlayer 1 2 $hget(CardStackHT,%tmpselect)
              }
            }
          }
          elseif (%CardMode == 2) {
            if ($hget(CardPossessionHT,%tmpselect) == 0) {
              if ($hget(CardStackHT,%tmpselect) == 0) {
                performaction %CurrentPlayer 3 1 %tmpselect
              }
              else {
                performaction %CurrentPlayer 3 2 $hget(CardStackHT,%tmpselect)
              }
            }
          }
          elseif (%CardMode == 3) {
            if ($hget(CardPossessionHT,%tmpselect) == 0) {
              if ($hget(CardStackHT,%tmpselect) == 0) {
                performaction %CurrentPlayer 4 1 %tmpselect
              }
              else {
                performaction %CurrentPlayer 4 2 $hget(CardStackHT,%tmpselect)
              }
            }
          }
          elseif (%CardMode == 4) {
            if ($hget(CardPossessionHT,%tmpselect) == 0) {
              if ($hget(CardStackHT,%tmpselect) == 0) {
                splay -w $+($mircdir,anycard\takecard.wav)
                %peaked = %tmpselect
                performaction %CurrentPlayer 5
              }
            }
          }
          elseif (%CardMode == 5) {
            if ($hget(CardPossessionHT,%tmpselect) == 0) || ($hget(CardPossessionHT,%tmpselect) == %CurrentPlayer) {
              if ($hget(CardStackHT,%tmpselect) == 0) {
                performaction %CurrentPlayer 6 1 %tmpselect
              }
              else {
                performaction %CurrentPlayer 6 2 $hget(CardStackHT,%tmpselect)
              }
            }
          }
        }
        else {
          performaction %CurrentPlayer 8
        }
      }
    }
  }
  rclick: {
    var %tmpx = $mouse.x, %tmpy = $mouse.y
    if (%GameMode == 1) {
    }
    elseif (%GameMode == 2) {
      if (!$hget(GrabbedFlagHT,%CurrentPlayer)) && (%Peaked == 0) {
        if ($inrect(%tmpx,%tmpy,65,595,528,80)) && (%CardMode <= 1) {
          inc %CardMode
          if (%CardMode == 2) {
            %CardMode = 0
          }
          drawmouse
        }
        elseif ($inrect(%tmpx,%tmpy,65,65,570,570)) && (!$inrect(%tmpx,%tmpy,65,595,528,80)) {
          inc %CardMode
          if (%CardMode == 6) {
            %CardMode = 0
          }
          drawmouse
        }
      }
      elseif ($hget(GrabbedFlagHT,%CurrentPlayer)) {
        if ($hget(GrabbedTypeHT,%CurrentPlayer) == 2) {
          performaction %CurrentPlayer 7 $rand(1,5) $rand(2,5)
        }
        else {
          performaction %CurrentPlayer 4 1 $hget(GrabbedIDHT,%CurrentPlayer)
        }
      }
    }
  }
  uclick: {
    var %tmpx = $mouse.x, %tmpy = $mouse.y, %tmpselect, %tmphand, %tmp0, %tmp1
    if (%GameMode == 1) {
    }
    elseif (%GameMode == 2) {
      if (%CardMode == 4) && (%Peaked != 0) {
        %Peaked = 0
        drawmouse
      }
      if ($hget(GrabbedFlagHT,%CurrentPlayer)) || (%CuedGrab) {
        if (!%Server) {
          if (%ActionDropCueFlag) && (!%CuedGrab) {
            return
          }
        }
        if (%CuedGrab) {
          if ($hget(ActionCueHT,3) == 1) {
            %tmp0 = 1
          }
          elseif ($hget(ActionCueHT,3) == 2) {
            %tmp0 = 2
            %tmp1 = $hget(ActionCueHT,4)
          }
          elseif ($hget(ActionCueHT,3) == 3) {
            %tmp0 = 1
          }
          else {
            %tmp0 = 1
          }
        }
        else {
          %tmp0 = $hget(GrabbedTypeHT,%CurrentPlayer)
          %tmp1 = $hget(GrabbedIDHT,%CurrentPlayer)
        }
        if ($inrect(%tmpx,%tmpy,65,595,528,80)) {
          if (%CurrentPlayer == 1) {
            %tmphand = %HandPlayer1
          }
          elseif (%CurrentPlayer == 2) {
            %tmphand = %HandPlayer2
          }
          elseif (%CurrentPlayer == 3) {
            %tmphand = %HandPlayer3
          }
          else {
            %tmphand = %HandPlayer4
          }
          if ($numtok(%tmphand,46) < 40) {
            %tmpselect = $int($calc(((%tmpx - 65) / 12) + 1))
            if ($numtok(%tmphand,46) <= %tmpselect) && ($numtok(%tmphand,46) > 0) {
              if (%tmpx < $calc(($numtok(%tmphand,46) * 12) + 65 + 48)) {
                %tmpselect = $numtok(%tmphand,46)
              }
            }
            if (%tmp0 == 1) {
              if (%tmpselect <= $numtok(%tmphand,46)) {
                performaction %CurrentPlayer 2 4 %tmpselect
              }
              else {
                performaction %CurrentPlayer 2 4 $calc($numtok(%tmphand,46) + 1)
              }
            }
            elseif (%tmp0 == 2) {
              if ($calc(40 - $numtok(%tmphand,46)) >= $calc($hget(StackSizeHT,%tmp1) + 1)) {
                if (%tmpselect <= $numtok(%tmphand,46)) {
                  performaction %CurrentPlayer 2 4 %tmpselect
                }
                else {
                  performaction %CurrentPlayer 2 4 $calc($numtok(%tmphand,46) + 1)
                }
              }
              else {
                performaction %CurrentPlayer 13
              }
            }
          }
          else {
            performaction %CurrentPlayer 13
          }
        }
        elseif ($inrect(%tmpx,%tmpy,65,65,570,570)) && (!$inrect(%tmpx,%tmpy,65,595,528,80)) {
          %tmpselect = $int($rgb($getdot(@DetectCard,%tmpx,%tmpy)))
          if (%tmpselect == 0) || (%CardMode == 0) {
            performaction %CurrentPlayer 2 1 %tmpx %tmpy
          }
          elseif ($hget(CardStackHT,%tmpselect) == 0) {
            if ($hget(CardPossessionHT,%tmpselect) == 0) {
              performaction %CurrentPlayer 2 2 %tmpselect
            }
            else {
              performaction %CurrentPlayer 13
            }
          }
          else {
            if ($hget(CardPossessionHT,%tmpselect) == 0) {
              performaction %CurrentPlayer 2 3 $hget(CardStackHT,%tmpselect)
            }
            else {
              performaction %CurrentPlayer 13
            }
          }
        }
      }
    }
  }
}
